unit GUI;
// 

interface

uses OpenGL, Windows, eXgine, npUtils, GlobalConst, Map, Hero, Items;

const maxLine        = 5;             //-    
      ItmUse         = '';
      ItmDrop        = '';
      ItmInfo        = '';
      InvMaxLine     = 10;            //-   
      LineStartX     = 530;           //  X   
      LineStartY     = 416;           //  Y   
      InvW           = 250;           // 
      InvH           = 160;           // 
      LineH          = 16;            //   
      BtnTrap        = 4;             //  
      BtnPortal      = 5;             //   
      BtnRangeAttack = 8;             //  
      BtnRangeLeft   = 7;             //   
      BtnRangeTop    = 6;             //   
      BtnRangeRigth  = 9;             //   
      BtnRangeDown   = 10;            //   
      BtnGameSave    = 1;             //  
      BtnGameLoad    = 2;             //  
      BtnGAmeExit    = 3;             // 
      BtnMaxGame     = 10;
      ImageW         = 32;            // 
      ImageH         = 32;            // 

//------------------------------------------------------------------------
type TGlButton = class
       bRect:      TGLRect;  // 
       bCaption:   String;   //
       bStatus:    boolean;  //(    )
       bProc:      procedure;//   
       bAlfa:      integer;  //
       bEnable:    boolean;  //
       TextColor:  integer;  // 
       constructor Create(x,y,w,h,a,txtColor: integer; text: string);
       procedure   Process;
       procedure   Click;
       procedure   Draw;
       destructor  Destroy; override;
     end;

//-------------------------------------------------------------------
type TGLImage = class
       Rect:      TGLRect;  // 
       Status:    boolean;  //(    )
       Proc:      procedure;//   
       Alfa:      integer;  //
       active:    boolean;  // 
       texture:   cardinal; //
       Info:      string;   // 
       constructor Create(x,y,w,h,a: integer; texImage: cardinal; txtInfo: string);
       procedure Process;
       procedure Click;
       procedure Draw(angle: integer);
       procedure SetActive(activeFlag: boolean);
       destructor Destroy; override;
     end;

//------------------------- --------------------------------------
type TInventory = record
       Rect:             TGLRect;// 
       Caption:          string; //
       ActiveLine:       integer;// 
       NumLineStartDraw: integer;//      
       DrawAction:       boolean;//  
       ActionSelect:     integer;//   
       DrawInfo:         boolean;//   
       InfoText:         string; //  
     end;

var texButton:          cardinal;//   
    BtnAr:              Array[1..3] of TGlButton;
    OutTextArray:       Array[1..maxLine] of string;
    BtnGameArray:       Array[1..BtnMaxGame] of TGLImage;
    Inv:                TInventory;
    flagInvBtn:         integer;
    texBtnTrap:         cardinal;//   
    texBtnPortal:       cardinal;//    
    texBtnShot:         cardinal;//   
    texBtnVectorShot:   cardinal;//    
    texBtnSave:         cardinal;//   
    texBtnLoad:         cardinal;//   
    texBtnExit:         cardinal;//  
    texInvBtn:          cardinal;//    
    texMenuFon:         cardinal;//   
    textTextFon:        cardinal;//    

procedure GUIInit;   // 
procedure GUIDraw;   // 
procedure GUIProcess;//  
procedure GUIFree;   //  

procedure btnProcStart;// 
procedure btnProcLoad; // 
procedure btnProcExit; //

procedure OutTextFree;            //  
procedure OutTextAdd(txt: string);//  
procedure OutTextDraw;            //  

procedure InvDraw;                                   // 
procedure InvInit(x, y, w, h: integer; text: string);// 
procedure InvProcess;                                // 

procedure BtnGameInit;   // 
procedure BtnGameDraw;   // 
procedure BtnGameProcess;//  
procedure BtnGameFree;   //  


implementation

uses main;

//------------------------------------------------------------------------------
procedure GUIInit;
begin
  texButton:= tex.Load('data/button.jpg',false,false);
  BtnAr[btnStart]:= TGlButton.Create(336,250,128,32,255,COLOR_WHITE,' ');
  BtnAr[btnLoad]:= TGlButton.Create(336,314,128,32,255,COLOR_WHITE,'');
  BtnAr[btnExit]:= TGlButton.Create(336,378,128,32,255,COLOR_WHITE,'');
  BtnAr[btnStart].bProc:= btnProcStart;
  BtnAr[btnLoad].bProc:= btnProcLoad;
  BtnAr[btnExit].bProc:= btnProcExit;
end;

//------------------------------------------------------------------------------
procedure GUIDraw;
var i: integer;
begin
  for i:= 1 to maxBtnMenu do
    BtnAr[i].Draw;
end;

//------------------------------------------------------------------------------
procedure GUIProcess;
var i: integer;
begin
  for i:= 1 to maxBtnMenu do
    BtnAr[i].Process;
end;

//------------------------------------------------------------------------------
procedure GUIFree;
var i: integer;
begin
  for i:= 1 to maxBtnMenu do
    BtnAr[i].Free;
end;


{ TGlButton }

//------------------------------------------------------------------------------
procedure TGlButton.Click;
begin
  if (inp.Down(M_BTN_1)) and (MouseDown = false) then
  begin
    if @bProc <> nil then
    begin
      bProc;
      MouseDown:= true;
    end;
  end;
end;

//------------------------------------------------------------------------------
constructor TGlButton.Create(x, y, w, h, a,txtColor: integer; text: string);
begin
  bRect:=GLRect(x,y,w,h);
  bCaption:= text;
  bStatus:= False;
  bAlfa:= a;
  bEnable:= True;
  bProc:= nil;
  TextColor:= txtColor;
end;

//------------------------------------------------------------------------------
destructor TGlButton.Destroy;
begin
  inherited;
end;

//------------------------------------------------------------------------------
procedure TGlButton.Draw;
var w,h: integer;
begin
  if bEnable = false then exit;

  w:= ogl.TextLen(0,pchar(bCaption));
  h:= 15;
  if bStatus = false then
  begin
    DrawSprite2D_simple(texButton,bRect.x,bRect.y,bRect.w,bRect.h);
    DrawText2D(0, bRect.x + bRect.w div 2 - w div 2,
               bRect.y + bRect.h div 2 - h div 2,bCaption,textColor,bAlfa);
  end
  else
  begin
    DrawSprite2D_simple(texButton,bRect.x,bRect.y,bRect.w,bRect.h,
                        150,$DDDDDD,true);
    DrawText2D(0,bRect.x + bRect.w div 2 - w div 2,
               bRect.y + bRect.h div 2 - h div 2,bCaption,textColor,150);
  end;
end;

//------------------------------------------------------------------------------
procedure TGlButton.Process;
begin
  if bEnable = false then exit;

  if PointInRect(CursorX,CursorY,bRect) = true then
  begin
    bStatus:= true;
    Click;
  end
  else
    bStatus:= false;
end;

//------------------------------------------------------------------------------
procedure btnProcStart;
begin
  BloodInit(0,0,false);
  Randomize;
  AllClear;
  CreateHero(1,1);
  MapLevelCreate(1);
  OutTextAdd(' !');
  ActionFlag:= 1;
end;

//------------------------------------------------------------------------------
procedure btnProcLoad;
begin
  Load;
end;

//------------------------------------------------------------------------------
procedure btnProcExit;
begin
  eX.Quit;
end;

//------------------------------------------------------------------------------
procedure MenuEnable;
var i: integer;
begin
  for i:= 1 to maxBtnMenu do
    BtnAr[i].bEnable:= true;
end;

//------------------------------------------------------------------------------
procedure MenuDisable;
var i: integer;
begin
  for i:= 1 to maxBtnMenu do
    BtnAr[i].bEnable:= false;
end;

//------------------------------------------------------------------------------
procedure OutTextFree;
var numLine: integer;
begin
  for numLine:= 1 to maxLine do
    OutTextArray[numLine]:= '';
end;

//------------------------------------------------------------------------------
procedure OutTextAdd(txt: string);
var numLine: integer;
begin
  for numLine:= 1 to maxLine do
  begin
    if OutTextArray[numLine] = '' then
    begin
      OutTextArray[numLine]:= txt;
      exit;
    end;
  end;
  for numLine:= 1 to maxLine-1 do
  begin
    OutTextArray[numLine]:=OutTextArray[numLine+1];
  end;
  OutTextArray[maxLine]:= txt;
end;

//------------------------------------------------------------------------------
procedure OutTextDraw;
var numLine: integer;
    const fonTxtX = 32;
          fonTxtY = 516;
          fonTxtW = ViewScreen*TileW;
          fonTxtH = 80;
begin
  glLineWidth(2);
  glColor3f(0.8,0.8,0.8);
  glBegin(GL_LINES);
    glVertex2f(fonTxtX,fonTxtY);
    glVertex2f(fonTxtX+fonTxtW,fonTxtY);
    glVertex2f(fonTxtX+fonTxtW,fonTxtY);
    glVertex2f(fonTxtX+fonTxtW,fonTxtY+fonTxtH);
    glVertex2f(fonTxtX+fonTxtW,fonTxtY+fonTxtH);
    glVertex2f(fonTxtX,fonTxtY+fonTxtH);
    glVertex2f(fonTxtX,fonTxtY+fonTxtH);
    glVertex2f(fonTxtX,fonTxtY);
  glEnd;
  DrawSprite2D_simple(textTextFon,fonTxtX,fonTxtY,fonTxtW,fonTxtH);
  for numLine:= 1 to maxLine do
    DrawText2D(0,88,500+numLine*16,OutTextArray[numLine],COLOR_WHITE);
end;

{ TInventory }
//------------------------------------------------------------------------------
procedure InvInit(x, y, w, h: integer; text: string);
begin
  Inv.Rect:= GLRect(x,y,w,h);
  Inv.Caption:= text;
  Inv.NumLineStartDraw:= 0;
  Inv.ActiveLine:= 0;
  Inv.DrawAction:= false;
  Inv.ActionSelect:= 0;
  Inv.DrawInfo:= false;
  Inv.InfoText:= '';
end;

//------------------------------------------------------------------------------
procedure InvDraw;
var numLine: integer;
    itmName: string;
begin
  glColor3f(0.0,0.0,0.0);
  DrawQuads(Inv.Rect.x,Inv.Rect.y,Inv.Rect.w,Inv.rect.h);
  DrawText2D(0,Inv.Rect.x,Inv.Rect.y-16,Inv.Caption);
  if Inv.ActiveLine >= 0 then
  begin
    glColor3f(0.3,0.4,0.5);
    DrawQuads(LineStartX,LineStartY+Inv.ActiveLine*LineH,Inv.Rect.w,LineH);
  end;

  for numLine:= 0 to InvMaxLine-1 do
  begin
    if numLine <= Length(Player.Items)-1 then
    begin
      itmName:= '';
      if Player.Items[Inv.NumLineStartDraw+numLine].HeroUse = true then
        itmName:= '*';
      itmName:= itmName+ItemName(Player.Items[Inv.NumLineStartDraw+numLine],True);
      DrawText2D(0,LineStartX,LineStartY+numLine*LineH,itmName);
    end;
  end;

  glLineWidth(2);
  glColor3f(0.8,0.8,0.8);
  glBegin(GL_LINES);
    glVertex2f(Inv.Rect.x,Inv.Rect.y);
    glVertex2f(Inv.Rect.x+Inv.Rect.w,Inv.Rect.y);
    glVertex2f(Inv.Rect.x+Inv.Rect.w,Inv.Rect.y);
    glVertex2f(Inv.Rect.x+Inv.Rect.w,Inv.Rect.y+Inv.rect.h);
    glVertex2f(Inv.Rect.x+Inv.Rect.w,Inv.Rect.y+Inv.rect.h);
    glVertex2f(Inv.Rect.x,Inv.Rect.y+Inv.rect.h);
    glVertex2f(Inv.Rect.x,Inv.Rect.y+Inv.rect.h);
    glVertex2f(Inv.Rect.x,Inv.Rect.y);
  glend;
  if flagInvBtn = 1 then
    DrawSprite2D_simple(texInvBtn,760,416,20,20,230,COLOR_AQUA,True)
  else
    DrawSprite2D_simple(texInvBtn,760,416,20,20);
  if flagInvBtn = 2 then
    DrawSprite2D(texInvBtn,760,556,20,20,180,230,COLOR_AQUA,True)
  else
    DrawSprite2D(texInvBtn,760,556,20,20,180);
  //  
  if Inv.DrawAction then
  begin
    if Inv.ActionSelect = 1 then
      glColor3f(0.5,0.5,0.5)
    else
      glColor3f(0.5,0.4,0.3);
    DrawQuads(LineStartX+TileW,LineStartY+Inv.ActiveLine*LineH-LineH,Inv.Rect.w div 2,LineH);
    DrawText2D(0,LineStartX+TileW,LineStartY+Inv.ActiveLine*LineH-LineH,ItmUse,COLOR_WHITE);
    if Inv.ActionSelect = 2 then
      glColor3f(0.5,0.5,0.5)
    else
      glColor3f(0.5,0.4,0.3);
    DrawQuads(LineStartX+TileW,LineStartY+Inv.ActiveLine*LineH,Inv.Rect.w div 2,LineH);
    DrawText2D(0,LineStartX+TileW,LineStartY+Inv.ActiveLine*LineH,ItmInfo,COLOR_WHITE);
    if Inv.ActionSelect = 3 then
      glColor3f(0.5,0.5,0.5)
    else
      glColor3f(0.5,0.4,0.3);
    DrawQuads(LineStartX+TileW,LineStartY+Inv.ActiveLine*LineH+LineH,Inv.Rect.w div 2,LineH);
    DrawText2D(0,LineStartX+TileW,LineStartY+Inv.ActiveLine*LineH+LineH,ItmDrop,COLOR_WHITE);
  end;
  //  
  if Inv.DrawInfo then
  begin
    glColor3f(0.5,0.4,0.3);
    DrawQuads(LineStartX-64,LineStartY+Inv.ActiveLine*LineH,Inv.Rect.w+64,LineH);
    DrawText2D(0,LineStartX-64,LineStartY+Inv.ActiveLine*LineH,
              Inv.InfoText,COLOR_WHITE);
  end;
end;

//------------------------------------------------------------------------------
procedure InvProcess;
begin
  flagInvBtn:= 0;
  //  
  if Inv.DrawInfo then
  begin
    if (inp.Down(M_BTN_1) = true) and (MouseDown = false) then
    begin
      Inv.DrawInfo:= false;
      Inv.InfoText:= '';
    end;
    Exit;
  end;
  // 
  if Inv.DrawAction then
  begin
    Inv.ActionSelect:= 0;
    if PointInRect(CursorX,CursorY,
    GLRect(LineStartX+TileW,LineStartY+Inv.ActiveLine*LineH-LineH,Inv.Rect.w div 2,LineH)) then
    begin
      Inv.ActionSelect:= 1;
      if (inp.Down(M_BTN_1) = true) and (MouseDown = false) then
      begin
        ItemUse(Inv.NumLineStartDraw+Inv.ActiveLine);
        MouseDown:= true;
      end;
    end;
    if PointInRect(CursorX,CursorY,
    GLRect(LineStartX+TileW,LineStartY+Inv.ActiveLine*LineH,Inv.Rect.w div 2,LineH)) then
    begin
      Inv.ActionSelect:= 2;
      if (inp.Down(M_BTN_1) = true) and (MouseDown = false) then
      begin
        ItemInfo(Inv.NumLineStartDraw+Inv.ActiveLine);
        MouseDown:= true;
      end;
    end;
    if PointInRect(CursorX,CursorY,
    GLRect(LineStartX+TileW,LineStartY+Inv.ActiveLine*LineH+LineH,Inv.Rect.w div 2,LineH)) then
    begin
      Inv.ActionSelect:= 3;
      if (inp.Down(M_BTN_1) = true) and (MouseDown = false) then
      begin
        ItemDrop(Inv.NumLineStartDraw+Inv.ActiveLine);
        MouseDown:= true;
      end;
    end;
    if inp.Down(M_BTN_1) then
      Inv.DrawAction:= false;
    Exit;
  end;
  //        10 
  if PointInRect(CursorX,CursorY,GLRect(760,416,20,20)) = true then
  begin
    flagInvBtn:= 1;
    if (inv.NumLineStartDraw > 0) and
       (inp.Down(M_BTN_1) = True) and (MouseDown = false) then
    begin
      inv.NumLineStartDraw:= inv.NumLineStartDraw-1;
      MouseDown:= true;
    end;
    exit;
  end;
  if PointInRect(CursorX,CursorY,GLRect(760,556,20,20)) = true then
  begin
    flagInvBtn:= 2;
    if (inv.NumLineStartDraw+10 < Length(Player.Items)) and
       (inp.Down(M_BTN_1) = True) and (MouseDown = false) then
    begin
      inv.NumLineStartDraw:= inv.NumLineStartDraw+1;
      MouseDown:= true;
    end;
    exit;
  end;
  // 
  if (PointInRect(CursorX,CursorY,Inv.Rect) = true) and
     (length(Player.Items) > 0) and
     (((CursorY-LineStartY) div 16) <= Length(Player.Items)-1) then
  begin
    if (inp.Down(M_BTN_1) = True) and (MouseDown = false) then
    begin
      inv.ActiveLine:= ((CursorY-LineStartY) div 16);
      MouseDown:= true;
    end;
    if (inp.Down(M_BTN_2) = True) and (MouseRigthDown = false) then
    begin
      inv.ActiveLine:= ((CursorY-LineStartY) div 16);
      MouseRigthDown:= true;
      Inv.DrawAction:= true;
    end;
  end;
end;

{ TGLImage }
//------------------------------------------------------------------------------
procedure TGLImage.Click;
begin
  if (inp.Down(M_BTN_1)) and (MouseDown = false) then
  begin
    if @Proc <> nil then
    begin
      Proc;
      MouseDown:= true;
    end;
  end;
end;

//------------------------------------------------------------------------------
constructor TGLImage.Create(x, y, w, h, a: integer; texImage: cardinal; txtInfo: string);
begin
  Rect:=GLRect(x,y,w,h);
  Status:= False;
  Alfa:= a;
  Proc:= nil;
  texture:= texImage;
  active:= false;
  Info:= txtInfo;
end;

//------------------------------------------------------------------------------
destructor TGLImage.Destroy;
begin
  inherited;
end;

//------------------------------------------------------------------------------
procedure TGLImage.Draw(angle: integer);
begin
  if Status = false then
  begin
    DrawSprite2D(texture,Rect.x,Rect.y,Rect.w,Rect.h,angle);
  end
  else
  begin
    DrawSprite2D(texture,Rect.x,Rect.y,Rect.w,Rect.h,angle,150,$DDDDDD,true);
    glColor3f(0.5,0.5,0.5);
    DrawQuads(Rect.x-(ogl.TextLen(0,PChar(Info)) div 2),Rect.y-16,
              ogl.TextLen(0,PChar(Info)),16);
    DrawText2D(0,Rect.x-(ogl.TextLen(0,PChar(Info)) div 2),Rect.y-16,Info);
  end;
  if active then
  begin
    glLineWidth(2);
    glColor3f(0.8,0.5,0.5);
    glBegin(GL_LINES);
      glVertex2f(Rect.x,Rect.y);
      glVertex2f(Rect.x+Rect.w,Rect.y);
      glVertex2f(Rect.x+Rect.w,Rect.y);
      glVertex2f(Rect.x+Rect.w,Rect.y+Rect.h);
      glVertex2f(Rect.x+Rect.w,Rect.y+Rect.h);
      glVertex2f(Rect.x,Rect.y+Rect.h);
      glVertex2f(Rect.x,Rect.y+Rect.h);
      glVertex2f(Rect.x,Rect.y);
    glend;
  end;
end;

//------------------------------------------------------------------------------
procedure TGLImage.Process;
begin
  if PointInRect(CursorX,CursorY,Rect) = true then
  begin
    Status:= true;
    Click;
  end
  else
    Status:= false;
end;

//------------------------------------------------------------------------------
procedure TGLImage.SetActive(activeFlag: boolean);
begin
  active:= activeFlag;
end;

//------------------------- ----------------------------------------
procedure ShotLeft;
begin
  ShotStart(270);
end;

//------------------------- ---------------------------------------
procedure ShotRight;
begin
  ShotStart(90);
end;

//------------------------- ----------------------------------------
procedure ShotUp;
begin
  ShotStart(0);
end;

//------------------------- -----------------------------------------
procedure ShotDown;
begin
  ShotStart(180);
end;

//------------------------------------------------------------------------------
procedure BtnGameInit;
begin
  texBtnTrap:= tex.Load('data/btntrap.tga',false,false);
  texBtnPortal:= tex.Load('data/btnportal.tga',false,false);
  texBtnShot:= tex.Load('data/btnshot.tga',false,false);
  texBtnVectorShot:= tex.Load('data/btnvectorshot.tga',false,false);
  texInvBtn:= tex.Load('data/invbtn.bmp',false,false);
  texBtnLoad:= tex.Load('data/loadbtn.tga',false,false);
  texBtnSave:= tex.Load('data/savebtn.tga',false,false);
  texBtnExit:= tex.Load('data/exitbtn.tga',false,false);
  BtnGameArray[BtnTrap]:= TGLImage.Create(706,262,ImageW,ImageH,255,
                          texBtnTrap,' ');
  BtnGameArray[BtnPortal]:= TGLImage.Create(741,262,ImageW,ImageH,255,
                          texBtnPortal,'  ');
  BtnGameArray[BtnRangeAttack]:= TGLImage.Create(724,330,ImageW,ImageH,255,
                          texBtnShot,' ');
  BtnGameArray[BtnRangeLeft]:= TGLImage.Create(690,330,ImageW,ImageH,255,
                          texBtnVectorShot,' ');
  BtnGameArray[BtnRangeTop]:= TGLImage.Create(724,296,ImageW,ImageH,255,
                          texBtnVectorShot,' ');
  BtnGameArray[BtnRangeRigth]:= TGLImage.Create(758,330,ImageW,ImageH,255,
                          texBtnVectorShot,' ');
  BtnGameArray[BtnRangeDown]:= TGLImage.Create(724,364,ImageW,ImageH,255,
                          texBtnVectorShot,' ');
  BtnGameArray[BtnGameSave]:= TGLImage.Create(690,228,ImageW,ImageH,255,
                          texBtnSave,' ');
  BtnGameArray[BtnGameLoad]:= TGLImage.Create(724,228,ImageW,ImageH,255,
                          texBtnLoad,' ');
  BtnGameArray[BtnGameExit]:= TGLImage.Create(758,228,ImageW,ImageH,255,
                          texBtnExit,'');
  BtnGameArray[BtnTrap].Proc:= SearchTrap;
  BtnGameArray[BtnPortal].Proc:= NextMap;
  BtnGameArray[BtnRangeAttack].Proc:= ChooseShot;
  BtnGameArray[BtnRangeLeft].Proc:= ShotLeft;
  BtnGameArray[BtnRangeTop].Proc:= ShotUp;
  BtnGameArray[BtnRangeRigth].Proc:= ShotRight;
  BtnGameArray[BtnRangeDown].Proc:= ShotDown;
  BtnGameArray[BtnGameExit].Proc:= GameEnd;
  BtnGameArray[BtnGameLoad].Proc:= Load;
  BtnGameArray[BtnGameSave].Proc:= Save;
end;

//------------------------------------------------------------------------------
procedure BtnGameDraw;
var numBtn: integer;
    const fonBtnX = 686;
          fonBtnY = 224;
          fonBtnW = 108;
          fonBtnH = 178;
begin
  glColor3f(0.0,0.0,0.0);
  DrawQuads(fonBtnX,fonBtnY,fonBtnW,fonBtnH);
  glLineWidth(2);
  glColor3f(0.8,0.8,0.8);
  glBegin(GL_LINES);
    glVertex2f(fonBtnX,fonBtnY);
    glVertex2f(fonBtnX+fonBtnW,fonBtnY);
    glVertex2f(fonBtnX+fonBtnW,fonBtnY);
    glVertex2f(fonBtnX+fonBtnW,fonBtnY+fonBtnH);
    glVertex2f(fonBtnX+fonBtnW,fonBtnY+fonBtnH);
    glVertex2f(fonBtnX,fonBtnY+fonBtnH);
    glVertex2f(fonBtnX,fonBtnY+fonBtnH);
    glVertex2f(fonBtnX,fonBtnY);
  glend;
  DrawSprite2D_simple(texMenuFon,fonBtnX,fonBtnY,fonBtnW,fonBtnH);
  for numBtn:= 1 to btnMaxGame do
  begin
    case numBtn of
      BtnRangeLeft:BtnGameArray[numBtn].Draw(270);
      BtnRangeRigth:BtnGameArray[numBtn].Draw(90);
      BtnRangeDown:BtnGameArray[numBtn].Draw(180);
    else
      BtnGameArray[numBtn].Draw(0);
    end;
  end;
end;

//------------------------------------------------------------------------------
procedure BtnGameProcess;
var numBtn: integer;
begin
  for numBtn:= 1 to btnMaxGame do
    BtnGameArray[numBtn].Process;
end;

//------------------------------------------------------------------------------
procedure BtnGameFree;
var numBtn: integer;
begin
  for numBtn:= 1 to btnMaxGame do
    BtnGameArray[numBtn].Free;
  tex.free(texBtnVectorShot);
  tex.free(texBtnShot);
  tex.free(texBtnPortal);
  tex.free(texBtnTrap);
end;

end.
