unit Hero;
// 

interface

uses npUtils, windows, eXgine, GlobalConst, Items;

const MaxChars        = 2;  //.-  
      chrSTR          = 1;  //
      chrCON          = 2;  //
      MaxHeroLevel    = 9;  //. 
      SmallFatigue    = 150;// 
      HardFatigue     = 200;// 
      DeadFatigue     = 300;// ,  2/3
      // ,      
      ExpLevel_Table: array[0..MaxHeroLevel] of Integer =
      (20, 50, 80, 100, 150, 200, 250, 350, 400, 500);
      //-     
      MaxLengthShot   = 5;  //  ( )
      ShotSpeed       = 1.5;// 
      BloodSpeedTime  = 0.1;//  
      BloodMaxTime    = 1;  //  

//---------------------------(/ )-----------------------
type TShot = record
       x,y:            real;    //
       deltaX, deltaY: real;    //  
       targetX:        integer; // X 
       targetY:        integer; // Y 
       targetMonster:  integer; //     (-1   )
       angle:          integer; //(0,90,180,270)
       itemNum:        integer; //    
       texArrow:       cardinal;// 
       texFireBall:    cardinal;//  
     end;

//-------------------------------------------------------------------------
type TBlood = record
       x,y:    integer;
       active: boolean;
       time:   real;
     end;

//-------------------------------------------------------------------------
type THero=record
  FCoordX, FCoordY: integer;        //   X,Y   
  HP, MaxHP:        integer;        //   
  Exp, MaxExp:      integer;        //      
  Level:            integer;        // 
  VisLong:          integer;        // 
  armor:            byte;           //
  DopArmor:         byte;           //.
  DopTimeArmor:     byte;           //  .
  Gold:             integer;        //- 
  Fatigue:          integer;        //
  Name:             string[10];     //
  Chars:            array[1..MaxChars] of Integer;// 
  DopChars:         array[1..MaxChars] of Integer;// .
  DopTimeChars:     array[1..MaxChars] of Integer;//   .
  Items:            array of TItems;//  
  Poison:           integer;        //
end;

var
  Player:       THero;
  Shot:         TShot;
  Blood:        TBlood;
  //InitHeroName: string;
  flagShot:     boolean;//
  shotType:     integer;//0- 1- 
  texPlayer:    Cardinal;// 
  

Procedure CreateHero(Ax,AY:integer);            // 
procedure HeroSetCoord(x,y: integer);           //   
procedure DrawHero;                             // 
procedure ProcessHero;                          //
procedure MoveHero(deltaX, deltaY: integer);    // 
procedure SearchTrap;                           // 
procedure HeroIncHP(deltaHP: integer);          //  
procedure HeroIncFatigue(deltaFatigue: integer);//  
function  HeroCoeffFatigue: integer;            //  
procedure HeroDead;                             // 
procedure TakeItem(itm: TItems);                // 
procedure HeroAction;                           //   
function  HeroNearAttack(x,y: integer): boolean;//  
function  RollDice( d1, d2: Integer ): Integer; // 
function  HeroNameFatigue: string;              //  
procedure NextMap;                              //  
procedure HeroLevelUp;                          //  
procedure ChooseShot;                           //  
procedure MoveMouse;                            //
procedure ShotStart(angle: integer);            //  
procedure ShotProcess;                          // 
procedure ShotDraw;                             // 
procedure ShotEnd;                              //  
procedure BloodInit(x,y: integer; active: boolean);
procedure BloodProcess;
procedure BloodDraw;
procedure DeadProcess;
procedure GameWin;                              //
procedure WinProcess;
procedure VisibleTile;                          // 


implementation

uses Main, Map, Monsters, SysUtils, GUI, Math, InitRes;

//-------------------- --------------------------------------------
procedure CreateHero(Ax,AY:integer);
begin
  Player.Level := 0;
  Player.Name := 'Rogue';
  Player.FCoordX:=Ax;
  Player.FCoordY:=Ay;
  Player.Chars[chrStr]:= 1;
  Player.Chars[chrCon]:= 1;
  Player.MaxHP := 10;
  Player.fatigue:=0;
  Player.Exp := 0;
  Player.MaxExp := ExpLevel_Table[Player.Level];
  Player.VisLong := 3;
  Player.armor:= 0;
  Player.Gold:= 0;
  Player.Poison:= 0;
  SetLength(Player.Items,0);
  ItemsCreate(itmAxe,0,0,lvlSpec0,SpecNone,false,1);
  ItemsCreate(itmHealPotion,0,0,lvlSpec0,SpecNone,false,5);
  ItemsCreate(itmFood,0,0,lvlSpec0,SpecNone,false,7);
  ItemsCreate(itmRingClear,0,0,lvlSpec0,SpecNone,false,1);
  ItemsCreate(itmArmorPotion,0,0,lvlSpec0,SpecNone,false,2);
  Player.Items[0].HeroUse:= true;
  Player.DopArmor:= 0;
  Player.DopTimeArmor:= 0;
  Player.DopChars[chrStr]:= 0;
  Player.DopTimeChars[chrStr]:= 0;
  Player.DopChars[chrCon]:= 0;
  Player.DopTimeChars[chrCon]:= 0;
  flagShot:= false;
  OpenIniHero;
  Player.HP := Player.MaxHP;
end;

//------------------------------------------------------------------------------
procedure HeroSetCoord(x,y: integer);
begin
  Player.FCoordX:=x;
  Player.FCoordY:=y;
  VisibleTile;
end;

//------------------------------------------------------------------------------
function  HeroGetArmor: integer;
var itmNum, armorItem: integer;
begin
  armorItem:= 0;
  for itmNum:= 0 to length(Player.Items)-1 do
  begin
    if (Player.Items[itmNum].ItemType = ItemArmor) and
       (Player.Items[itmNum].HeroUse = true) then
      armorItem:= Player.Items[itmNum].Ints[itmIntsArmor];
  end;
  HeroGetArmor:= Player.armor+Player.DopArmor+armorItem;
end;

//-------------------- -------------------------------------------
procedure DrawHero;
begin
  DrawSprite2D_simple(texPlayer,startDrawX+(Player.FCoordX-CurMap.MapX)*TileW,
                      startDrawY+(Player.FCoordY-CurMap.MapY)*tileH,TileW,TileH);
  //ogl.TextOut(0, 312, 8, PChar('HeroX: ' + IntToStr(Player.FCoordX)));
  //ogl.TextOut(0, 402, 8, PChar('HeroY: ' + IntToStr(Player.FCoordY)));
  DrawText2D(0, 530, 228, Player.Name+('(.')+inttostr(Player.Level)+')');
  ogl.TextOut(0, 530, 244, PChar(': ' + IntToStr(Player.Chars[chrSTR]+
                                                     Player.DopChars[chrSTR])));
  ogl.TextOut(0, 530, 260, PChar(': ' + IntToStr(Player.Chars[chrCON]+
                                                             Player.DopChars[chrCON])));
  ogl.TextOut(0, 530, 276, PChar(': ' + IntToStr(Player.HP)));
  ogl.TextOut(0, 530, 292, PChar(': ' + IntToStr(HeroGetArmor)));
  ogl.TextOut(0, 530, 324, PChar(': ' + IntToStr(Player.Exp)));
  ogl.TextOut(0, 530, 340, PChar(': ' + IntToStr(Player.Gold)));
  ogl.TextOut(0, 530, 356, PChar(': ' + inttostr(Player.Fatigue)));
  ogl.TextOut(0, 530, 372, PChar('(' + HeroNameFatigue +')'));
  if Player.Poison > 0 then
    DrawText2D(0,530,308, PChar(''),COLOR_RED);
end;

//--------------------  ----------------------------------
procedure ProcessHero;
begin
  if flagShot = false then
  begin
    // 
    MoveMouse;
    InvProcess;
    PortalProcess;
    BtnGameProcess;
    if InKey(Key_Left) then
      MoveHero(-1,0);
    if InKey(Key_Right) then
      MoveHero(1,0);
    if InKey(Key_Up) then
      MoveHero(0,-1);
    if InKey(Key_Down) then
      MoveHero(0,1);
    if Inp.Down(Key_Left) and inp.Down(Key_Shift) then
      MoveHero(-1,0);
    if Inp.Down(Key_Right) and inp.Down(Key_Shift) then
      MoveHero(1,0);
    if Inp.Down(Key_Up) and inp.Down(Key_Shift) then
      MoveHero(0,-1);
    if Inp.Down(Key_Down) and inp.Down(Key_Shift) then
      MoveHero(0,1);
    if InKey(Key_F) then
      SearchTrap;
  end
  else
  begin
    //
    BtnGameArray[BtnRangeAttack].Process;
    BtnGameArray[BtnRangeLeft].Process;
    BtnGameArray[BtnRangeTop].Process;
    BtnGameArray[BtnRangeRigth].Process;
    BtnGameArray[BtnRangeDown].Process;
    if InKey(Key_Left) then
      ShotStart(270);
    if InKey(Key_Right) then
      ShotStart(90);
    if InKey(Key_Up) then
      ShotStart(0);
    if InKey(Key_Down) then
      ShotStart(180);
  end;
end;

//-------------------- --------------------------------------------
procedure MoveHero(deltaX, deltaY: integer);
begin
  if (FreeTile(CurMap.MapCell[Player.FCoordX+deltaX,Player.FCoordY+deltaY].tile,
      flagAllFree) = true) then
  begin
    if HeroNearAttack(Player.FCoordX+deltaX,Player.FCoordY+deltaY) then
    begin
      // 
      HeroAction;
    end
    else
    begin
      //
      HeroSetCoord(Player.FCoordX+deltaX,Player.FCoordY+deltaY);
      HeroAction;
      if (Player.FCoordX - CurMap.MapX = ScrollScreen) or
         (Player.FCoordY - CurMap.MapY = ScrollScreen) or
         (abs(Player.FCoordX - (CurMap.MapX + viewScreen)) = ScrollScreen) or
         (abs(Player.FCoordY - (CurMap.MapY + viewScreen)) = ScrollScreen) then
        MapWriteCoord(CurMap.MapX+deltaX,CurMap.MapY+deltaY);
    end;
  end;
end;

//-------------------------- ---------------------------------------
procedure SearchTrap;
var heroX, heroY: integer;
    trapNum:      integer;
    findTrap:     boolean;
begin
  HeroIncFatigue(1);
  findTrap:= false;
  for heroX:= Player.FCoordX-1 to Player.FCoordX+1 do
    for heroY:= Player.FCoordY-1 to Player.FCoordY+1 do
    begin
      for trapNum:= 0 to length(TrapArray)-1 do
        if (TrapArray[trapNum].x = heroX) and
           (TrapArray[trapNum].y = heroY) then
           begin
             TrapArray[trapNum].Visible:= true;
             OutTextAdd(' .');
             findTrap:= true;
           end;
    end;
  if findTrap = false then
    OutTextAdd('  .');
  HeroAction;
end;

//------------------------------------------------------------------------------
procedure HeroIncHP(deltaHP: integer);
begin
  inc(Player.HP,deltaHP);
  if Player.HP > Player.MaxHP then
    Player.HP:= Player.MaxHP
  else if Player.HP <= 0 then
    HeroDead;
end;

//------------------------------------------------------------------------------
procedure HeroIncFatigue(deltaFatigue: integer);
begin
  inc(Player.Fatigue,deltaFatigue);
  if Player.Fatigue < 0 then
    Player.Fatigue:= 0
  else if Player.Fatigue > DeadFatigue then
  begin
    Player.Fatigue:= HardFatigue;
    Player.HP:= Player.HP div 3;
  end;
end;

//------------------------------------------------------------------------------
function  HeroNameFatigue: string;
var returnCoeff: string;
begin
  returnCoeff:= ' ';
  if Player.Fatigue > SmallFatigue then
    returnCoeff:= ' ';
  if Player.Fatigue > HardFatigue then
    returnCoeff:= ' ';
  HeroNameFatigue:= returnCoeff;
end;

//------------------------------------------------------------------------------
function  HeroCoeffFatigue: integer;
var returnCoeff: integer;
begin
  returnCoeff:= 0;
  if Player.Fatigue > SmallFatigue then
    returnCoeff:= 1;
  if Player.Fatigue > HardFatigue then
    returnCoeff:= 2;
  HeroCoeffFatigue:= returnCoeff;
end;

//------------------------------------------------------------------------------
procedure HeroDead;
begin
  if FlagDead = false then
  begin
    OutTextAdd(' .  Enter...');
    FlagDead:= true;
  end;
end;

//------------------------------------------------------------------------------
procedure TakeItem(itm: TItems);
var itmNum: integer;
begin
  if (Length(Player.Items) = 0) and (itm.ItemType <> ItemGold) then
  begin
    Inv.NumLineStartDraw:= 0;
    Inv.ActiveLine:= 0;
  end;
  if itm.ItemType = ItemGold then
    inc(Player.Gold,itm.Ints[itmIntsNum])
  else
  begin
    for itmNum:= 0 to Length(Player.Items)-1 do
    begin
      if (itm.ID = Player.Items[itmNum].ID) and
         (itm.Special = Player.Items[itmNum].Special) and
         (itm.LevelSpecial = Player.Items[itmNum].LevelSpecial) and
         (itm.ItemType <> ItemHandWeapon) and (itm.ItemType <> ItemArmor)
         and (itm.ItemType <> ItemRangeWeapon) then
      begin
        inc(Player.Items[itmNum].Ints[ItmIntsNum],itm.Ints[itmIntsNum]);
        exit;
      end;
    end;
    SetLength(Player.Items,length(Player.Items)+1);
    itmNum:= length(Player.Items)-1;
    Player.Items[itmNum]:= itm;
  end;
end;

//------------------------------------------------------------------------------
procedure HeroAction;
var trpNum:    integer;
    itmNum:    integer;
    trpDamage: integer;
    rndPoison: integer;
    dmgPoison: integer;
begin
  //      
  for itmNum:= 0 to Length(GameItems)-1 do
  begin
    if (Player.FCoordX = GameItems[itmNum].X) and
       (Player.FCoordY = GameItems[itmNum].Y) then
    begin
      //   
      TakeItem(GameItems[itmNum]);
      OutTextAdd('  '+ItemName(GameItems[itmNum],false));
      ItemsDelete(itmNum,True);
      break;
    end;
  end;
  //      
  for trpNum:= 0 to Length(TrapArray)-1 do
  begin
    if (Player.FCoordX = TrapArray[trpNum].x) and
       (Player.FCoordY = TrapArray[trpNum].y) then
    begin
      //       
      if TrapArray[trpNum].typeTrap = TrpPoisonDrotic then
      begin
        trpDamage:= round(Player.MaxHP*((Random(trpMaxDmg1-trpMinDmg)+trpMinDmg)/100));
        if trpDamage = 0 then trpDamage:= 1;
        OutTextAdd('!   '+inttostr(trpDamage)+'   ');
        PoisonHero;
        HeroIncHP(-trpDamage);
      end
      else
      begin
        trpDamage:= round(Player.MaxHP*((Random(trpMaxDmg2-trpMinDmg)+trpMinDmg)/100));
        if trpDamage = 0 then trpDamage:= 1;
        OutTextAdd('!   '+inttostr(trpDamage)+'   ');
        HeroIncHP(-trpDamage);
      end;
      TrapArray[trpNum].Visible:= true;
    end;
  end;
  //            
  if Player.Poison > 0 then
  begin
    rndPoison:= Random(2);
    if rndPoison = 0 then
    begin
      dmgPoison:= Random(poisonDmg)+1;
      OutTextAdd('    '+inttostr(dmgPoison));
      HeroIncHP(-dmgPoison);
    end;
    Player.Poison:= Player.Poison-1;
  end;
  //  .          1
  if Player.DopArmor > 0 then
  begin
    if Player.DopTimeArmor <= 0 then
      Player.DopArmor:= 0
    else
      Player.DopTimeArmor:= Player.DopTimeArmor-1;
  end;
  if Player.DopChars[chrStr] > 0 then
  begin
    if Player.DopTimeChars[chrStr] <= 0 then
      Player.DopChars[chrStr]:= 0
    else
      Player.DopTimeChars[chrStr]:= Player.DopTimeChars[chrStr]-1;
  end;
  if Player.DopChars[chrCon] > 0 then
  begin
    if Player.DopTimeChars[chrCon] <= 0 then
    begin
      Player.MaxHP:= Player.MaxHP-Player.DopChars[chrCon]*5;
      If Player.HP > Player.MaxHP then
        Player.HP:= Player.MaxHP;
      Player.DopChars[chrCon]:= 0;
    end
    else
      Player.DopTimeChars[chrCon]:= Player.DopTimeChars[chrCon]-1;
  end;
  //    
  HeroLevelUp;
  // 
  inc(GlobalTime);
  if GlobalTime mod 10 = 0 then
  begin
    // 15   
    HeroIncFatigue(1);
    HeroIncHP(1);
  end;
  if GlobalTime = 30 then
  begin
    // 30         
    GlobalTime:= 0;
    NewMonsterCreate;
  end;
  // 
  AllMonsterMove;
end;

//------------------------------------------------------------------------------
function RollDice( d1, d2: Integer ): Integer;
var i,s: Integer;
begin
  s := 0;
  for i := 1 to d1 do
    s := s + random(d2)+1;
  RollDice := s;
end;

//------------------------------------------------------------------------------
function  HeroNearAttack(x,y: integer): boolean;
var mtrNum:     integer;
    itmWpnNum:  integer;
    flagAttack: boolean;
    itmUseNum:  integer;
    mtrDamage:  integer;
    mtrMissed:  integer;
    SpecDmg:    integer;
begin
  flagAttack:= false;
  SpecDmg:= 0;
  for mtrNum:= 0 to Length(MonstersMap)-1 do
  begin
    if (x = MonstersMap[mtrNum].x) and (y = MonstersMap[mtrNum].y) then
    begin
      flagAttack:= true;
      //      
      if MonstersMap[mtrNum].Paralize > 0 then
        mtrMissed:= 100
      else
        mtrMissed:= Random(100)+1-(HeroCoeffFatigue*10);
      if mtrMissed > 20 then
      begin
        itmUseNum:= -1;
        //    
        for itmWpnNum:= 0 to Length(Player.Items)-1 do
        begin
          if (Player.Items[itmWpnNum].ItemType = ItemHandWeapon) and
             (Player.Items[itmWpnNum].HeroUse = true) then
          begin
            itmUseNum:= itmWpnNum;
            break;
          end;
        end;
        if itmUseNum = -1 then
        begin
          //     
          mtrDamage:=Player.Chars[chrSTR]+Player.DopChars[chrSTR]
                     -MonstersMap[mtrNum].Dd1-HeroCoeffFatigue;
          if  mtrDamage <= 0 then mtrDamage:= 1;
          OutTextAdd(MonstersMap[mtrNum].Name+'   '+inttostr(mtrDamage));
          MonsterIncHP(mtrNum,-mtrDamage);
        end
        else
        begin
          //   ,    .
          if Player.Items[itmUseNum].Special = SpecAttack then
            SpecDmg:= Player.Items[itmUseNum].LevelSpecial;
          mtrDamage:= RollDice(Player.Items[itmUseNum].Ints[itmIntsAtk1],
                               Player.Items[itmUseNum].Ints[itmIntsAtk2])
                      -MonstersMap[mtrNum].Dd1-HeroCoeffFatigue
                      +Player.Chars[chrSTR]+SpecDmg+Player.DopChars[chrSTR];
          if  mtrDamage <= 0 then mtrDamage:= 1;
          OutTextAdd(MonstersMap[mtrNum].Name+'   '+inttostr(mtrDamage));
          MonsterIncHP(mtrNum,-mtrDamage);
        end;
      end
      else
      begin
        OutTextAdd('!');
      end;
      HeroIncFatigue(2);
    end;
  end;
  HeroNearAttack:= flagAttack;
end;

//------------------------------------------------------------------------------
procedure NextMap;
begin
  if (Player.FCoordX = Portal.x) and (Player.FCoordY = Portal.y) then
  begin
    if CurMap.Level = 50 then
    begin
      GameWin;
    end
    else
    begin
      MapLevelCreate(CurMap.Level+1);
      OutTextAdd('  '+inttostr(CurMap.Level));
    end;
  end;
end;

//------------------------------------------------------------------------------
procedure HeroLevelUp;
begin
  if Player.Level >= 10 then
    exit;
  if Player.Exp >= Player.MaxExp then
  begin
    Player.Chars[chrStr]:=Player.Chars[chrStr]+1;
    Player.Chars[chrCon]:=Player.Chars[chrCon]+1;
    Player.MaxHP:= Player.MaxHP+7;
    Player.HP:= Player.MaxHP;
    Player.armor:= Player.Chars[chrCon] div 2;
    Player.Level:= Player.Level+1;
    Player.MaxExp:=ExpLevel_Table[Player.Level];
    OutTextAdd('!  '+inttostr(Player.Level)+ ' !');
  end;
end;

//------------------------------------------------------------------------------
procedure ChooseShot;
var itmNum:   integer;
    WpnRange: boolean;
    ammo:     boolean;
begin
  //    ,        
  if flagShot = true then
  begin
    flagShot:= false;
    BtnGameArray[BtnRangeAttack].active:= false;
    exit;
  end;
  WpnRange:= false;
  ammo:= false;
  //        
  for itmNum:= 0 to Length(Player.Items)-1 do
  begin
    if (Player.Items[itmNum].ItemType = ItemRangeWeapon) and
       (Player.Items[itmNum].HeroUse = true) then
    begin
      WpnRange:= true;
      Shot.itemNum:= itmNum;
    end;
    if Player.Items[itmNum].ItemType = ItemAmmo then
      ammo:= true;
  end;
  if (WpnRange = true) and (ammo = true) then
  begin
    shotType:= 0;
    flagShot:= true;
    BtnGameArray[BtnRangeAttack].active:= true;
  end;
end;

//------------------------------------------------------------------------------
procedure MoveMouse;
begin
  //    
  if PointInRect(CursorX,CursorY,GLRect(startDrawX,startDrawY,
     startDrawX+((viewScreen-1)*TileW),startDrawY+((viewScreen-1)*TileH))) then
  begin
    if (inp.Down(M_BTN_1) = true) and (MouseDown = false) then
    begin
      MouseDown:= true;
    if PointInRect(CursorX+(TileW div 2), cursorY+(TileH div 2),
       GLRect((Player.FCoordX-CurMap.MapX)*TileW+startDrawX-(TileW div 2),
               startDrawY, TileW*2,
              (Player.FCoordY-CurMap.MapY)*TileH-(TileW div 2))) then
      MoveHero(0,-1)
    else if PointInRect(CursorX+(TileW div 2), cursorY+(TileH div 2),
       GLRect((Player.FCoordX-CurMap.MapX)*TileW+startDrawX+TileW+(TileW div 2),
              (Player.FCoordY-CurMap.MapY)*TileH+startDrawY-(TileH div 2),
              ((CurMap.MapX+viewScreen)-Player.FCoordX)*TileW-(TileW div 2),
              TileH*2)) then
      MoveHero(1,0)
    else if PointInRect(CursorX+(TileW div 2), cursorY+(TileH div 2),
       GLRect((Player.FCoordX-CurMap.MapX)*TileW+startDrawX-(TileW div 2),
              (Player.FCoordY-CurMap.MapY)*TileH+startDrawY+TileH+(TileH div 2),
              TileW*2,
              ((CurMap.MapY+viewScreen)-Player.FCoordY)*TileH-(TileH div 2))) then
      MoveHero(0,1)
    else if PointInRect(CursorX+(TileW div 2), cursorY+(TileH div 2),
       GLRect(startDrawX,
              (Player.FCoordY-CurMap.MapY)*TileH+startDrawY-(TileH div 2),
              (Player.FCoordX-CurMap.MapX)*TileW-(TileW div 2),
              TileH*2)) then
      MoveHero(-1,0);
    end;
  end;
end;

//------------------------------------------------------------------------------
procedure ShotStart(angle: integer);
var mtrNum:  integer;
    wallNum: integer;
begin
  Shot.targetMonster:= -1;
  //       
  if angle = 0 then
  begin
    Shot.x:= (Player.FCoordX-CurMap.MapX)*TileW+startDrawX;
    Shot.y:= (Player.FCoordY-CurMap.MapY)*TileH-(TileH div 2)+startDrawY;
    Shot.deltaX:= 0;
    Shot.deltaY:= -ShotSpeed;
    Shot.targetX:= 0;
    Shot.targetY:= Player.FCoordY-MaxLengthShot;
    for mtrNum:= 0 to Length(MonstersMap)-1 do
    begin
      if (MonstersMap[mtrNum].x = Player.FCoordX) and
         (MonstersMap[mtrNum].y < Player.FCoordY) and
         (MonstersMap[mtrNum].y >= Shot.targetY) then
      begin
        Shot.targetY:= MonstersMap[mtrNum].y;
        Shot.targetMonster:= mtrNum;
      end;
    end;
    for wallNum:= Player.FCoordY downto Shot.targetY do
    begin
      if not FreeTile(CurMap.MapCell[Player.FCoordX,wallNum].tile,flagAllFree) then
      begin
        Shot.targetY:= wallNum;
        Shot.targetMonster:= -1;
        break;
      end;
    end;
    Shot.targetY:= (Shot.targetY-CurMap.MapY)*TileH+startDrawY+(TileH div 2);
  end;
  if angle = 90 then
  begin
    Shot.x:= (Player.FCoordX-CurMap.MapX)*TileW + startDrawX + (TileW div 2);
    Shot.y:= (Player.FCoordY-CurMap.MapY)*TileH + startDrawY;
    Shot.deltaX:= ShotSpeed;
    Shot.deltaY:= 0;
    Shot.targetY:= 0;
    Shot.targetX:= Player.FCoordX+MaxLengthShot;
    for mtrNum:= 0 to Length(MonstersMap)-1 do
    begin
      if (MonstersMap[mtrNum].y = Player.FCoordY) and
         (MonstersMap[mtrNum].x > Player.FCoordX) and
         (MonstersMap[mtrNum].x <= Shot.targetX) then
      begin
        Shot.targetX:= MonstersMap[mtrNum].x;
        Shot.targetMonster:= mtrNum;
      end;
    end;
    for wallNum:= Player.FCoordX to Shot.targetX do
    begin
      if not FreeTile(CurMap.MapCell[wallNum,Player.FCoordY].tile,flagAllFree) then
      begin
        Shot.targetX:= wallNum;
        Shot.targetMonster:= -1;
        break;
      end;
    end;
    Shot.targetX:= (Shot.targetX-CurMap.MapX)*TileW+startDrawX-(TileW div 2);
  end;
  if angle = 180 then
  begin
    Shot.x:= (Player.FCoordX-CurMap.MapX)*TileW + startDrawX;
    Shot.y:= (Player.FCoordY-CurMap.MapY)*TileH + startDrawY + (TileH div 2);
    Shot.deltaX:= 0;
    Shot.deltaY:= ShotSpeed;
    Shot.targetX:= 0;
    Shot.targetY:= Player.FCoordY+MaxLengthShot;
    for mtrNum:= 0 to Length(MonstersMap)-1 do
    begin
      if (MonstersMap[mtrNum].x = Player.FCoordX) and
         (MonstersMap[mtrNum].y > Player.FCoordY) and
         (MonstersMap[mtrNum].y <= Shot.targetY) then
      begin
        Shot.targetY:= MonstersMap[mtrNum].y;
        Shot.targetMonster:= mtrNum;
      end;
    end;
    for wallNum:= Player.FCoordY to Shot.targetY do
    begin
      if not FreeTile(CurMap.MapCell[Player.FCoordX,wallNum].tile,flagAllFree) then
      begin
        Shot.targetY:= wallNum;
        Shot.targetMonster:= -1;
        break;
      end;
    end;
    Shot.targetY:= (Shot.targetY-CurMap.MapY)*TileH+startDrawY-(TileH div 2);
  end;
  if angle = 270 then
  begin
    Shot.x:= (Player.FCoordX-CurMap.MapX)*TileW - (TileW div 2) +startDrawX;
    Shot.y:= (Player.FCoordY-CurMap.MapY)*TileH + startDrawY;
    Shot.deltaX:= -ShotSpeed;
    Shot.deltaY:= 0;
    Shot.targetY:= 0;
    Shot.targetX:= Player.FCoordX-MaxLengthShot;
    for mtrNum:= 0 to Length(MonstersMap)-1 do
    begin
      if (MonstersMap[mtrNum].y = Player.FCoordY) and
         (MonstersMap[mtrNum].x < Player.FCoordX) and
         (MonstersMap[mtrNum].x >= Shot.targetX) then
      begin
        Shot.targetX:= MonstersMap[mtrNum].x;
        Shot.targetMonster:= mtrNum;
      end;
    end;
    for wallNum:= Player.FCoordX downto Shot.targetX do
    begin
      if not FreeTile(CurMap.MapCell[wallNum,Player.FCoordY].tile,flagAllFree) then
      begin
        Shot.targetX:= wallNum;
        Shot.targetMonster:= -1;
        break;
      end;
    end;
    Shot.targetX:= (Shot.targetX-CurMap.MapX)*TileW+startDrawX+(TileW div 2);
  end;
  Shot.angle:= angle;
  Pause:= True;
end;

//------------------------------------------------------------------------------
procedure ShotProcess;
begin
  //     
  if Shot.angle = 0 then
  begin
    if Shot.y < Shot.targetY then
      ShotEnd;
  end;
  if Shot.angle = 90 then
  begin
    if Shot.x > Shot.targetX then
      ShotEnd;
  end;
  if Shot.angle = 180 then
  begin
    if Shot.y > Shot.targetY then
      ShotEnd;
  end;
  if Shot.angle = 270 then
  begin
    if Shot.x < Shot.targetX then
      ShotEnd;
  end;
  Shot.x:= Shot.x+Shot.deltaX;
  Shot.y:= Shot.y+Shot.deltaY;
  if (abs(Shot.x - ((Player.FCoordX-CurMap.MapX)*TileW)+startDrawX) > TileW*7) or
     (abs(Shot.y - ((Player.FCoordY-CurMap.MapY)*TileH)+startDrawY) > TileH*7) then
  begin
    //        
    ShotEnd;
    Pause:= false;
    flagShot:= false;
    BtnGameArray[BtnRangeAttack].active:= false;
  end;
end;

//------------------------------------------------------------------------------
procedure ShotDraw;
begin
  if (flagShot = false) or (Pause = false) then
    exit;
  if shotType = 0 then
  begin
    DrawSprite2D(Shot.texArrow,Round(Shot.x),Round(Shot.y),ImageW,ImageH,Shot.angle);
  end
  else
  begin
    DrawSprite2D(Shot.texFireBall,Round(Shot.x),Round(Shot.y),ImageW,ImageH,Shot.angle);
  end;
end;

//------------------------------------------------------------------------------
procedure ShotEnd;
var itmUseNum: integer;
    mtrMissed: integer;
    SpecDmg  : integer;
    mtrDamage: integer;
begin
  SpecDmg:= 0;
  itmUseNum:= Shot.itemNum;
  //   
  if Shot.targetMonster <> -1 then
  begin
    //      
    if (MonstersMap[Shot.targetMonster].Paralize > 0) or
       (shotType = 1) then
      mtrMissed:= 100
    else
      mtrMissed:= Random(100)+1-(HeroCoeffFatigue*10);
    if mtrMissed > 10 then
    begin
      if Player.Items[itmUseNum].Special = SpecAttack then
        SpecDmg:= Player.Items[itmUseNum].LevelSpecial;
      //     (/ )  
      if shotType = 0 then
      begin
        mtrDamage:= RollDice(Player.Items[itmUseNum].Ints[itmIntsAtk1],
                             Player.Items[itmUseNum].Ints[itmIntsAtk2])
                    -MonstersMap[Shot.targetMonster].Dd1-HeroCoeffFatigue
                    +Player.Chars[chrSTR]+SpecDmg+Player.DopChars[chrSTR];
      end
      else
      begin
        mtrDamage:= Player.Items[itmUseNum].Ints[itmIntsPower]+
                    Player.Items[itmUseNum].LevelSpecial*Player.Items[itmUseNum].Ints[itmIntsPower];
      end;
      if  mtrDamage <= 0 then mtrDamage:= 1;
      OutTextAdd(MonstersMap[Shot.targetMonster].Name+'   '+inttostr(mtrDamage));
      MonsterIncHP(Shot.targetMonster,-mtrDamage);
    end
    else
    begin
      OutTextAdd('!');
    end;
  end;
  //          ,  
  if shotType = 1 then
    IncItem(itmUseNum)
  else
  begin
    for itmUseNum:= 0 to Length(Player.Items)-1 do
    begin
      if Player.Items[itmUseNum].ItemType = ItemAmmo then
      begin
        IncItem(itmUseNum);
        break;
      end;
    end;
  end;
  Pause:= false;
  flagShot:= false;
  BtnGameArray[BtnRangeAttack].active:= false;
  HeroAction;
end;

//------------------------------------------------------------------------------
procedure BloodInit(x,y: integer; active: boolean);
begin
  Blood.x:= x;
  Blood.y:= y;
  Blood.active:= active;
  Pause:= active;
  Blood.time:= 0;
end;

//------------------------------------------------------------------------------
procedure BloodProcess;
begin
  if Blood.time < BloodMaxTime then
    Blood.time:= Blood.time+BloodSpeedTime
  else
    BloodInit(0,0,false);
end;

//------------------------------------------------------------------------------
procedure BloodDraw;
begin
  if Blood.active = true then
    DrawSprite2D_simple(texBlood,startDrawX+(Blood.x-CurMap.MapX)*TileW,
    startDrawY+(Blood.y-CurMap.MapY)*TileH,TileW,TileH);
end;

//------------------------------------------------------------------------------
procedure DeadProcess;
begin
  if InKey(Key_Enter) then
    GameEnd;
end;

//------------------------------------------------------------------------------
procedure GameWin;
begin
  if FlagWin = false then
  begin
    FlagWin:= true;
    OutTextAdd('!!!');
    OutTextAdd(' -  - '+inttostr(Player.Gold));
    OutTextAdd('   Enter...');
  end;
end;

//------------------------------------------------------------------------------
procedure WinProcess;
begin
  if InKey(Key_Enter) then
    GameEnd;
end;

//------------------------------------------------------------------------------
procedure VisibleTile;
var TileX: integer;
    TileY: integer;
begin
  for TileX:= Player.FCoordX-Player.VisLong to Player.FCoordX+Player.VisLong do
    for TileY:= Player.FCoordY-Player.VisLong to Player.FCoordY+Player.VisLong do
    begin
      CurMap.MapCell[TileX,TileY].visible:= true;
    end;
end;

end.
