unit InitRes;
//   ini 

interface

uses  monsters, hero, inifiles;

const FileNameHero =     'paramhero.ini';
      FileNameMonsters = 'parammonsters.ini';

const EnglishNameMonsters: array[1..mtrMaxType] of string =
      ('Giant cockroach',
       'Goblin',
       'Giant scolopendr',
       'Werewolf',
       'Dark Elf',
       'Mutant',
       'Draconid',
       'Golem',
       'Demon',
       'Phoenix');

//   
const StandartMonsters: array[1..mtrMaxType] of TMonster =
      (
      (Name:'.'; ID:1; x:0; y:0; HP:5; MaxHP:5; XP:1; Level:0; Ad1:1; Ad2:1;
      Dd1:0; ViewZone:5; Specs:mtrNone; Paralize:0),
      (Name:''; ID:2; x:0; y:0; HP:8; MaxHP:8; XP:2; Level:0; Ad1:1; Ad2:2;
      Dd1:1; ViewZone:5; Specs:mtrNone; Paralize:0),
      (Name:'.'; ID:3; x:0; y:0; HP:15; MaxHP:15; XP:3; Level:1; Ad1:1; Ad2:4;
      Dd1:3; ViewZone:5; Specs:mtrPoison; Paralize:0),
      (Name:''; ID:4; x:0; y:0; HP:10; MaxHP:10; XP:3; Level:1; Ad1:2; Ad2:2;
      Dd1:2; ViewZone:5; Specs:mtrNone; Paralize:0),
      (Name:'Ҹ '; ID:5; x:0; y:0; HP:18; MaxHP:18; XP:5; Level:2; Ad1:4; Ad2:2;
      Dd1:3; ViewZone:5; Specs:mtrNone; Paralize:0),
      (Name:''; ID:6; x:0; y:0; HP:30; MaxHP:30; XP:7; Level:2; Ad1:2; Ad2:4;
      Dd1:7; ViewZone:5; Specs:mtrPoison; Paralize:0),
      (Name:''; ID:7; x:0; y:0; HP:22; MaxHP:22; XP:7; Level:3; Ad1:3; Ad2:5;
      Dd1:5; ViewZone:5; Specs:mtrNone; Paralize:0),
      (Name:''; ID:8; x:0; y:0; HP:40; MaxHP:40; XP:10; Level:4; Ad1:5; Ad2:3;
      Dd1:10; ViewZone:5; Specs:mtrNone; Paralize:0),
      (Name:''; ID:9; x:0; y:0; HP:30; MaxHP:30; XP:10; Level:5; Ad1:4; Ad2:5;
      Dd1:8; ViewZone:5; Specs:mtrPoison; Paralize:0),
      (Name:''; ID:10; x:0; y:0; HP:70; MaxHP:70; XP:15; Level:7; Ad1:7; Ad2:3;
      Dd1:10; ViewZone:5; Specs:mtrNone; Paralize:0)
      );

procedure OpenIniHero;
procedure OpenIniMonsters;
procedure FillHero;
procedure FillMonsters;

var HeroIni:     TIniFile;
    MonstersIni: TIniFile;

implementation

uses SysUtils;

//------------------------------------------------------------------------------
procedure OpenIniHero;
begin
  if not FileExists(GetCurrentDir+'\'+FileNameHero) then
  begin
    HeroIni:= TIniFile.Create(GetCurrentDir+'\'+FileNameHero);
    HeroIni.WriteString('Hero','Name','Rogue');
    HeroIni.WriteInteger('Hero','MaxHP',10);
    HeroIni.WriteInteger('Hero','VisLong',3);
    HeroIni.Free;
  end;
  FillHero;
end;

//------------------------------------------------------------------------------
procedure OpenIniMonsters;
var mtrId: integer;
begin
  if not FileExists(GetCurrentDir+'\'+FileNameMonsters) then
  begin
    MonstersIni:= TIniFile.Create(GetCurrentDir+'\'+FileNameMonsters);
    for mtrId:= 1 to mtrMaxType do
    begin
      MonstersIni.WriteInteger(EnglishNameMonsters[mtrId],'MaxHP',
                               StandartMonsters[mtrId].MaxHP);
      MonstersIni.WriteInteger(EnglishNameMonsters[mtrId],'XP',
                               StandartMonsters[mtrId].XP);
      MonstersIni.WriteInteger(EnglishNameMonsters[mtrId],'Ad1',
                               StandartMonsters[mtrId].Ad1);
      MonstersIni.WriteInteger(EnglishNameMonsters[mtrId],'Ad2',
                               StandartMonsters[mtrId].Ad2);
      MonstersIni.WriteInteger(EnglishNameMonsters[mtrId],'Dd1',
                               StandartMonsters[mtrId].Dd1);
      MonstersIni.WriteInteger(EnglishNameMonsters[mtrId],'ViewZone',
                               StandartMonsters[mtrId].ViewZone);
    end;
    MonstersIni.Free;
  end;
  FillMonsters;
end;

//------------------------------------------------------------------------------
procedure FillHero;
var tmpHeroName: string;
begin
  HeroIni:= TIniFile.Create(GetCurrentDir+'\'+FileNameHero);
  tmpHeroName:= HeroIni.ReadString('Hero','Name','Rogue');
  SetLength(tmpHeroName,10);
  Player.Name := tmpHeroName;
  Player.MaxHP := HeroIni.ReadInteger('Hero','MaxHP',10);
  Player.VisLong := HeroIni.ReadInteger('Hero','VisLong',3);
  HeroIni.Free;
end;

//------------------------------------------------------------------------------
procedure FillMonsters;
var mtrId: integer;
begin
  MonstersIni:= TIniFile.Create(GetCurrentDir+'\'+FileNameMonsters);
  for mtrId:= 1 to mtrMaxType do
  begin
    BaseMonsters[mtrId]:= StandartMonsters[mtrID];
    BaseMonsters[mtrId].MaxHP :=
    MonstersIni.ReadInteger(EnglishNameMonsters[mtrId],'MaxHP',
                            StandartMonsters[mtrId].MaxHP);
    BaseMonsters[mtrId].XP :=
    MonstersIni.ReadInteger(EnglishNameMonsters[mtrId],'XP',
                             StandartMonsters[mtrId].XP);
    BaseMonsters[mtrId].Ad1 :=
    MonstersIni.ReadInteger(EnglishNameMonsters[mtrId],'Ad1',
                             StandartMonsters[mtrId].Ad1);
    BaseMonsters[mtrId].Ad2 :=
    MonstersIni.ReadInteger(EnglishNameMonsters[mtrId],'Ad2',
                             StandartMonsters[mtrId].Ad2);
    BaseMonsters[mtrId].Dd1 :=
    MonstersIni.ReadInteger(EnglishNameMonsters[mtrId],'Dd1',
                             StandartMonsters[mtrId].Dd1);
    BaseMonsters[mtrId].ViewZone :=
    MonstersIni.ReadInteger(EnglishNameMonsters[mtrId],'ViewZone',
                             StandartMonsters[mtrId].ViewZone);
  end;
  MonstersIni.Free;
end;

end.
