unit Items;
// 

interface

uses npUtils, windows, eXgine, GlobalConst;

const //
      itmSword         = 1;//
      itmAxe           = 2;//
      itmSpear         = 3;//
      itmBow           = 4;//
      itmArmor         = 5;//
      itmHealPotion    = 6;// 
      itmFatiguePotion = 7;// 
      itmStrPotion     = 8;// 
      itmConPotion     = 9;// 
      itmArmorPotion   = 10;// 
      itmGold          = 11;//
      itmAmmo          = 12;//
      itmFood          = 13;//
      itmRingCold      = 14;// 
      itmRingParalize  = 15;// 
      itmRingClear     = 16;// 
      itmRingFire      = 17;// 
      itmMax           = 17;// 

      // . 
      lvlSpec0 = 0;
      lvlSpec1 = 1;
      lvlSpec2 = 2;
      lvlSpec3 = 3;
      lvlSpec4 = 4;
      lvlSpec5 = 5;

      itmMinMap = 5; //.-   
      itmMaxMap = 12;//.-   

      //- 
      itmIntsNum   = 1;//-
      itmIntsAtk1  = 2;//1
      itmIntsAtk2  = 3;//2
      itmIntsArmor = 4;//
      itmIntsTime  = 5;//
      itmIntsPower = 6;//
      itmIntsLife  = 7;// 

type TItemType = (ItemNone, ItemHandWeapon, ItemRangeWeapon, ItemArmor,
                  ItemPotion, ItemGold, ItemMagicRing, ItemAmmo, ItemFood);
type TSpecial  = (SpecAttack, SpecArmor, SpecStr, SpecCon,SpecHeal,SpecTime,SpecNone);


type TItems = record
       ID:           integer;              //ID( )
       ItemType:     TItemType;            // 
       Name:         string[128];          //
       X,Y:          integer;              //
       Special:      TSpecial;             //.
       LevelSpecial: byte;                 // .
       HeroUse:      boolean;              // 
       Ints:         array[1..10] of Byte; // ()
     end;

//  
const BaseItems:array[1..itmMax] of TItems =
      ((ID:1; ItemType:ItemHandWeapon; Name:''; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,3,4,0,0,0,0,0,0,0)),

        (ID:2; ItemType:ItemHandWeapon; Name:''; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,1,7,0,0,0,0,0,0,0)),

        (ID:3; ItemType:ItemHandWeapon; Name:''; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,2,5,0,0,0,0,0,0,0)),

        (ID:4; ItemType:ItemRangeWeapon; Name:''; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,1,4,0,0,0,0,0,0,0)),

        (ID:5; ItemType:ItemArmor; Name:''; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,0,0,1,0,0,0,0,0,0)),

        (ID:6; ItemType:ItemPotion; Name:' '; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,0,0,0,0,3,0,0,0,0)),

        (ID:7; ItemType:ItemPotion; Name:' '; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,0,0,0,0,5,0,0,0,0)),

        (ID:8; ItemType:ItemPotion; Name:' '; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,0,0,0,0,1,5,0,0,0)),

        (ID:9; ItemType:ItemPotion; Name:' '; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,0,0,0,0,1,5,0,0,0)),

        (ID:10; ItemType:ItemPotion; Name:' '; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,0,0,0,0,1,5,0,0,0)),

        (ID:11; ItemType:ItemGold; Name:''; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(10,0,0,0,0,0,0,0,0,0)),

        (ID:12; ItemType:ItemAmmo; Name:''; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(10,0,0,0,0,0,0,0,0,0)),

        (ID:13; ItemType:ItemFood; Name:''; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(3,0,0,0,0,1,0,0,0,0)),

        (ID:14; ItemType:ItemMagicRing; Name:' '; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,0,0,0,0,10,0,0,0,0)),

        (ID:15; ItemType:ItemMagicRing; Name:' '; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,0,0,0,5,1,0,0,0,0)),

        (ID:16; ItemType:ItemMagicRing; Name:' '; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,0,0,0,0,1,0,0,0,0)),

        (ID:17; ItemType:ItemMagicRing; Name:' '; X:0; Y:0;
        Special:SpecNone; LevelSpecial:lvlSpec0; HeroUse:False;
        Ints:(1,0,0,0,0,20,0,0,0,0)));

var GameItems: array of TItems;
    texItems:  array[1..itmMax] of cardinal;

// 
procedure ItemsCreate(itmId, itmX, itmY, itmlvlSpec: integer;
                      itmSpec: TSpecial; itmMap: boolean; itmNum: integer);
procedure ItemDraw;                                      // 
procedure ItemsDelete(itmNum:integer; itmMap: boolean);  // 
procedure IncItem(ItmId: integer);                       // -      1
procedure ItemUse(itmId: integer);                       // 
procedure ItemInfo(itmId: integer);                      //  
procedure ItemDrop(itmId: integer);                      // 
function  ItemName(Item: TItems; isBag: boolean): string;// +-+
procedure ItemsInit;                                     //   

implementation

uses Map, Classes, Hero, Main, GUI, Monsters;

//--TItems

//------------------------------------------------------------------------------
procedure ItemsInit;
var itmTexNum: integer;
begin
  for itmTexNum:= 1 to itmMax do
    texItems[itmTexNum] := tex.Load(PChar('data/item'+inttostr(itmTexNum)+'.tga'),false, false);
end;

//------------------------------------------------------------------------------
procedure ItemsCreate(itmId, itmX, itmY, itmlvlSpec: integer;
          itmSpec: TSpecial; itmMap: boolean; itmNum: integer);
var numItem: integer;
begin
  if itmMap = true then
  begin
    //   
    SetLength(GameItems,length(GameItems)+1);
    numItem:= length(GameItems)-1;
    GameItems[numItem]:= BaseItems[itmId];
    GameItems[numItem].X:= itmX;
    GameItems[numItem].Y:= itmY;
    GameItems[numItem].Special:= itmSpec;
    GameItems[numItem].LevelSpecial:= itmlvlSpec;
    GameItems[numItem].Ints[itmIntsNum]:= itmNum;
  end
  else
  begin
    //    
    SetLength(Player.Items,length(Player.Items)+1);
    numItem:= length(Player.Items)-1;
    Player.Items[numItem]:= BaseItems[itmId];
    Player.Items[numItem].X:= itmX;
    Player.Items[numItem].Y:= itmY;
    Player.Items[numItem].Special:= itmSpec;
    Player.Items[numItem].LevelSpecial:= itmlvlSpec;
    Player.Items[numItem].Ints[itmIntsNum]:= itmNum;
  end;
end;

//------------------------------------------------------------------------------
procedure ItemDraw;
var itmNum: integer;
begin
  for itmNum:= 0 to length(GameItems)-1 do
  begin
    if (CurMap.MapX <= GameItems[itmNum].X) and (GameItems[itmNum].X <= CurMap.MapX+viewScreen-1)
    and (CurMap.MapY <= GameItems[itmNum].Y) and (GameItems[itmNum].Y <= CurMap.MapY+viewScreen-1)
    and (CurMap.MapCell[GameItems[itmNum].X,GameItems[itmNum].Y].visible = true) then
    DrawSprite2D_simple(texItems[GameItems[itmNum].ID],
    startDrawX+(GameItems[itmNum].X-CurMap.MapX)*TileW,
    startDrawY+(GameItems[itmNum].Y-CurMap.MapY)*tileH,TileW,TileH);
  end;
end;

//------------------------------------------------------------------------------
procedure ItemsDelete(itmNum:integer; itmMap: boolean);
var itmNumLoop: integer;
begin
  if itmMap then
  begin
    //   
    for itmNumLoop:= itmNum to Length(GameItems)-2 do
    begin
      GameItems[itmNumLoop]:= GameItems[itmNumLoop+1];
    end;
    SetLength(GameItems,Length(GameItems)-1);
  end
  else
  begin
    //    
    for itmNumLoop:= itmNum to Length(Player.Items)-2 do
    begin
      Player.Items[itmNumLoop]:= Player.Items[itmNumLoop+1];
    end;
    SetLength(Player.Items,Length(Player.Items)-1);
  end;
end;

//------------------------------------------------------------------------------
procedure IncItem(ItmId: integer);
begin
  Player.Items[itmId].Ints[ItmIntsNum]:=Player.Items[itmId].Ints[ItmIntsNum]-1;
  if Player.Items[itmId].Ints[ItmIntsNum] <= 0 then
  begin
    ItemsDelete(itmId,false);
    Inv.ActiveLine:= Inv.ActiveLine-1;
    if Inv.NumLineStartDraw > 0 then
      Inv.NumLineStartDraw:= Inv.NumLineStartDraw-1;
  end;
end;

//---------------------------- ----------------------------
procedure ItemUse(itmId: integer);
var tmpItm: TItems;
    itmNum: integer;
    mtrNum: integer;
    dmgNum: integer;
begin
  tmpItm:= Player.Items[ItmId];
  {if tmpItm.Ints[itmIntsNum] <= 0 then
    exit;}
  case tmpItm.ItemType of
    ItemHandWeapon,ItemRangeWeapon,ItemArmor:
    begin
      //        
      for itmNum:= 0 to length(Player.Items)-1 do
      begin
        if Player.Items[itmNum].ItemType = tmpItm.ItemType then
          Player.Items[itmNum].HeroUse:= false;
      end;
      //    
      Player.Items[itmId].HeroUse:= true;
      OutTextAdd('  '+Player.Items[itmId].Name);
    end;
    ItemPotion:
    begin
      if tmpItm.ID = itmHealPotion then
      begin
        HeroIncHP(10+tmpItm.LevelSpecial*10);
        OutTextAdd('  +'+inttostr(10+tmpItm.LevelSpecial*10));
      end;
      if tmpItm.ID = itmFatiguePotion then
      begin
        HeroIncFatigue(-(100+tmpItm.LevelSpecial*100));
        OutTextAdd('   '+inttostr(100+tmpItm.LevelSpecial*100));
      end;
      if tmpItm.ID = itmStrPotion then
      begin
        Player.DopChars[chrStr]:= 3+tmpItm.LevelSpecial*3;
        Player.DopTimeChars[chrStr]:= 15;
        OutTextAdd(' ');
      end;
      if tmpItm.ID = itmConPotion then
      begin
        Player.DopChars[chrCon]:= 1+tmpItm.LevelSpecial*2;
        Player.DopTimeChars[chrCon]:= 30;
        Player.MaxHP:= Player.MaxHP+Player.DopChars[chrCon]*5;
        HeroIncHP(Player.DopChars[chrCon]*5);
        OutTextAdd(' ');
      end;
      if tmpItm.ID = itmArmorPotion then
      begin
        Player.DopArmor:= 1+tmpItm.LevelSpecial;
        Player.DopTimeArmor:= 50;
        OutTextAdd(' ');
      end;
      IncItem(ItmId);
      HeroAction;
    end;
    ItemMagicRing:
    begin
      if tmpItm.ID = itmRingCold then
      begin
        for mtrNum:= 0 to Length(MonstersMap)-1 do
        begin
          if (MonstersMap[mtrNum].x >= Player.FCoordX-1) and
             (MonstersMap[mtrNum].x <= Player.FCoordX+1) and
             (MonstersMap[mtrNum].y >= Player.FCoordY-1) and
             (MonstersMap[mtrNum].y <= Player.FCoordY+1) then
          begin
            dmgNum:= tmpItm.Ints[itmIntsPower]+tmpItm.LevelSpecial*tmpItm.Ints[itmIntsPower];
            OutTextAdd(MonstersMap[mtrNum].Name+'   '+inttostr(dmgNum));
            MonsterIncHP(mtrNum,-dmgNum);
          end;
        end;
      end;
      if tmpItm.ID = itmRingParalize then
      begin
        for mtrNum:= 0 to Length(MonstersMap)-1 do
        begin
          if (MonstersMap[mtrNum].x >= Player.FCoordX-1) and
             (MonstersMap[mtrNum].x <= Player.FCoordX+1) and
             (MonstersMap[mtrNum].y >= Player.FCoordY-1) and
             (MonstersMap[mtrNum].y <= Player.FCoordY+1) then
          begin
            MonstersMap[mtrNum].Paralize:= tmpItm.Ints[itmIntsTime]+tmpItm.LevelSpecial;
            OutTextAdd(MonstersMap[mtrNum].Name+' ');
          end;
        end;
      end;
      if tmpItm.ID = itmRingClear then
      begin
        Player.Poison:= 0;
        OutTextAdd('   ');
      end;
      if tmpItm.ID = itmRingFire then
      begin
        shotType:= 1;
        flagShot:= true;
        Shot.itemNum:= itmId;
        BtnGameArray[BtnRangeAttack].active:= true;
      end;
      if tmpItm.ID <> itmRingFire then
      begin
        IncItem(ItmId);
        HeroAction;
      end;
    end;
    ItemFood:
    begin
      HeroIncFatigue(-50);
      IncItem(ItmId);
      HeroAction;
    end;
    else
      exit;
  end;
end;

//----------------------------  -----------------------------
procedure ItemInfo(itmId: integer);
var TmpItm: TItems;
begin
  Inv.DrawInfo:= true;
  Inv.InfoText:= '';
  TmpItm:= Player.Items[itmId];
  case TmpItm.ItemType of
    ItemHandWeapon,ItemRangeWeapon:
    begin
      Inv.InfoText:= ' '+
      inttostr(TmpItm.Ints[itmIntsAtk1]+TmpItm.LevelSpecial)
      +'-'+
      inttostr(TmpItm.Ints[itmIntsAtk2]+TmpItm.LevelSpecial);
    end;
    ItemArmor:
    begin
      Inv.InfoText:= ' '+inttostr(TmpItm.Ints[itmIntsArmor]+
      TmpItm.LevelSpecial)
    end;
    ItemPotion:
    begin
      case TmpItm.ID of
        itmHealPotion:
        begin
          Inv.InfoText:='  '+
          inttostr(10+tmpItm.LevelSpecial*10)+' ';
        end;
        itmFatiguePotion:
        begin
          Inv.InfoText:='   '+
          inttostr(100+tmpItm.LevelSpecial*100)+' ';
        end;
        itmStrPotion:
        begin
          Inv.InfoText:= '  +'+inttostr(3+tmpItm.LevelSpecial*3)
          +'  15 ';
        end;
        itmConPotion:
        begin
          Inv.InfoText:= '  +'+inttostr(1+tmpItm.LevelSpecial*2)
          +'  30 ';
        end;
        itmArmorPotion:
        begin
          Inv.InfoText:= '  +'+inttostr(1+tmpItm.LevelSpecial)
          +'  50 ';
        end;
      end;
    end;
    ItemMagicRing:
    begin
      case TmpItm.ID of
        itmRingCold:
        begin
          Inv.InfoText:='      '+
          inttostr(tmpItm.Ints[itmIntsPower]+tmpItm.LevelSpecial*tmpItm.Ints[itmIntsPower]);
        end;
        itmRingParalize:
        begin
          Inv.InfoText:='      '+
          inttostr(3+tmpItm.LevelSpecial);
        end;
        itmRingClear:
        begin
          Inv.InfoText:=' ';
        end;
        itmRingFire:
        begin
          Inv.InfoText:='    '+
          inttostr(tmpItm.Ints[itmIntsPower]+tmpItm.LevelSpecial*tmpItm.Ints[itmIntsPower]);
        end;
      end;
    end;
    ItemFood:
    begin
      Inv.InfoText:= '   50';
    end;
  else
    Inv.InfoText:= '';
    Inv.DrawInfo:= false;
  end;
end;

//---------------------------- ---------------------------------
procedure ItemDrop(itmId: integer);
begin
  ItemsDelete(itmId,false);
  Inv.ActiveLine:= Inv.ActiveLine-1;
  if Inv.NumLineStartDraw > 0 then
    Inv.NumLineStartDraw:= Inv.NumLineStartDraw-1;
end;

//------------------------------------------------------------------------------
function  ItemName(Item: TItems; isBag: boolean): string;
var Spec: string;
function nameSpec(itmSpec: TSpecial): string;// .
begin
  case itmSpec of
    SpecAttack:nameSpec:= '( +';
    SpecArmor:nameSpec:= '( +';
    SpecStr:nameSpec:= '( +';
    SpecCon:nameSpec:= '(- +';
    SpecHeal:nameSpec:= '(- +';
    SpecTime:nameSpec:= '( +';
    SpecNone:nameSpec:= '';
  else
    nameSpec:= '';
  end;
end;
function nameNum: string;//- 
begin
  if Item.Ints[itmIntsNum] = 1 then
  begin
    nameNum:= '';
    exit;
  end;
  if isBag then
  begin
    nameNum:= '('+inttostr(Item.Ints[itmIntsNum])+')';
  end
  else
  begin
    case Item.ID of
      itmGold,itmAmmo,itmFood:nameNum:= '(- '+inttostr(Item.Ints[itmIntsNum])+')';
    else
      nameNum:= '';
    end;
  end;
end;
begin
  if Item.LevelSpecial > 0 then
  begin
    Spec:= nameSpec(Item.Special)+inttostr(Item.LevelSpecial)+')';
  end
  else
    Spec:= '';
  ItemName:= Item.Name+nameNum+Spec;
end;

end.
