unit Main;
// 

interface

uses OpenGL, Windows, eXgine, npUtils, GUI, GlobalConst, Map, Hero, Items, Monsters;

const       btnStart     = 1;
            btnLoad      = 2;
            btnExit      = 3;
            maxBtnMenu   = 3;

            startDrawX   = 32;//       
            startDrawY   = 32;//  Y     

procedure MainInit;      //  
procedure MainDraw;      //  
procedure MainProcess;   //  
procedure MainFree;      //   
procedure DrawMoveCursor;//    (  )
procedure GameEnd;       // 
procedure AllClear;      //   
procedure Load;          // 
procedure Save;          // 

var CursorX, CursorY: integer;        // 
    MousePosition:    TPointFloat;    //  
    MouseDown:        boolean = false;//   
    MouseRigthDown:   boolean = false;//   
    texCursor:        cardinal;       // 
    texFon:           cardinal;       // 
    ActionFlag:       integer = 0;    //  
                                      //0-, 1- 
    GlobalTime:       integer = 0;    // 
    flagResetKey:     integer = 0;    //     
    texMoveCursor:    cardinal;       //     
    texBlood:         cardinal;       // 
    FlagDead:         boolean = false;// 
    FlagWin:          boolean = false;//
    saveNumMonsters:  integer;        //-      
    saveNumItems:     integer;        //-      
    saveNumTrap:      integer;        //-      
    SaveNumHeroItems: integer;        //-      
    texLose:          cardinal;
    texWin:           cardinal;

    KeyAr:   Array[0..256] of boolean;//  
    AnyKey:  integer = 0;             //-   
    Pause:   boolean;                 //

implementation

uses SysUtils, InitRes;

//------------------------------------------------------------------------------
procedure MainInit;
begin
  //   
  wnd.Mode(false, 800, 600, 32, 75);
  texCursor:= tex.Load('data/cursor.tga',false,false);
  texMoveCursor:= tex.Load('data/movecursor.tga',false,false);
  texFon:= tex.Load('data/fon.bmp',false,false);
  texPlayer:= tex.Load('data/hero.tga',false,false);
  Shot.texArrow:= tex.Load('data/shotarrow.tga',false,false);
  Shot.texFireBall:= tex.Load('data/shotfireball.tga',false,false);
  texBlood:= tex.Load('data/blood.tga',false,false);
  texMenuFon:= tex.Load('data/menufon.bmp',false,false);
  textTextFon:= tex.Load('data/textfon.bmp',false,false);

  GUIInit;
  MapInit;
  ItemsInit;
  MonsterTexInit;
  InvInit(LineStartX,LineStartY,InvW,InvH,'');
  BtnGameInit;
  OpenIniMonsters;
  Pause:= false;
  texLose:= tex.Load('data/lose.bmp',false,false);
  texWin:= tex.Load('data/win.bmp',false,false);
end;

//------------------------------------------------------------------------------
procedure MainDraw;
begin
  ogl.Clear(True, True);
  ogl.Set2D(0, 0, wnd.Width, wnd.Height);
  DrawSprite2D_simple(texFon,0,0,wnd.Width,wnd.Height);
  case ActionFlag of
  0:begin
      GUIDraw;
    end;
  1:begin
      MapDraw;
      TrapDraw;
      ItemDraw;
      PortalDraw;
      MonsterDraw;
      DrawHero;
      OutTextDraw;
      InvDraw;
      BtnGameDraw;
      ShotDraw;
      BloodDraw;
      if FlagDead then
        DrawSprite2D_simple(texLose,startDrawX+(viewScreen*TileW div 2)-256,
                            startDrawY+(viewScreen*TileH div 2)-64,512,128);
      if FlagWin then
        DrawSprite2D_simple(texWin,startDrawX+(viewScreen*TileW div 2)-256,
                            startDrawY+(viewScreen*TileH div 2)-64,512,128);
    end;
  end;

  //  
  glColor3f(0.9, 0.9, 0.9);
  ogl.TextOut(0, 8, 8, PChar('FPS: ' + IntToStr(ogl.FPS)));
  //ogl.TextOut(0, 96, 8, PChar('CursorX: ' + IntToStr(CursorX)));
  //ogl.TextOut(0, 204, 8, PChar('CursorY: ' + IntToStr(CursorY)));
  //         
  //  (    ) 
  if (PointInRect(CursorX,CursorY,GLRect(startDrawX,startDrawY,
  startDrawX+((viewScreen-1)*TileW),startDrawY+((viewScreen-1)*TileH))) = true)
  and (ActionFlag = 1) then
  begin
    DrawMoveCursor;
  end
  else
  begin
    DrawSprite2D_simple(texCursor,CursorX,CursorY,32,32);
  end;
end;

//------------------------------------------------------------------------------
procedure MainProcess;
begin
  MousePosition.X:= MousePosition.X + inp.MDelta.X;
  MousePosition.Y:= MousePosition.Y + inp.MDelta.Y;
  if MousePosition.X < 0 then MousePosition.X := 0;
  if MousePosition.Y < 0 then MousePosition.Y := 0;
  if MousePosition.X > wnd.Width then MousePosition.X := wnd.Width;
  if MousePosition.Y > wnd.Height then MousePosition.Y := wnd.Height;
  CursorX:= round(MousePosition.X);
  CursorY:= round(MousePosition.Y);
  
  case ActionFlag of
  0:begin
      GUIProcess;
      flagResetKey:= 0;
    end;
  1:begin
      if FlagWin then
        WinProcess
      else if FlagDead = true then
        DeadProcess
      else if (Pause = true) and (flagShot = true) then
        ShotProcess
      else if Blood.active = true then
        BloodProcess
      else
        ProcessHero;
      if AnyKey = 1 then
      begin
        flagResetKey:= flagResetKey+1;
        if flagResetKey > 10 then
        begin
          ResetKey;
          flagResetKey:= 0;
        end;
      end;
    end;
  end;

  if inp.Down(M_BTN_1) = false then MouseDown:= False;
  if inp.Down(M_BTN_2) = false then MouseRigthDown:= false;
  //    Escape (  27)
  if inp.Down(27) then eX.Quit;
end;

//------------------------------------------------------------------------------
procedure MainFree;
var i: integer;
begin
  tex.Free(texWin);
  tex.Free(texLose);
  tex.Free(textTextFon);
  tex.Free(texMenuFon);
  tex.Free(texBlood);
  tex.Free(Shot.texFireBall);
  tex.Free(Shot.texArrow);
  BtnGameFree;
  GUIFree;
  tex.Free(texPlayer);
  for i:= mtrMaxType downto 1 do
    tex.Free(texMonster[i]);
  for i:= itmMax downto 1 do
    tex.Free(texItems[i]);
  tex.Free(texPortal);
  for i:= 2 downto 1 do
    tex.Free(textrap[i]);
  tex.Free(texTileDoor);
  tex.Free(texTileEmpty);
  tex.Free(texTileRoom);
  tex.Free(texTileNo);
  tex.Free(texTileWall);
  tex.Free(texTileGroud);
  tex.Free(texButton);
  tex.Free(texFon);
  tex.Free(texMoveCursor);
  tex.Free(texCursor);
end;

//------------------------------------------------------------------------------
procedure DrawMoveCursor;
begin
    if PointInRect(CursorX+(TileW div 2), cursorY+(TileH div 2),
       GLRect((Player.FCoordX-CurMap.MapX)*TileW+startDrawX-(TileW div 2),
               startDrawY, TileW*2,
              (Player.FCoordY-CurMap.MapY)*TileH-(TileW div 2))) then
      DrawSprite2D(texMoveCursor,CursorX,CursorY,32,32,0)
    else if PointInRect(CursorX+(TileW div 2), cursorY+(TileH div 2),
       GLRect((Player.FCoordX-CurMap.MapX)*TileW+startDrawX+TileW+(TileW div 2),
              (Player.FCoordY-CurMap.MapY)*TileH+startDrawY-(TileH div 2),
              ((CurMap.MapX+viewScreen)-Player.FCoordX)*TileW-(TileW div 2),
              TileH*2)) then
      DrawSprite2D(texMoveCursor,CursorX,CursorY,32,32,90)
    else if PointInRect(CursorX+(TileW div 2), cursorY+(TileH div 2),
       GLRect((Player.FCoordX-CurMap.MapX)*TileW+startDrawX-(TileW div 2),
              (Player.FCoordY-CurMap.MapY)*TileH+startDrawY+TileH+(TileH div 2),
              TileW*2,
              ((CurMap.MapY+viewScreen)-Player.FCoordY)*TileH-(TileH div 2))) then
      DrawSprite2D(texMoveCursor,CursorX,CursorY,32,32,180)
    else if PointInRect(CursorX+(TileW div 2), cursorY+(TileH div 2),
       GLRect(startDrawX,
              (Player.FCoordY-CurMap.MapY)*TileH+startDrawY-(TileH div 2),
              (Player.FCoordX-CurMap.MapX)*TileW-(TileW div 2),
              TileH*2)) then
      DrawSprite2D(texMoveCursor,CursorX,CursorY,32,32,270)
    else
      DrawSprite2D_simple(texCursor,CursorX,CursorY,32,32);
end;

//------------------------------------------------------------------------------
procedure GameEnd;
begin
  AllClear;
  ActionFlag:= 0;
end;

//------------------------------------------------------------------------------
procedure AllClear;
begin
  GlobalTime:= 0;
  flagResetKey:= 0;
  flagShot:= false;
  Pause:= false;
  Inv.NumLineStartDraw:= 0;
  Inv.ActiveLine:= 0;
  Inv.DrawAction:= false;
  Inv.ActionSelect:= 0;
  Inv.DrawInfo:= false;
  Inv.InfoText:= '';
  BloodInit(0,0,false);
  FlagDead:= false;
end;

//------------------------------------------------------------------------------
procedure Load;
var F: File;
    i: integer;
begin
  if not FileExists('rogue.sav') then
    exit;
  BloodInit(0,0,false);
  Randomize;
  AllClear;
  // 
  Assign(F, 'rogue.sav');
  Reset(F,1);
  BlockRead(F, saveNumItems, SizeOf(saveNumItems));
  BlockRead(F, saveNumMonsters, SizeOf(saveNumMonsters));
  BlockRead(F, saveNumTrap, SizeOf(saveNumTrap));
  BlockRead(F, SaveNumHeroItems, SizeOf(SaveNumHeroItems));
  SetLength(GameItems,0);
  for i := 0 to saveNumItems do
  begin
    SetLength(GameItems,Length(GameItems)+1);
    BlockRead(F, GameItems[i], SizeOf(GameItems[i]));
  end;
  BlockRead(F, CurMap, SizeOf(CurMap));
  SetLength(MonstersMap,0);
  for i := 0 to saveNumMonsters do
  begin
    SetLength(MonstersMap,Length(MonstersMap)+1);
    BlockRead(F, MonstersMap[i], SizeOf(MonstersMap[i]));
  end;
  SetLength(TrapArray,0);
  for i := 0 to saveNumTrap do
  begin
    SetLength(TrapArray,Length(TrapArray)+1);
    BlockRead(F, TrapArray[i], SizeOf(TrapArray[i]));
  end;
  BlockRead(F, Portal, SizeOf(Portal));

  BlockRead(F, Player.FCoordX, SizeOf(Player.FCoordX));
  BlockRead(F, Player.FCoordY, SizeOf(Player.FCoordY));
  BlockRead(F, Player.HP, SizeOf(Player.HP));
  BlockRead(F, Player.MaxHP, SizeOf(Player.MaxHP));
  BlockRead(F, Player.Exp, SizeOf(Player.Exp));
  BlockRead(F, Player.MaxExp, SizeOf(Player.MaxExp));
  BlockRead(F, Player.Level, SizeOf(Player.Level));
  BlockRead(F, Player.VisLong, SizeOf(Player.VisLong));
  BlockRead(F, Player.armor, SizeOf(Player.armor));
  BlockRead(F, Player.DopArmor, SizeOf(Player.DopArmor));
  BlockRead(F, Player.DopTimeArmor, SizeOf(Player.DopTimeArmor));
  BlockRead(F, Player.Gold, SizeOf(Player.Gold));
  BlockRead(F, Player.Fatigue, SizeOf(Player.Fatigue));
  BlockRead(F, Player.Name, SizeOf(Player.Name));
  BlockRead(F, Player.Chars, SizeOf(Player.Chars));
  BlockRead(F, Player.DopChars, SizeOf(Player.DopChars));
  BlockRead(F, Player.DopTimeChars, SizeOf(Player.DopTimeChars));
  BlockRead(F, Player.Poison, SizeOf(Player.Poison));
  SetLength(Player.Items,0);
  for i:= 0 to SaveNumHeroItems do
  begin
    SetLength(Player.Items,Length(Player.Items)+1);
    BlockRead(F, Player.Items[i], SizeOf(Player.Items[i]));
  end;


  Close(F);
  OutTextAdd(' ');
  ActionFlag:= 1;
end;

//------------------------------------------------------------------------------
procedure Save;
var F: File;
    i: integer;
begin
  Assign(F, 'rogue.sav');
  Rewrite(F,1);
  saveNumItems:= length(GameItems)-1;
  saveNumMonsters:= Length(MonstersMap)-1;
  saveNumTrap:= Length(TrapArray)-1;
  SaveNumHeroItems:= Length(Player.Items)-1;
  BlockWrite(F, saveNumItems, SizeOf(saveNumItems));
  BlockWrite(F, saveNumMonsters, SizeOf(saveNumMonsters));
  BlockWrite(F, saveNumTrap, SizeOf(saveNumTrap));
  BlockWrite(F, SaveNumHeroItems, SizeOf(SaveNumHeroItems));
  for i := 0 to saveNumItems do
    BlockWrite(F, GameItems[i], SizeOf(GameItems[i]));
  BlockWrite(F, CurMap, SizeOf(CurMap));
  for i := 0 to saveNumMonsters do
    BlockWrite(F, MonstersMap[i], SizeOf(MonstersMap[i]));
  for i := 0 to saveNumTrap do
    BlockWrite(F, TrapArray[i], SizeOf(TrapArray[i]));
  BlockWrite(F, Portal, SizeOf(Portal));

  BlockWrite(F, Player.FCoordX, SizeOf(Player.FCoordX));
  BlockWrite(F, Player.FCoordY, SizeOf(Player.FCoordY));
  BlockWrite(F, Player.HP, SizeOf(Player.HP));
  BlockWrite(F, Player.MaxHP, SizeOf(Player.MaxHP));
  BlockWrite(F, Player.Exp, SizeOf(Player.Exp));
  BlockWrite(F, Player.MaxExp, SizeOf(Player.MaxExp));
  BlockWrite(F, Player.Level, SizeOf(Player.Level));
  BlockWrite(F, Player.VisLong, SizeOf(Player.VisLong));
  BlockWrite(F, Player.armor, SizeOf(Player.armor));
  BlockWrite(F, Player.DopArmor, SizeOf(Player.DopArmor));
  BlockWrite(F, Player.DopTimeArmor, SizeOf(Player.DopTimeArmor));
  BlockWrite(F, Player.Gold, SizeOf(Player.Gold));
  BlockWrite(F, Player.Fatigue, SizeOf(Player.Fatigue));
  BlockWrite(F, Player.Name, SizeOf(Player.Name));
  BlockWrite(F, Player.Chars, SizeOf(Player.Chars));
  BlockWrite(F, Player.DopChars, SizeOf(Player.DopChars));
  BlockWrite(F, Player.DopTimeChars, SizeOf(Player.DopTimeChars));
  BlockWrite(F, Player.Poison, SizeOf(Player.Poison));
  for i:= 0 to SaveNumHeroItems do
    BlockWrite(F, Player.Items[i], SizeOf(Player.Items[i]));

  Close(F);
  OutTextAdd('  !');
end;

end.
