unit Map;
// 

interface

uses  npUtils, windows, eXgine, OpenGl, GlobalConst;

const tileGround    = 1;//
      tileRoom      = 2;// 
      tileWall      = 3;//
      tileEmpty     = 4;//
      tileNo        = 5;// 
      tileDoor      = 6;//
      TileMax       = 6;// 

      ConstVecTile      = -1;// 
      LengthPathForDoor = 3;//    
      ArrayColorMiniMap:array[1..TileMax] of integer =
      (COLOR_GROUND,COLOR_ROOM,COLOR_WALL,COLOR_EMPTY,COLOR_NO,COLOR_DOOR);
      //   

      viewScreen   = 15;//   ( )
      scrollScreen = 3;//       
      notWall      = 6;//.   
      FreeDoorTile = 5;//.     
      FreePathTile = 2;//.    
      PortalFrame  = 4;

      // 
      vectorLeft   = 0;
      vectorTop    = 1;
      vectorRight  = 2;
      vectorDown   = 3;

      TileW = 32;// 
      TileH = 32;// 
      MapW  = 64;//   
      MapH  = 48;//   
      flagAllFree        = 1;//  
      flagForCreateRoom  = 2;//  
      flagForCreateObj   = 3;//  
      flagForCreatePath  = 4;//    

      minRoomNum  = 4;//.- 
      maxRoomNum  = 10;//.- 
      minRoomSize = 2;//. 
      maxRoomSize = 12;//. 

      trpMinLevel = 2;//.-  +   
      trpMaxLevel = 4;//.-  +   
      trpMinDmg   = 5;//.    
      trpMaxDmg1  = 10;//  1  
      trpMaxDmg2  = 30;//  2  

// 
type TMapCell = record
                  tile:    byte;// 
                  visible: boolean;//
                end;

//  
type TDoor = record
               x,y:     integer;//
               numRoom: integer;//    
               active:  boolean;//       
             end;

// 
type TTypeTrap = (TrpPoisonDrotic, TrpFireBall);

//
type TTrap = record
               id:       integer;// 
               x,y:      integer;//
               Visible:  boolean;//  
               typeTrap: TTypeTrap;// 
             end;

//   
type TPortal = record
                 x,y: integer;//
                 numFrame: real;// 
               end;

//
type TMap = record
       MapCell:    array[1..MapW,1..MapH] of TMapCell;//  
       MapX, MapY: integer;//   
       Level:      integer;// 
       ArrayDoors: array of TDoor;// 
     end;

var texTileGroud,
    texTileWall,
    texTileNo,
    texTileRoom,
    texTileEmpty,
    texTileDoor: Cardinal;

    CurMap:      TMap;
    TrapArray:   Array of TTrap;
    texTrap:     Array[1..2] of cardinal;
    Portal:      TPortal;
    texPortal:   cardinal;

function  FreeTile(tile, flag: integer): boolean;// ( )
procedure FreeMapPoint(var x,y: integer; flag: integer);//   
procedure PortalCreate;// 
procedure PortalDraw;// 
procedure PortalProcess;
procedure TrapCreate(tx,ty:integer; tType: TTypeTrap);// 
procedure MapTrapGenerate;//   
procedure TrapDraw;// 
procedure MapInit;// 
procedure MapLevelCreate(lvl: integer);// 
procedure MapCreate;//  
procedure MapGenerate(level: integer);//   
procedure MapDraw;// 
procedure MapwriteCoord(x,y: integer);//   
procedure FillArrayDoor(x,y,n,v: integer);//  
procedure CreatePath;//   
procedure FillWall;//     
procedure DrawMiniMap;// 
procedure MapItemGenerate;//   
function  MapTypeTile(x,y: integer): integer;//    
function  FreeSizeForRoom(w,h: integer): boolean;//      
function  FreeTileForRoom(x,y,w,h: integer): boolean;//    
function  FreeDoor(x,y,vector: integer):boolean;//   

implementation

uses Math, Main, Hero, Items, Monsters;

{ TMap }

//------------------------------------------------------------------------------
function FreeTile(tile, flag: integer): boolean;
begin
  case flag of
    flagAllFree:FreeTile:= (tile = tileGround) or (tile = tileRoom) or (tile = tileDoor);
    flagForCreateRoom:FreeTile:= tile = tileEmpty;
    flagForCreateObj:FreeTile:= tile = tileRoom;
    flagForCreatePath:begin
                        if (tile = tileEmpty) or (tile = tileGround) then
                          FreeTile:= true
                        else
                          FreeTile:= false;
                      end;
    else
      FreeTile:= false;
  end;
end;

//------------------------------------------------------------------------------
procedure FreeMapPoint(var x,y: integer; flag: integer);
begin
  repeat
    x := random(MapW - scrollScreen*2) + scrollScreen;
    y := random(MapH - scrollScreen*2) + scrollScreen;
  until
    FreeTile(CurMap.MapCell[x,y].tile,flag);
end;

//------------------------------------------------------------------------------
procedure PortalCreate;
var prtFlagCreate: boolean;
    px,py:         integer;
    tmpNum:        integer;
begin
  prtFlagCreate:= false;
  while not prtFlagCreate do
  begin
    prtFlagCreate:= true;
    FreeMapPoint(px,py,flagForCreateObj);
    for tmpNum:= 0 to length(TrapArray)-1 do
    begin
      if (TrapArray[tmpNum].x = px) and (TrapArray[tmpNum].y = py) then
        prtFlagCreate:= false;
    end;
    for tmpNum:= 0 to length(GameItems)-1 do
    begin
      if (GameItems[tmpNum].x = px) and (GameItems[tmpNum].y = py) then
        prtFlagCreate:= false;
    end;
  end;
  Portal.x:= px;
  Portal.y:= py;
  Portal.numFrame:= 1;
end;

//------------------------------------------------------------------------------
procedure PortalDraw;
begin
    if (CurMap.MapX <= Portal.X) and (Portal.X <= CurMap.MapX+viewScreen-1)
    and (CurMap.MapY <= Portal.Y) and (Portal.Y <= CurMap.MapY+viewScreen-1)
    and (CurMap.MapCell[Portal.x,Portal.y].visible = true) then
      DrawSprite2D(texPortal, startDrawX+(Portal.X-CurMap.MapX)*TileW,
      startDrawY+(Portal.Y-CurMap.MapY)*tileH, TileW, TileH, 0, 255,
      COLOR_NONE, false, TileW,TileH,round(Portal.numFrame),PortalFrame);
end;

//------------------------------------------------------------------------------
procedure PortalProcess;
begin
  if Portal.numFrame > 4 then
    Portal.numFrame:= 1
  else
    Portal.numFrame:= Portal.numFrame+0.08;
end;

//------------------------------------------------------------------------------
procedure MapLevelCreate(lvl: integer);
var x,y: integer;
begin
  MapCreate;
  MapGenerate(lvl);
  MapItemGenerate;
  MapTrapGenerate;
  PortalCreate;
  FreeMapPoint(x,y,flagForCreateObj);
  HeroSetCoord(x,y);
  MonsterGenerateLevel;
  MapWriteCoord(x-(viewScreen div 2),y-(viewScreen div 2));
  GlobalTime:= 0;
end;

//------------------------------------------------------------------------------
procedure MapCreate;
var i,j: integer;
begin
  for i:= 1 to MapW do
    for j:= 1 to MapH do
    begin
      if (i < scrollScreen) or (i > MapW - scrollScreen) or
         (j < scrollScreen) or (j > MapH - scrollScreen) then
        CurMap.MapCell[i,j].tile:= tileNo
      else
        if (i = scrollScreen) or (i = MapW - scrollScreen) or
           (j = scrollScreen) or (j = MapH - scrollScreen) then
          CurMap.MapCell[i,j].tile:= tileWall
      else
        CurMap.MapCell[i,j].tile:= tileEmpty;
      CurMap.MapCell[i,j].visible:= False;
    end;

  CurMap.Level:= 0;
  SetLength(CurMap.ArrayDoors,0);
end;

//------------------------------------------------------------------------------
procedure MapDraw;
var i,j: integer;
begin
  glLineWidth(2);
  glColor3f(0.8,0.8,0.8);
  glBegin(GL_LINES);
    glVertex2f(StartDrawX,StartDrawY);
    glVertex2f(StartDrawX+(viewScreen*TileW),StartDrawY);
    glVertex2f(StartDrawX+(viewScreen*TileW),StartDrawY);
    glVertex2f(StartDrawX+(viewScreen*TileW),StartDrawY+(viewScreen*TileH));
    glVertex2f(StartDrawX+(viewScreen*TileW),StartDrawY+(viewScreen*TileH));
    glVertex2f(StartDrawX,StartDrawY+(viewScreen*TileH));
    glVertex2f(StartDrawX,StartDrawY+(viewScreen*TileH));
    glVertex2f(StartDrawX,StartDrawY);
  glend;
  for i:= CurMap.MapX to CurMap.MapX+viewScreen-1 do
    for j:= CurMap.MapY to CurMap.MapY+viewScreen-1 do
      begin
        if CurMap.MapCell[i,j].visible then
        begin
          //  
          case CurMap.MapCell[i,j].tile of
            tileGround:DrawSprite2D_simple(texTileGroud,startDrawX+(i-CurMap.MapX)*TileW,
                                    startDrawY+(j-CurMap.MapY)*tileH,TileW,TileH);
            tileRoom:DrawSprite2D_simple(texTileRoom,startDrawX+(i-CurMap.MapX)*TileW,
                                    startDrawY+(j-CurMap.MapY)*tileH,TileW,TileH);
            tileWall:DrawSprite2D_simple(texTileWall,startDrawX+(i-CurMap.MapX)*TileW,
                                    startDrawY+(j-CurMap.MapY)*TileH,TileW,TileH);
            tileEmpty:DrawSprite2D_simple(texTileEmpty,startDrawX+(i-CurMap.MapX)*TileW,
                                    startDrawY+(j-CurMap.MapY)*TileH,TileW,TileH);
            tileDoor:DrawSprite2D_simple(texTileDoor,startDrawX+(i-CurMap.MapX)*TileW,
                                    startDrawY+(j-CurMap.MapY)*TileH,TileW,TileH);
            tileNo:DrawSprite2D_simple(texTileNo,startDrawX+(i-CurMap.MapX)*TileW,
                                    startDrawY+(j-CurMap.MapY)*TileH,TileW,TileH);
            else
              DrawSprite2D_simple(texTileNo,startDrawX+(i-CurMap.MapX)*TileW,
                                  startDrawY+(j-CurMap.MapY)*TileH,TileW,TileH);
          end;
        end
        else
          DrawSprite2D_simple(texTileEmpty,startDrawX+(i-CurMap.MapX)*TileW,
                              startDrawY+(j-CurMap.MapY)*tileH,TileW,TileH);
      end;
  DrawMiniMap;
end;

//------------------------------------------------------------------------------
function FreeSizeForRoom(w,h: integer): boolean;
var i,j,roomW,roomH: integer;
    count:           integer;
begin
  for i:= 1+scrollScreen to MapW-scrollScreen-w do
    for j:= 1+scrollScreen to MapH-scrollScreen-h do
    begin
      if FreeTile(CurMap.MapCell[i,j].tile,flagForCreateRoom) then
      begin
        count:= 0;
        for roomW := i-notWall to i+w+notWall do
          for roomH := j-notWall to j+h+notWall do
          begin
            if not FreeTile(CurMap.MapCell[roomW,roomH].tile,flagForCreateRoom) then
              count:= count+1;
          end;
        if count = 0 then
        begin
          FreeSizeForRoom:= true;
          exit;
        end;
      end;
    end;
  FreeSizeForRoom:= False;
end;

//------------------------------------------------------------------------------
function FreeTileForRoom(x,y,w,h: integer): boolean;
var i,j:   integer;
    count: integer;
begin
  count:= 0;
  for i:= x-notWall to x+w+notWall do
    for j:= y-notWall to y+h+notWall do
      if not FreeTile(CurMap.MapCell[i,j].tile,flagForCreateRoom) then
              count:= count+1;

  if count = 0 then
    FreeTileForRoom:= true
  else
    FreeTileForRoom:= False;
end;

//------------------------------------------------------------------------------
function FreeDoor(x,y,vector: integer):boolean;
var i: integer;
begin
  case vector of
  vectorLeft:begin
               FreeDoor:= true;
               for i:= x to x-FreeDoorTile do
                 if not FreeTile(CurMap.MapCell[i,y].tile,tileRoom) then
                 begin
                   FreeDoor:= false;
                   exit;
                 end;
             end;
  vectorTop:begin
               FreeDoor:= true; 
               for i:= y to y-FreeDoorTile do
                 if not FreeTile(CurMap.MapCell[x,i].tile,tileRoom) then
                 begin
                   FreeDoor:= false;
                   exit;
                 end;
             end;
  vectorRight:begin
               FreeDoor:= true; 
               for i:= x to x+FreeDoorTile do
                 if not FreeTile(CurMap.MapCell[i,y].tile,tileRoom) then
                 begin
                   FreeDoor:= false;
                   exit;
                 end;
             end;
  vectorDown:begin
               FreeDoor:= true; 
               for i:= y to y+FreeDoorTile do
                 if not FreeTile(CurMap.MapCell[x,i].tile,tileRoom) then
                 begin
                   FreeDoor:= false;
                   exit;
                 end;
             end;
  else
    FreeDoor:= false;
  end;
end;

//------------------------------------------------------------------------------
procedure FillArrayDoor(x,y,n,v: integer);
begin
  SetLength(CurMap.ArrayDoors,length(CurMap.ArrayDoors)+1);
  CurMap.ArrayDoors[length(CurMap.ArrayDoors)-1].x:= x;
  CurMap.ArrayDoors[length(CurMap.ArrayDoors)-1].y:= y;
  CurMap.ArrayDoors[length(CurMap.ArrayDoors)-1].numRoom:= n;
  CurMap.ArrayDoors[length(CurMap.ArrayDoors)-1].active:= true;
end;

//------------------------------------------------------------------------------
procedure MapGenerate(level: integer);
var NumRoom:             integer;//- 
    SizeRoomX,SizeRoomY: integer;// 
    NumExitRoom:         integer;//-   
    FlagExitRoom:        integer;
    DoorVector:          integer;
    i,rx,ry:             integer;
    roomX, roomY:        integer;
    doorx, doory:        integer;
begin
  roomX:= 1;
  roomY:= 1;
  CurMap.Level:= level;
  NumRoom:= Random(maxRoomNum-minRoomNum)+minRoomNum;
  //   
  for i := 1 to NumRoom do
  begin
    //  
    SizeRoomX:= Random(maxRoomSize-minRoomSize)+minRoomSize;
    SizeRoomY:= Random(maxRoomSize-minRoomSize)+minRoomSize;
    if FreeSizeForRoom(SizeRoomX,SizeRoomY) then
    //     ,     
    begin
      while not FreeTileForRoom(roomx,roomy,SizeRoomX,SizeRoomY) do
      begin
        FreeMapPoint(roomX,roomY,flagForCreateRoom);
      end;

      // 
      //      - 
      if SizeRoomX*SizeRoomY < 15 then
        NumExitRoom:= random(2)+1
      else
        NumExitRoom:= random(3)+1;
      FlagExitRoom:= 0;
      while FlagExitRoom <> NumExitRoom do
      begin
        //     
        DoorVector:= Random(4);
        case DoorVector of
          vectorLeft:begin
                      doorx:= roomx-1;
                      doory:= random(SizeRoomY-1)+roomy;
                        if FreeDoor(doorx,doory,vectorLeft) then
                        //      
                        begin
                          FillArrayDoor(doorx-LengthPathForDoor,doory,i,vectorLeft);
                          CurMap.MapCell[doorx,doory].tile:= tileDoor;
                          for rx:= doorx-LengthPathForDoor to doorx-1 do
                          begin
                            CurMap.MapCell[rx,doory].tile:= tileGround;
                          end;
                          FlagExitRoom:= FlagExitRoom+1;
                        end;
                     end;
          vectorTop:begin
                      doorx:= random(SizeRoomX-1)+roomx;
                      doory:= roomy-1;
                        if FreeDoor(doorx,doory,vectorTop) then
                        //      
                        begin
                          FillArrayDoor(doorx,doory-LengthPathForDoor,i,vectorTop);
                          CurMap.MapCell[doorx,doory].tile:= tileDoor;
                          for ry:= doory-LengthPathForDoor to doory-1 do
                          begin
                            CurMap.MapCell[doorx,ry].tile:= tileGround;
                          end;
                          FlagExitRoom:= FlagExitRoom+1;
                        end;
                    end;
          vectorRight:begin
                      doorx:= roomx+SizeRoomX;
                      doory:= random(SizeRoomY-1)+roomy;
                        if FreeDoor(doorx,doory,vectorRight) then
                        //      
                        begin
                          FillArrayDoor(doorx+LengthPathForDoor,doory,i,vectorRight);
                          CurMap.MapCell[doorx,doory].tile:= tileDoor;
                          for rx:= doorx+1 to doorx+LengthPathForDoor do
                          begin
                            CurMap.MapCell[rx,doory].tile:= tileGround;
                          end;
                          FlagExitRoom:= FlagExitRoom+1;
                        end;
                      end;
          vectorDown:begin
                      doorx:= random(SizeRoomX-1)+roomx;
                      doory:= roomy+SizeRoomY;
                        if FreeDoor(doorx,doory,vectorDown) then
                        //      
                        begin
                          FillArrayDoor(doorx,doory+LengthPathForDoor,i,vectorDown);
                          CurMap.MapCell[doorx,doory].tile:= tileDoor;
                          for ry:= doory+1 to doory+LengthPathForDoor do
                          begin
                            CurMap.MapCell[doorx,ry].tile:= tileGround;
                          end;
                          FlagExitRoom:= FlagExitRoom+1;
                        end;
                     end;
        end;
      end;
      // 
      for rx:= roomx to roomX+SizeRoomX-1 do
        for ry:= roomy to roomY+SizeRoomY-1 do
        begin
          CurMap.MapCell[rx,ry].tile:= tileRoom;
        end;
    end;

  end;

  //   
  CreatePath;
  //     
  FillWall;
  SetLength(CurMap.ArrayDoors,0);
end;

//------------------------------------------------------------------------------
procedure MapInit;
var tmpNum: integer;
begin
  texTileGroud:= tex.Load('data/ground.bmp',false,false);
  texTileWall:= tex.Load('data/wall.bmp',false,false);
  texTileNo:= tex.Load('data/no.bmp',false,false);
  texTileRoom:= tex.Load('data/room.bmp',false,false);
  texTileEmpty:= tex.Load('data/empty.bmp',false,false);
  texTileDoor:= tex.Load('data/door.bmp',false,false);
  for tmpNum:= 1 to 2 do
    texTrap[tmpNum]:= tex.Load(PChar('data/trap'+inttostr(tmpNum)+'.tga'),false,false);
  texPortal:= tex.Load('data/portal.tga',false,false);
end;

//------------------------------------------------------------------------------
procedure MapWriteCoord(x, y: integer);
begin
  CurMap.MapX:= x;
  CurMap.MapY:= y;
  if x < 1 then
    CurMap.MapX:= 1;
  if y < 1 then
    CurMap.MapY:= 1;
  if x+viewScreen > MapW then
    CurMap.MapX:= MapW-viewScreen;
  if y+viewScreen > MapH then
    CurMap.MapY:= MapH-viewScreen;
end;

//------------------------------------------------------------------------------
procedure CreatePath;
var i:              integer;
    FindDoor:       boolean;
    numberDoor:     integer;
    FindNumDoor:    integer;
    RandomDoor:     integer;
    flagRandomDoor: boolean;
//    
procedure FindPath(x,y,x1,y1: integer);
var px,py,lpx,lpy: integer;
    pathEnd:       boolean;
    pathNext:      boolean;
    vecTile:       integer;
//      
function FreePath(nx,ny,lx,ly: integer): boolean;
var areaX,areaY: integer;
begin
  FreePath:= true;

  for areaX:= nx-FreePathTile to nx+FreePathTile do
  begin
    for areaY:= ny-FreePathTile to ny+FreePathTile do
    begin
      if not FreeTile(CurMap.MapCell[areaX,areaY].tile,flagForCreatePath) then
      begin
        FreePath:= false;
        exit;
      end;
    end;
  end;

  if (nx = lx) and (ny = ly) then
    FreePath:= false;
end;
begin
  pathEnd:= false;
  px:= x;
  py:= y;
  lpx:= px;
  lpy:= py;
  vecTile:= ConstVecTile;
  while not pathEnd do
  //    
  begin
    pathNext:= false;
    //    
    if (px > x1) and (pathNext=false) then
    begin
      if FreePath(px-1,py,lpx,lpy) then
      begin
        CurMap.MapCell[px-1,py].tile:= tileGround;
        lpx:= px;
        lpy:= py;
        px:= px-1;
        vecTile:= ConstVecTile;
        pathNext:= true;
      end;
    end;
    if (px < x1) and (pathNext=false) then
    begin
      if FreePath(px+1,py,lpx,lpy) then
      begin
        CurMap.MapCell[px+1,py].tile:= tileGround;
        lpx:= px;
        lpy:= py;
        px:= px+1;
        vecTile:= ConstVecTile;
        pathNext:= true;
      end;
    end;
    if (py > y1) and (pathNext=false) then
    begin
      if FreePath(px,py-1,lpx,lpy) then
      begin
        CurMap.MapCell[px,py-1].tile:= tileGround;
        lpx:= px;
        lpy:= py;
        py:= py-1;
        vecTile:= ConstVecTile;
        pathNext:= true;
      end;
    end;
    if (py < y1) and (pathNext=false) then
    begin
      if FreePath(px,py+1,lpx,lpy) then
      begin
        CurMap.MapCell[px,py+1].tile:= tileGround;
        lpx:= px;
        lpy:= py;
        py:= py+1;
        vecTile:= ConstVecTile;
        pathNext:= true;
      end;
    end;

    //     
    if (FreePath(px-1,py,lpx,lpy) = true) and (pathNext=false) and
       ((py < y1) or (py > y1)) and ((vecTile = constVecTile) or (vecTile = vectorLeft)) then
    begin
      CurMap.MapCell[px-1,py].tile:= tileGround;
      lpx:= px;
      lpy:= py;
      px:= px-1;
      vecTile:= vectorLeft;
      pathNext:= true;
    end;
    if (FreePath(px+1,py,lpx,lpy)= true) and (pathNext=false) and
       ((py < y1) or (py > y1)) and ((vecTile = constVecTile) or (vecTile = vectorRight)) then
    begin
      CurMap.MapCell[px+1,py].tile:= tileGround;
      lpx:= px;
      lpy:= py;
      px:= px+1;
      vecTile:= vectorRight;
      pathNext:= true;
    end;
    if (FreePath(px,py-1,lpx,lpy) = true) and (pathNext = false) and
       ((px < x1) or (px > x1)) and ((vecTile = constVecTile) or (vecTile = vectorTop)) then
    begin
      CurMap.MapCell[px,py-1].tile:= tileGround;
      lpx:= px;
      lpy:= py;
      py:= py-1;
      vecTile:= vectorTop;
      pathNext:= true;
    end;
    if (FreePath(px,py+1,lpx,lpy) = true) and (pathNext = false) and
       ((px < x1) or (px > x1)) and ((vecTile = constVecTile) or (vecTile = vectorDown)) then
    begin
      CurMap.MapCell[px,py+1].tile:= tileGround;
      lpx:= px;
      lpy:= py;
      py:= py+1;
      vecTile:= vectorDown;
      pathNext:= true;
    end;

    //    
    if ((px-1 = x1) and (py = y1)) or
       ((px+1 = x1) and (py = y1)) or
       ((py-1 = y1) and (px = x1)) or
       ((py+1 = y1) and (px = x1)) then
      pathEnd:= true;

    //    ,    ,  
    if pathNext = false then
      pathEnd:= true;

  end;
end;

begin
  numberDoor:= 0;
  for i:= 0 to Length(CurMap.ArrayDoors)-1 do
  begin
    FindNumDoor:= i;
    if numberDoor <> CurMap.ArrayDoors[i].numRoom then
    begin
      //   
      numberDoor:= CurMap.ArrayDoors[i].numRoom;
      FindDoor:= false;
      while not FindDoor do
      begin
        if FindNumDoor = Length(CurMap.ArrayDoors)-1 then
        begin
          //       
          FindNumDoor:= 1;
          FindDoor:= true;
        end
        else
        begin
          //    
          FindNumDoor:= FindNumDoor+1;
          if CurMap.ArrayDoors[i].numRoom <> CurMap.ArrayDoors[FindNumDoor].numRoom then
            FindDoor:= true;
        end;
      end;
      //  ,    
      FindPath(CurMap.ArrayDoors[i].x,CurMap.ArrayDoors[i].y,
               CurMap.ArrayDoors[FindNumDoor].x,CurMap.ArrayDoors[FindNumDoor].y);

    end
    else
    begin
      //Random ,       ,
      //     
      flagRandomDoor:= false;
      RandomDoor:= 0;
      while not flagRandomDoor do
      begin
        RandomDoor:= random(Length(CurMap.ArrayDoors));
        if CurMap.ArrayDoors[i].numRoom <> CurMap.ArrayDoors[RandomDoor].numRoom then
          flagRandomDoor:= true;
      end;
      FindPath(CurMap.ArrayDoors[i].x,CurMap.ArrayDoors[i].y,
               CurMap.ArrayDoors[RandomDoor].x,CurMap.ArrayDoors[RandomDoor].y);
    end;

  end;
end;

//------------------------------------------------------------------------------
procedure FillWall;
var i,j: integer;
    x,y: integer;
begin
  for i:= 1 to MapW do
    for j:= 1 to MapH do
    begin
      if FreeTile(CurMap.MapCell[i,j].tile,flagForCreateRoom) then
        for x:= i-1 to i+1 do
         for y:= j-1 to j+1 do
           if (MapTypeTile(x,y) = tileRoom) or
              (MapTypeTile(x,y) = tileGround) or
              (MapTypeTile(x,y) = tileDoor) then
             CurMap.MapCell[i,j].tile:= tileWall;
    end;
end;

//------------------------------------------------------------------------------
function MapTypeTile(x, y: integer): integer;
begin
  MapTypeTile:= CurMap.MapCell[x,y].tile;
end;

//------------------------------------------------------------------------------
procedure DrawMiniMap;
var x,y: integer;
const pointSize        = 4;
      StartMiniMapX    = 530;
      StartMiniMapY    = 32;
      ColorMiniHero    = COLOR_HERO;
      ColorMiniMonster = COLOR_MONSTERS;
      ColorMiniItems   = COLOR_ITEMS;
      ColorMiniPortal  = COLOR_PORTAL;
      ColorMiniTraps   = Color_Traps;
begin
  glColor3f(0.5,0.3,0.3);
  DrawQuads(StartMiniMapX,StartMiniMapY,(MapW-1)*pointSize,(MapH-1)*pointSize);
  for x:= 1+scrollScreen to MapW-scrollScreen do
  begin
    for y:= 1+scrollScreen to MapH-scrollScreen do
    begin
      glPointSize(pointSize);
      if CurMap.MapCell[x,y].visible then
        SetColorGL(ArrayColorMiniMap[CurMap.MapCell[x,y].tile])
      else
        SetColorGL(COLOR_EMPTY);
      glBegin(GL_POINTS);
        glVertex2f(StartMiniMapX+((x-1)*pointSize),StartMiniMapY+((y-1)*pointSize));
      glend;
    end;
  end;
  for x:= 0 to length(GameItems)-1 do
  begin
    glPointSize(pointSize);
    if CurMap.MapCell[GameItems[x].X,GameItems[x].Y].visible then
      SetColorGL(ColorMiniItems)
    else
      SetColorGL(COLOR_EMPTY);
    glBegin(GL_POINTS);
      glVertex2f(StartMiniMapX+((GameItems[x].X-1)*pointSize),StartMiniMapY+((GameItems[x].y-1)*pointSize));
    glend;
  end;
  for x:= 0 to length(TrapArray)-1 do
  begin
    if TrapArray[x].Visible then
    begin
      glPointSize(pointSize);
      SetColorGL(ColorMiniTraps);
      glBegin(GL_POINTS);
        glVertex2f(StartMiniMapX+((TrapArray[x].X-1)*pointSize),StartMiniMapY+((TrapArray[x].y-1)*pointSize));
      glend;
    end;
  end;
  glPointSize(pointSize);
  if CurMap.MapCell[Portal.x,Portal.y].visible then
    SetColorGL(ColorMiniPortal)
  else
    SetColorGL(COLOR_EMPTY);
  glBegin(GL_POINTS);
    glVertex2f(StartMiniMapX+((Portal.x-1)*pointSize),StartMiniMapY+((Portal.y-1)*pointSize));
  glend;
  for x:= 0 to length(MonstersMap)-1 do
  begin
    glPointSize(pointSize);
    if CurMap.MapCell[MonstersMap[x].x,MonstersMap[x].y].visible then
      SetColorGL(ColorMiniMonster)
    else
      SetColorGL(COLOR_EMPTY);
    glBegin(GL_POINTS);
      glVertex2f(StartMiniMapX+((MonstersMap[x].X-1)*pointSize),StartMiniMapY+((MonstersMap[x].y-1)*pointSize));
    glend;
  end;
  glPointSize(pointSize);
  SetColorGL(ColorMiniHero);
  glBegin(GL_POINTS);
    glVertex2f(StartMiniMapX+((Player.FCoordX-1)*pointSize),StartMiniMapY+((Player.FCoordY-1)*pointSize));
  glend;
end;

//------------------------   ----------------------------
procedure MapItemGenerate;
var itmNumMap: integer;
    itmNum: integer;
    itmRnd: integer;
    itmRnd1: integer;
    itmRndSpec: integer;
    itmRndLvlSpec: integer;
    itmNumRnd: integer;
    itmX, itmY: integer;
    itmTmpSpec: TSpecial;
    itmTmpLvlSpec: integer;
begin
  SetLength(GameItems,0);
  // -   
  itmNumMap:= random(itmMaxMap-itmMinMap)+itmMinMap;
  for itmNum:= 1 to itmNumMap do
  begin
    itmTmpLvlSpec:= lvlSpec0;
    itmRnd:= Random(2);
    //  ,  
    if itmRnd = 0 then
    begin
      // 
      itmRnd:= Random(2);
      if itmRnd = 0 then
      begin
        // , , , .
        itmRnd:= Random(5);
        //-----------  . -----------------
        itmRndLvlSpec:= Random(CurMap.Level);
        if itmRndLvlSpec < 10 then
          itmTmpLvlSpec:= lvlSpec1
        else if (itmRndLvlSpec >= 10) and (itmRndLvlSpec < 20) then
          itmTmpLvlSpec:= lvlSpec2
        else if (itmRndLvlSpec >=20) and (itmRndLvlSpec < 30) then
          itmTmpLvlSpec:= lvlSpec3
        else if (itmRndLvlSpec >=30) and (itmRndLvlSpec < 40) then
          itmTmpLvlSpec:= lvlSpec4
        else if (itmRndLvlSpec >= 40) then
          itmTmpLvlSpec:= lvlSpec5;
        //----------------------------------------------------------------------
        case itmRnd of
          0:begin
              //, 
              itmRnd1:= random(5);
              case itmRnd1 of
                0:begin
                    //
                    itmRndSpec:= Random(CurMap.Level);
                    if itmRndSpec > 7 then
                    begin
                      // .
                      itmTmpSpec:= SpecAttack;
                    end
                    else
                    begin
                      // .
                      itmTmpSpec:= SpecNone;
                      itmTmpLvlSpec:= lvlSpec0;
                    end;
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmSword,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,1);
                  end;
                1:begin
                    //
                    itmRndSpec:= Random(CurMap.Level);
                    if itmRndSpec > 7 then
                    begin
                      itmTmpSpec:= SpecAttack;
                    end
                    else
                    begin
                      itmTmpSpec:= SpecNone;
                      itmTmpLvlSpec:= lvlSpec0;
                    end;
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmAxe,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,1);
                  end;
                2:begin
                    //
                    itmRndSpec:= Random(CurMap.Level);
                    if itmRndSpec > 7 then
                    begin
                      itmTmpSpec:= SpecAttack;
                    end
                    else
                    begin
                      itmTmpSpec:= SpecNone;
                      itmTmpLvlSpec:= lvlSpec0;
                    end;
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmSpear,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,1);
                  end;
                3:begin
                    //
                    itmRndSpec:= Random(CurMap.Level);
                    if itmRndSpec > 7 then
                    begin
                      itmTmpSpec:= SpecAttack
                    end
                    else
                    begin
                      itmTmpSpec:= SpecNone;
                      itmTmpLvlSpec:= lvlSpec0;
                    end;
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmBow,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,1);
                  end;
                4:begin
                    //
                    itmRndSpec:= Random(CurMap.Level);
                    if itmRndSpec > 7 then
                    begin
                      itmTmpSpec:= SpecArmor
                    end
                    else
                    begin
                      itmTmpSpec:= SpecNone;
                      itmTmpLvlSpec:= lvlSpec0;
                    end;
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmArmor,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,1);
                  end;
              else
                begin
                  //
                  itmNumRnd:= Random(10)+3+round(CurMap.Level/5);
                  FreeMapPoint(itmX,itmY,flagForCreateObj);
                  ItemsCreate(itmAmmo,itmX,itmY,lvlSpec0,SpecNone,true,itmNumRnd);
                end;
              end;
            end;
          1,3,4:begin
              //
              itmRnd1:= random(5);
              itmRndSpec:= Random(CurMap.Level);
              if itmRndSpec > 7 then
              begin
                itmTmpSpec:= SpecHeal;
              end
              else
              begin
                itmTmpSpec:= SpecNone;
                itmTmpLvlSpec:= lvlSpec0;
              end;
              case itmRnd1 of
                0:begin
                    //
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmHealPotion,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,3);
                  end;
                1:begin
                    //
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmFatiguePotion,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,2);
                  end;
                2:begin
                    //
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmStrPotion,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,2);
                  end;
                3:begin
                    //
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmConPotion,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,2);
                  end;
                4:begin
                    //
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmArmorPotion,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,2);
                  end;
              else
                begin
                  //
                  itmNumRnd:= Random(10)+3+round(CurMap.Level/5);
                  FreeMapPoint(itmX,itmY,flagForCreateObj);
                  ItemsCreate(itmAmmo,itmX,itmY,lvlSpec0,SpecNone,true,itmNumRnd);
                end;
              end;
            end;
          2:begin
              //.
              itmRnd1:= random(4);
              case itmRnd1 of
                0:begin
                    // 
                    itmRndSpec:= Random(CurMap.Level);
                    if itmRndSpec > 7 then
                    begin
                      itmTmpSpec:= SpecAttack;
                    end
                    else
                    begin
                      itmTmpSpec:= SpecNone;
                      itmTmpLvlSpec:= lvlSpec0;
                    end;
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmRingCold,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,2);
                  end;
                1:begin
                    // 
                    itmRndSpec:= Random(CurMap.Level);
                    if itmRndSpec > 7 then
                    begin
                      itmTmpSpec:= SpecTime;
                    end
                    else
                    begin
                      itmTmpSpec:= SpecNone;
                      itmTmpLvlSpec:= lvlSpec0;
                    end;
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmRingParalize,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,2);
                  end;
                2:begin
                    // 
                    itmRndSpec:= Random(CurMap.Level);
                    if itmRndSpec > 7 then
                    begin
                      itmTmpSpec:= SpecHeal;
                    end
                    else
                    begin
                      itmTmpSpec:= SpecNone;
                      itmTmpLvlSpec:= lvlSpec0;
                    end;
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmRingClear,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,3);
                  end;
                3:begin
                    // 
                    itmRndSpec:= Random(CurMap.Level);
                    if itmRndSpec > 7 then
                    begin
                      itmTmpSpec:= SpecAttack
                    end
                    else
                    begin
                      itmTmpSpec:= SpecNone;
                      itmTmpLvlSpec:= lvlSpec0;
                    end;
                    FreeMapPoint(itmX,itmY,flagForCreateObj);
                    ItemsCreate(itmRingFire,itmX,itmY,itmTmpLvlSpec,itmTmpSpec,true,2);
                  end;
              else
                begin
                  //
                  itmNumRnd:= Random(10)+3+round(CurMap.Level/5);
                  FreeMapPoint(itmX,itmY,flagForCreateObj);
                  ItemsCreate(itmAmmo,itmX,itmY,lvlSpec0,SpecNone,true,itmNumRnd);
                end;
              end;
            end;
        else
          begin
            itmNumRnd:= Random(10)+3+round(CurMap.Level/5);
            FreeMapPoint(itmX,itmY,flagForCreateObj);
            ItemsCreate(itmAmmo,itmX,itmY,lvlSpec0,SpecNone,true,itmNumRnd);
          end;
        end;
      end
      else
      begin
        //   
        itmRnd:= Random(2);
        if itmRnd = 0 then
        begin
          //
          itmNumRnd:= Random(10)+3+round(CurMap.Level/10);
          FreeMapPoint(itmX,itmY,flagForCreateObj);
          ItemsCreate(itmAmmo,itmX,itmY,lvlSpec0,SpecNone,true,itmNumRnd);
        end
        else
        begin
          //
          itmNumRnd:= Random(round(CurMap.Level/10))+1;
          FreeMapPoint(itmX,itmY,flagForCreateObj);
          ItemsCreate(itmFood,itmX,itmY,lvlSpec0,SpecNone,true,itmNumRnd);
        end;
      end;
    end
    else
    begin
      //
      itmNumRnd:= Random(40)+15*CurMap.Level;
      FreeMapPoint(itmX,itmY,flagForCreateObj);
      ItemsCreate(itmGold,itmX,itmY,lvlSpec0,SpecNone,true,itmNumRnd);
    end;
  end;
end;

//------------------------------------------------------------------------------
procedure TrapCreate(tx,ty:integer; tType: TTypeTrap);
var trpNum: integer;
begin
  SetLength(TrapArray,length(TrapArray)+1);
  trpNum:= length(TrapArray)-1;
  TrapArray[trpNum].x:= tx;
  TrapArray[trpNum].y:= ty;
  TrapArray[trpNum].Visible:= False;
  TrapArray[trpNum].typeTrap:= tType;
  if tType = TrpPoisonDrotic then
    TrapArray[trpNum].id:= 1
  else
    TrapArray[trpNum].id:= 2;
end;

//------------------------------------------------------------------------------
procedure TrapDraw;
var trpNum: integer;
begin
  for trpNum:= 0 to length(TrapArray)-1 do
  begin
    if (CurMap.MapX <= TrapArray[trpNum].X) and (TrapArray[trpNum].X <= CurMap.MapX+viewScreen-1)
    and (CurMap.MapY <= TrapArray[trpNum].Y) and (TrapArray[trpNum].Y <= CurMap.MapY+viewScreen-1)
    and (TrapArray[trpNum].Visible = true) then
    DrawSprite2D_simple(texTrap[TrapArray[trpNum].ID],
    startDrawX+(TrapArray[trpNum].X-CurMap.MapX)*TileW,
    startDrawY+(TrapArray[trpNum].Y-CurMap.MapY)*tileH,TileW,TileH);
  end;;
end;

//------------------------------------------------------------------------------
procedure MapTrapGenerate;
var trpRndNum: integer;
    trpNum: integer;
    trpRndType: integer;
    trpX, trpY: integer;
begin
  SetLength(TrapArray,0);
  trpRndNum:= Random(trpMaxLevel-trpMinLevel)+trpMinLevel+(CurMap.Level div 10);
  for trpNum:= 1 to trpRndNum do
  begin
    trpRndType:= Random(10);
    if trpRndType = 0 then
    begin
      FreeMapPoint(trpX,trpY,flagForCreateObj);
      TrapCreate(trpX,trpY,TrpFireBall);
    end
    else
    begin
      FreeMapPoint(trpX,trpY,flagForCreateObj);
      TrapCreate(trpX,trpY,TrpPoisonDrotic);
    end;
  end;
end;

end.
