unit GameTypes;

interface
uses
  OpenGL, GLTypes, u_winapi;

type
  TGameObject = class
  private
    Texture : Integer;
    GLList : GLuint;
  public
    MustDie : Boolean;
    TypeName : String;
    Radius : Single;
    Pos : TGLVector;
    HAngle, Tilt, Bank, Health : Single;
    Collision : Boolean;
    Moving : Boolean;
    scrX, scrY : Integer;
    Trigger1 : Boolean;
    Blend : Boolean;
    procedure Project; virtual;
    procedure Render; virtual;
    procedure Move; virtual;
    procedure DoCollision(CollisionedWith : TObject); virtual;
    procedure LoadModel(const FileName : String; const Skin : String = ''); virtual;
  end;

implementation
uses
  uModelManager, TextureManager;

{ TGameObject }

procedure TGameObject.DoCollision(CollisionedWith: TObject);
begin
//
end;

procedure TGameObject.LoadModel(const FileName: String; const Skin : String = '');
begin
  GLList := ModelManager.LoadModelToGLList(FileName);
  if Skin <> '' then
    Texture := TextureMngr.LoadTexture(Skin);
end;

procedure TGameObject.Move;
begin
//
end;

procedure TGameObject.Project;
var
  Viewport : Array [0..3] of GLint;
  mvMatrix, ProjMatrix : Array [0..15] of GLdouble;
  wx, wy, wz : GLdouble; //  
begin
  //   
  glGetIntegerv (GL_VIEWPORT, @Viewport);
  glGetDoublev (GL_MODELVIEW_MATRIX, @mvMatrix);
  glGetDoublev (GL_PROJECTION_MATRIX, @ProjMatrix);
  //      
  gluProject (Pos.X, Pos.Y, Pos.Z, @mvMatrix, @ProjMatrix, @Viewport, wx, wy, wz);

  scrX := Trunc(wx) + 125;
  scrY := Screen_Height - Trunc(wy) - 90;
end;

procedure TGameObject.Render;
begin
  glCallList(GLList); 
end;

end.
