unit Sheduler;

interface
uses
  Windows;

type
  TShedulerVarType = (stInteger, stWord, stDword, stBoolean, stCharPointer);

  TShedulerTask = record
    StartTime : Cardinal;
    EndTime : Cardinal;
    Variable : Pointer;
    VarType : TShedulerVarType;
    Value : DWORD;
  end;

  TSheduler = class
  private
    Tasks : array of TShedulerTask;
  public
    procedure SetVarAfter(Variable : Pointer; Value : DWORD; VarType : TShedulerVarType; Miliseconds : Cardinal);
    procedure Tick;
  end;

var
  Shedulr : TSheduler;

implementation

{ TSheduler }


procedure TSheduler.SetVarAfter(Variable: Pointer; Value: DWORD;
  VarType: TShedulerVarType; Miliseconds: Cardinal);
begin
  SetLength(Tasks, Length(Tasks)+1);
  Tasks[High(Tasks)].StartTime := GetTickCount;
  Tasks[High(Tasks)].EndTime := GetTickCount + Miliseconds;
  Tasks[High(Tasks)].Variable := Variable;
  Tasks[High(Tasks)].VarType := VarType;
  Tasks[High(Tasks)].Value := Value;
end;

procedure TSheduler.Tick;
var
  I : Integer;
begin
  for I := High(Tasks) downto 0 do
  begin
    if GetTickCount >= Tasks[I].EndTime then
    begin
      dword(Tasks[I].Variable^) := Tasks[I].Value;
      Tasks[I] := Tasks[High(Tasks)];
      SetLength(Tasks, Length(Tasks)-1);
    end;
  end;
end;

end.
