program topgun;
uses
  Windows,
  OpenGL,
  u_opengl in 'u_opengl.pas',
  u_winapi in 'u_winapi.pas',
  g_move in 'g_move.pas',
  u_scripting in 'u_scripting.pas',
  g_global_vars in 'g_global_vars.pas',
  glCamera in 'glCamera.pas',
  GLTypes in 'GLTypes.pas',
  TheGame in 'TheGame.pas',
  GameTypes in 'GameTypes.pas',
  HUD in 'HUD.pas',
  TextureManager in 'TextureManager.pas',
  SoundManager in 'SoundManager.pas',
  Utils in 'Utils.pas',
  Player in 'Player.pas',
  Menus in 'Menus.pas',
  StartupAnunce in 'StartupAnunce.pas',
  Sheduler in 'Sheduler.pas',
  uGameObjects in 'uGameObjects.pas',
  uAmbience in 'uAmbience.pas',
  uModelManager in 'uModelManager.pas',
  Projectiles in 'Projectiles.pas',
  MissionStart in 'MissionStart.pas',
  Log in 'Log.pas',
  Billboards in 'Billboards.pas';

var
  Msg : TMsg;

procedure Render;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  case GameMode of
    modeAnounce: Anouncement.Render;
    modeMenu: ActiveMenu.Render;
    modeGame: Game.Render;
    modeMission : MissionBrief.Render;
  end;

  SwapBuffers(DC);
end;

procedure KeyDown(Key : Byte);
begin

  if GameMode = modeMenu then
    ActiveMenu.KeyDown(Key) else
  if GameMode = modeGame then
    Game.KeyDown(Key);
  if  GameMode = modeAnounce then
    Anouncement.AnyKey(Key) else
  if GameMode = modeMission then
    MissionBrief.KeyDown(Key);

end;

procedure KeyUp(Key : Byte);
begin

end;

procedure MouseMove(X,Y : Integer);
begin
  if GameMode = modeMenu then
    ActiveMenu.MouseMove(X, Y);
end;

procedure MouseDown(X,Y:Integer);
begin
  if GameMode = modeMenu then
    ActiveMenu.MouseDown(X, Y);
  {if (GameMode = modeGame) or (GameMode = modeMission) then
  begin
    Capture_Mouse := True;
    ShowCursor(False);
  end;}
end;

procedure MouseUp(X,Y:Integer);
begin
  {if GameMode = modeGame then
  begin
    Capture_Mouse := False;
    ShowCursor(True);
  end;}
end;

procedure CharType(Ch : Char);
begin

end;

begin
  InitLog;

  Windows_Create(800, 600, 0, 0, True, 'TopGun2009', '"Top Gun 2009" by KEFIR(kefir.rwr@gmail.com) Special for igdc.ru contest #50 [aug-sep 2009]');
  Shedulr := TSheduler.Create;
  
  KeyDownProc := KeyDown;
  KeyUpProc := KeyUp;
  MouseMoveProc := MouseMove;
  MouseDownProc := MouseDown;
  CharProc := CharType;

  SoundMngr := TSoundManager.Create(Window_Handle);
  SoundMngr.LogHandler := LogStr;
  //SoundMngr.Enabled := False;

  OpenGL_Init(Window_Handle);
  glViewport(0, 0, 800, 600);
  //Windows_FullScreen;

  ModelManager := TModelManager.Create;
  ModelManager.Log := @LogStr;

  TextureMngr := TTextureManager.Create;
  TextureMngr.SetTransparentRGBColor(255, 0, 255);
  TextureMngr.LogHandler := LogStr;

  MovingInitialize;
  MenuSound := SoundMngr.LoadSound('data\music\topgun_anthem.ogg', True);
  SoundMngr.Play(MenuSound);

  Anouncement := TStartAnouncement.Create;

  while not Quit_Hit do
  begin
    if PeekMessage(Msg, Window_Handle, 0, 0, PM_NOREMOVE) then
    begin
      if GetMessage(Msg, 0, 0, 0) then //     
      begin
        TranslateMessage(Msg); //  
        DispatchMessage(Msg);  //    WndProc
      end;
    end else
    begin
      Windows_Tick;
      MovingExecute;
      //try
      Render;
      {  except
          on E:Exception do
            LogStr('Excep.: ' + E.Message);
        end;}
    end;
    Shedulr.Tick;
  end;

end.
