unit Use_Parts;     {particles mechanism}

interface

uses
 Global,
 Use_Geometry,
 OpenGl,
 Use_OpenGL;

const
  Max_Parts = 5000;

type
  TPart = record
    Point:TPoint;
    Vector:TPoint;
    Size:Single;
    life:byte;
    tip:byte;
  end;
 {
  TParticle = record
    Point:TPoint;
    Vector:TPoint;
    life:byte;
    tip:byte;
  end;      }

procedure add_Particle(X,Y,Z,VX,VY,VZ:single;tip:byte;life:byte);    
procedure Render_Parts;
procedure Engine_Parts;

Var Parts:array [0..Max_Parts] of TPart;
 Wind:TPoint = (0,0,0);
 k:TPoint = (0,0,0);
 Mash:Single=1;
 Parts_Tex:cardinal;
 
implementation

procedure put_part(P:TPoint;Mash:single;tip,life:byte);
Var
  Size:single;
  A,B:byte;
begin
  case tip of
    0:begin
        A:=2;
        B:=0;
        size:=0.02+(100-life)*0.005;
        glColor4f(5,5,5,life/50);
    end;            {dim}
    1:begin
        A:=3;
        B:=0;
        size:=0.02+(100-life)*0.005;
        glColor4f(5,5,5,life/50);
    end;            {dim}
    2:begin
        A:=0;
        B:=0;
        size:=0.02+(80-life)*0.005;
        glColor4f(5,5,5,life/50);
    end;{ogon}
    3:begin
        A:=1;
        B:=0;
        size:=0.02+(80-life)*0.005;
        glColor4f(5,5,5,life/50);
    end;{ogon}
    4:begin
        A:=2;
        B:=0;
        size:=0.01+(100-life)*0.001;
        glColor4f(5,5,5,life/40);
    end;            {dim}
    5:begin
        A:=3;
        B:=0;
        size:=0.01+(100-life)*0.001;
        glColor4f(5,5,5,life/40);
    end;            {dim}
    6:begin
        A:=0;
        B:=0;
        size:=0.01+(100-life)*0.001;
        glColor4f(5,5,5,life/40);
    end;
    7:begin   {white_points}
        A:=3;
        B:=1;
        size:=0.03;
        glColor4f(5,5,5,life/60);
    end;            {smf}
    8:begin
        A:=3;
        B:=1;
        size:=0.03;
        glColor4f(5,5,5,life/60);
    end;            {vsplesk}
    9:begin
        A:=3;
        B:=1;
        size:=0.03;
        glColor4f(5,5,5,life/60);
    end;            {vsplesk}
    10:begin
        A:=3;
        B:=1;
        size:=0.03;
        glColor4f(5,5,5,life/60);
    end;            {vsplesk}
  end;
 gltexcoord2f(A*0.25,B*0.25);
 glVertex3f((P[0]-Size)*Mash,(P[1]-Size)*Mash,P[2]*Mash);
 gltexcoord2f(A*0.25+0.25,B*0.25);
 glVertex3f((P[0]+Size)*Mash,(P[1]-Size)*Mash,P[2]*Mash);
 gltexcoord2f(A*0.25+0.25,B*0.25+0.25);
 glVertex3f((P[0]+Size)*Mash,(P[1]+Size)*Mash,P[2]*Mash);
 gltexcoord2f(A*0.25,B*0.25+0.25);
 glVertex3f((P[0]-Size)*Mash,(P[1]+Size)*Mash,P[2]*Mash);
end;


procedure Render_Parts;
Var i:integer;
begin
 glBindTexture(GL_Texture_2d,Parts_Tex);
 glBegin(GL_Quads);    
 for i:=Max_Parts downto 0 do
   if Parts[i].life>0 then
    begin
     Put_Part(minus(Parts[i].Point,Point(k[0],k[1],k[2])),Mash,Parts[i].tip,Parts[i].life);
    end;
 glEnd;
 {}
end;

procedure Engine_Parts;
Var i:integer;
begin
 for i:=0 to Max_Parts do
   if Parts[i].life>0 then
 begin
   Parts[i].life:=Parts[i].life-1;
   Parts[i].Point:=plus(Parts[i].Point,Parts[i].Vector);
   Parts[i].Point:=plus(Parts[i].Point,Wind);
   case Parts[i].tip of 
    0,1:;{dim}
    2,3:if (Parts[i].life=5) then
      begin
        add_Particle(Parts[i].Point[0],Parts[i].Point[1],Parts[i].Point[2],
                Parts[i].Vector[0],Parts[i].Vector[1],Parts[i].Vector[2],Random(2),50);
      end;{ogon}
    4,5:;{malii dim}
   end;
 end;
 {}
end;

procedure add_Particle(X,Y,Z,VX,VY,VZ:single;tip:byte;life:byte);
Var i:integer;
begin
 for i:=0 to Max_Parts do
  if Parts[i].life=0 then
   begin
    Parts[i].Point:=Point(X,Y,Z);   
    Parts[i].Vector:=Point(VX,VY,VZ);
    Parts[i].life:=life;
    Parts[i].tip:=tip;
    break;
   end;  
 {}
end;

end.
