unit Use_Triang_terrain;

interface

uses OpenGl,Use_Geometry;

const
 TW = 256;//main rel
 TB = 64;

type
 TTerrain_triang = record
  H:Array [0..TW+1,0..TW+1] of byte;
  C:Array [0..TW+1,0..TW+1] of byte;
 end;

type
 TMap = record
  H:Array [0..TB+1,0..TB+1] of boolean;
  C:Array [0..TB+1,0..TB+1] of byte;
  N:Array [0..TB+1,0..TB+1] of TPoint;
  OB:Array [0..TB+1,0..TB+1] of boolean;
 end;



{ TArrayIndex = record
  i,j:integer;
 end; }

procedure gen_Terrain(Var Terr:TTerrain_triang);
procedure Draw_Terr(Terr:TTerrain_triang);
procedure Draw_T(T:TMap;A,B,C:TPoint);  
procedure Find_Norms(Var T:TMap;A,B,C:TPoint);
procedure gen_T(Var T:TMap);

var
 Terr:TTerrain_triang;
 T:TMap;
 F:Array[0..19]of TMap; 

implementation

procedure Set_Color(Color:byte);
begin
 case Color of
  0:glColor3f(1.2,1,0.5);{desert}
  1:glColor3f(1.1,0.6,0.1);{rocks e2990c}
  2:glColor3f(1.2,0.2,0.2);{spice}
 //3:glColor3f();{desert}
 end;
end;

procedure Draw_T(T:TMap;A,B,C:TPoint);
Var i,j:integer;{counters}
IV,JV:TPoint;{triang vectors}
HN,NN:TPoint;{heigth vector}
Norm,VA,VB,VC:TPoint;
kx,ky,kz,
TS:Single;
begin
 ///A - Point of begin
 IV:=(multi(minus(C,A),1/TB));
 JV:=(multi(minus(B,C),1/TB));
 HN:=multi(Get_Normal(A,B,C),Get_S(A,B)/TB*0.1);
 NN:=Point(0,0,0);
 glBegin(GL_TRIANGLES);
 glColor4f(5,5,5,5);
 for i:=0 to TB-1 do
  for j:=0 to i do
   begin
    VA:=plus(A,(plus(multi(IV,(i  )),multi(JV,(j  )))));
    VB:=plus(A,(plus(multi(IV,(i+1)),multi(JV,(j+1)))));
    VC:=plus(A,(plus(multi(IV,(i+1)),multi(JV,(j  )))));
    if T.H[i  ,j  ] then VA:=plus(VA,HN);
    if T.H[i+1,j+1] then VB:=plus(VB,HN);
    if T.H[i+1,j  ] then VC:=plus(VC,HN);
    glNormal3fv(@T.N[i,j]);
    Set_Color(T.C[i,j]);
    glVertex3fv(@VA);       
    glNormal3fv(@T.N[i+1,j+1]);
    Set_Color(T.C[i+1,j+1]);
    glVertex3fv(@VB);      
    glNormal3fv(@T.N[i+1,j]);
    Set_Color(T.C[i+1,j]);
    glVertex3fv(@VC);
   end;
 glColor4f(0,0,5,5);
 for i:=1 to TB-1 do
  for j:=0 to i-1 do
   begin
    VA:=plus(A,plus(multi(IV,(i  )),multi(JV,(j  ))));
    VB:=plus(A,plus(multi(IV,(i  )),multi(JV,(j+1))));
    VC:=plus(A,plus(multi(IV,(i+1)),multi(JV,(j+1))));
    if T.H[i  ,j  ] then VA:=plus(VA,HN);
    if T.H[i  ,j+1] then VB:=plus(VB,HN);
    if T.H[i+1,j+1] then VC:=plus(VC,HN);
    glNormal3fv(@T.N[i,j]);
    Set_Color(T.C[i,j]);
    glVertex3fv(@VA);
    glNormal3fv(@T.N[i,j+1]);
    Set_Color(T.C[i,j+1]);
    glVertex3fv(@VB);
    glNormal3fv(@T.N[i+1,j+1]);
    Set_Color(T.C[i+1,j+1]);
    glVertex3fv(@VC);
   end;
 glEnd;
end;

procedure Find_Norms(Var T:TMap;A,B,C:TPoint);
Var i,j:integer;{counters}
IV,JV:TPoint;{triang vectors}
HN,NN:TPoint;{heigth vector}
N1,N2,N3,VA,VB,VC:TPoint;
begin
 ///A - Point of begin
 IV:=(multi(minus(C,A),1/TB));
 JV:=(multi(minus(B,C),1/TB));
 HN:=multi(Get_Normal(A,B,C),Get_S(A,B)/TB*0.4);
 NN:=Point(0,0,0);
 for i:=0 to TB+1 do
  for j:=0 to TB+1 do
   begin
    T.N[i,j]:=Get_Normal(A,B,C);
   end;
{ for i:=1 to TB-1 do
  for j:=1 to i do
   begin
    VA:=plus(A,(plus(multi(IV,(i  )),multi(JV,(j  )))));
    VB:=plus(A,(plus(multi(IV,(i+1)),multi(JV,(j+1)))));
    VC:=plus(A,(plus(multi(IV,(i+1)),multi(JV,(j  )))));
    if T.H[i  ,j  ] then VA:=plus(VA,HN);
    if T.H[i+1,j+1] then VB:=plus(VB,HN);
    if T.H[i+1,j  ] then VC:=plus(VC,HN);
    N1:=Get_Normal(VA,VB,VC);
    VA:=plus(A,(plus(multi(IV,(i  )),multi(JV,(j  )))));
    VB:=plus(A,(plus(multi(IV,(i-1)),multi(JV,(j  )))));
    VC:=plus(A,(plus(multi(IV,(i  )),multi(JV,(j+1)))));
    if T.H[i  ,j  ] then VA:=plus(VA,HN);
    if T.H[i-1,j  ] then VB:=plus(VB,HN);
    if T.H[i  ,j+1] then VC:=plus(VC,HN);
    N2:=Get_Normal(VA,VB,VC);
    VA:=plus(A,(plus(multi(IV,(i  )),multi(JV,(j  )))));
    VB:=plus(A,(plus(multi(IV,(i  )),multi(JV,(j-1)))));
    VC:=plus(A,(plus(multi(IV,(i-1)),multi(JV,(j-1)))));
    if T.H[i  ,j  ] then VA:=plus(VA,HN);
    if T.H[i  ,j-1] then VB:=plus(VB,HN);
    if T.H[i-1,j-1] then VC:=plus(VC,HN);
    N3:=Get_Normal(VA,VB,VC);
    T.N[i,j]:=Normalize(middle(N1,N2,N3));
   end;            }
end;

procedure Draw_Terr(Terr:TTerrain_triang);
Var i,j:integer;
num:integer;
mash,hm,
kx,ky,kz,
TS:Single;
Norm:TPoint;
begin
 mash:=1.3;
 hm:=0.02;
 kx:=0;
 kx:=0;
 kz:=-5.8;
// kx:=TW/2*Mash;
 ky:=TW/1.8*Mash;
 ts:=0.86;

 glBegin(GL_TRIANGLES);
 glColor4f(5,5,5,5);
 for i:=0 to TW-1 do
  for j:=0 to i do
   begin
    norm:=Get_Normal(
        Point((-(i+1)*0.5+(j))*mash-kx  ,((i+1)*ts)*mash-ky,Terr.H[i+1,j]*hm-kz),
        Point((-(i+1)*0.5+(j+1))*mash-kx,((i+1)*ts)*mash-ky,Terr.H[i+1,j+1]*hm-kz),
        Point((-(i)*0.5+(j))*mash-kx,((i)*ts)*mash-ky      ,Terr.H[i,j]*hm-kz));
    glColor3f(1,0.8,0);
    glNormal3fv(@norm);
    glTexCoord2f(1,0);
    glVertex3f((-(i+1)*0.5+(j))*mash-kx  ,((i+1)*ts)*mash-ky,Terr.H[i+1,j]*hm-kz);
    glTexCoord2f(0.5,0.85);
    glVertex3f((-(i+1)*0.5+(j+1))*mash-kx,((i+1)*ts)*mash-ky,Terr.H[i+1,j+1]*hm-kz);
    glTexCoord2f(0,0);
    glVertex3f((-(i)*0.5+(j))*mash-kx,((i)*ts)*mash-ky      ,Terr.H[i,j]*hm-kz);
   end;
 glColor4f(0,0,5,5);
 for i:=1 to TW-1 do
  for j:=0 to i-1 do
   begin
    norm:=Get_Normal(
        Point((-(i)*0.5+(j))*mash-kx    ,((i)*ts)*mash-ky  ,Terr.H[i,j]*hm-kz),
        Point((-(i+1)*0.5+(j+1))*mash-kx,((i+1)*ts)*mash-ky,Terr.H[i+1,j+1]*hm-kz),
        Point((-(i)*0.5+(j+1))*mash-kx  ,((i)*ts)*mash-ky  ,Terr.H[i,j+1]*hm-kz));
    glColor3f(1,0.8,0);
    glNormal3fv(@norm);
    glTexCoord2f(0.5,0.85);
    glVertex3f((-(i)*0.5+(j))*mash-kx    ,((i)*ts)*mash-ky  ,Terr.H[i,j]*hm-kz);
    glTexCoord2f(1,0);
    glVertex3f((-(i+1)*0.5+(j+1))*mash-kx,((i+1)*ts)*mash-ky,Terr.H[i+1,j+1]*hm-kz);
    glTexCoord2f(1.5,0.85);
    glVertex3f((-(i)*0.5+(j+1))*mash-kx  ,((i)*ts)*mash-ky  ,Terr.H[i,j+1]*hm-kz);
   end;
 glEnd;
end;

procedure gen_Terrain(Var Terr:TTerrain_triang);
Var i,j,z,x:integer;
begin
 for i:=0 to TW+1 do
  for j:=0 to TW+1 do
   begin
    Terr.H[i,j]:=Random(55)+100;
   end;
 for i:=0 to trunc((TW+1)/2) do
  for j:=0 to trunc((TW+1)/2) do
   begin
    Terr.H[i*2,j*2]:=Random(255);
   end;
 for i:=0 to (TW+1) do
   begin
    Terr.H[i,0]:=127;
   // Terr.H[i,1]:=127;
    Terr.H[TW,i]:=127;
    Terr.H[TW+1,i]:=127;
    Terr.H[i,i]:=127;
   end;
 for z:=0 to 3 do
 begin
 for i:=0 to (TW+1) do {edge smooth}
   begin
    Terr.H[i,0]:=127;
   // Terr.H[i,1]:=127;
    Terr.H[TW,i]:=127;
    Terr.H[TW+1,i]:=127;
    Terr.H[i,i]:=127;
   end;
 for i:=1 to TW do
  for j:=1 to TW do
   begin
    Terr.H[i,j]:=trunc(
       (Terr.H[i+1,j]+Terr.H[i,j+1]+Terr.H[i+1,j+1]+
        Terr.H[i-1,j]+Terr.H[i,j-1]+Terr.H[i-1,j-1])/6);
   end;{ }
 end;
 z:=127;x:=127;
 for i:=1 to TW do
  for j:=1 to TW do
   begin
    if Terr.H[i,j]<z then z:=Terr.H[i,j];
    if Terr.H[i,j]>x then x:=Terr.H[i,j];
   end;
 for i:=0 to TW+1 do
  for j:=0 to TW+1 do
   begin
    Terr.H[i,j]:=Terr.H[i,j]-z;
    Terr.H[i,j]:=Round((Terr.H[i,j]/(x-z)*255));
   end;
 for i:=0 to (TW+1) do
   begin
    Terr.H[i,0]:=127;
   // Terr.H[i,1]:=127;
    Terr.H[TW,i]:=127;
    Terr.H[TW+1,i]:=127;
    Terr.H[i,i]:=127;
   end;
end;

procedure gen_T(Var T:TMap);
Var i,j,z,x:integer;
begin
 for i:=0 to TB+1 do
  for j:=0 to TB+1 do
   begin
    T.H[i,j]:=Random(3)=0;
    T.H[i,j]:=T.H[i,j] and (Random(2)=0);
   end;
 for i:=0 to TB+1 do
   begin
    T.H[i,0]:=false;
    T.H[i,1]:=false;
    T.H[TB,i]:=false;
    T.H[TB-1,i]:=false;
    T.H[i,i]:=false;
    T.H[i+1,i]:=false;
    T.H[i-1,i]:=false;
   { T.H[i-3,i-3]:=false;
    T.H[i+3,i+3]:=false;   }
  {  Terr.H[TW,i]:=127;
    Terr.H[TW+1,i]:=127;
    Terr.H[i,i]:=127;  }
   end;
 for i:=0 to TB+1 do
  for j:=0 to TB+1 do
   begin
    if T.H[i,j] then T.C[i,j]:=1 else T.C[i,j]:=0;
   end;
end;   

end.
