unit _Planet;

interface

Uses
  Windows,
  Global,
  OpenGL,
  Use_OpenGl,
  Use_JPG,
  Use_Geometry,
  Use_3d;

const
  Sector_Size = 64;
  Max_Units = 1000;
  Clear_Graph = 20;
  Max_owp = (1024*8-1);
  Max_way = 63;
  Stop_way = 6;
  Max_Sel_Units = 20;

type
  TFace = TVector3i;
  TWay = record  {connections beetween tiles}
   z,i,j:byte;{sector/x/y}
  end;

  TPath = array [0..Max_way] of TWay;

  TOpen_Way_Point = record  {connections beetween tiles}
   stat:byte;{status of cell - to none clear array}
   z,i,j:byte;{sector/x/y}
   cost:integer;{way to go}
   way:integer;{way from begin}
  end;


  TCoord = array [0..1] of integer;
  TGraph = array [0..5] of TWay;{for path find}

  TSector = record
   H:Array [0..Sector_Size+1,0..Sector_Size+1] of boolean;{Heigth - rocks/sand}
   C:Array [0..Sector_Size+1,0..Sector_Size+1] of byte;   {color 0-sand 1-rocks 2- spice}
   N:Array [0..Sector_Size+1,0..Sector_Size+1] of TPoint; {Normals}
   Pl:Array [0..Sector_Size+1,0..Sector_Size+1] of TPlane;{plain conditions - for selection and optimize}
   Poz:Array [0..Sector_Size+1,0..Sector_Size+1] of TPozition;{pozitionon this cell - for objects render}
   SP:Array [0..Sector_Size+1,0..Sector_Size+1] of TCoord;{coordinates on the screen}
   Units:Array [0..Sector_Size+1,0..Sector_Size+1] of integer;{units -1 - none!}
   Graph:Array [0..Sector_Size+1,0..Sector_Size+1] of TGraph;{connections between cells for path find}
   WP:Array [0..Sector_Size+1,0..Sector_Size+1] of byte;{for path find}
   Back_Way:Array [0..Sector_Size+1,0..Sector_Size+1] of TWay;{for path find - back way link}
   Back_gr:Array [0..Sector_Size+1,0..Sector_Size+1] of byte;
   Viz:boolean; {vizibility - for optimizing}
  end;

  TOpen_Way_Point_List = record
   owp:Array [0..Max_Owp] of TOpen_Way_Point;
  end;

{$REGION 'TUnit'}
  TUnit = record
   Tip:byte;{unit type}
   {0-none
   1-harvester
   2-quad
   3-tank
   4-launcher
   5-soldier
   6-heavy
   7-canon}
   poz:TWay;
   H:boolean;
   H_v:single;
   way:TPath;{num of way or 6-stop}
   way_command:byte;
   anim:integer;
   Life,Fool_Life:integer;{current/fool life}
   ang,need_ang:single;
   Side:byte;{side of conflict}
   Rad:single;{fire radius}
   Damage:byte;{damage}
   Reload,current_Reload:byte;{speed of reloading}
   action:byte;{current action 0 - stand 1-move}
   pt:TPoint;{for move animation}
   speed,current_speed:integer;{speed in tacts}
   wpx,wpy,wpz:byte;{way point and sector}
   {for anim}
  end;
{$ENDREGION}

{$REGION 'TSky_box'}
  TSky_Box = class
    private
     Venchik:Array[0..36,0..2] of TVect;
     Venchik_Norm:Array[0..36] of TPoint;
     sky:Array [0..18,0..18] of TPoint;
     sky_Norm:Array [0..18,0..18] of TPoint;
     Star_tex:Cardinal;
     Sun_tex:Cardinal;
     li:Single;{merge ligth var}
     Anim:Single;
    public
      l_p:TPlane;
      procedure put_Venchik;
      procedure put_SkyBox;
      procedure Put_Sky;
      constructor Create(star_fn,sun_fn:String);
      procedure Put_StarBox;                    
      procedure Put_Sun;
      procedure Set_Ligth();
  end;
{$ENDREGION}

{$REGION 'TPlanet'}
  TPlanet = class
    private
      Points:array[0..11] of TPoint;{points - base of planet}
      Faces:array[0..19] of TFace;  {faces of planetar sectors}
      planetar_mode:byte;{face(sector) division counter - for spherize planet}
      {texture coordinates for ground tiles}
      Tile_Faces:array[0..15] of TFace;
      Tile_Points:array[0..19] of TVect;
      {texture (for orbital view)}
      Tex_Points:array[0..16] of TVect; {points of the faces on the texture}
      Tex_Faces:array[0..19] of TFace;  {texture faces}
      Planet_tex:cardinal;              {texture for planet}
      Tex_w:integer;                    {tex width/height}
      Tex_h:integer;
      {path find vars}
      OWP:TOpen_Way_Point_List;
      owp_count:integer;
      Sel_Units:Array [0..Max_Sel_Units] of integer;
      Sel_Units_Count:integer;
      wp_tip:byte;{0-human 1-tank 2-worm etc}
      sx,sy,sz:byte;{start x,y and sector}
      ex,ey,ez:byte;{end x,y and sector}
      cx,cy,cz:byte;{current(best) x,y,sector waypoint}
      {path find proc}
      function Get_cost(nx,ny,nz,ex,ey,ez:byte):integer;
      procedure Add_OWP(x,y,z:byte;way:integer);
      procedure Add_Open(wp:TWay;px,py,pz,pw:byte;way:integer;tip:byte);
      procedure Add_Nearest(_x,_y,_z:byte;_way:integer);
      function Find_Best_Open:boolean;{find best open point}
      function gen_way(bx,by,bz,fx,fy,fz:byte):TPath;
      {for planet generation}
      procedure Find_Normals(Var T:TSector;A,B,C:TPoint);{find point normals - for planet sperize}
      procedure Gen_Sector(Var T:TSector);{generate Maps}
      procedure Gen_planet;{creating of all coords of planet}
      procedure Gen_tileset;{creating coords to link tileset and tiles}
      procedure Gen_Pozitions;{creating of all coords of Self}
      {for render}
      procedure Set_Color(Color:byte);
      procedure Set_G_Color(Color:byte);
      procedure Draw_Tex_Sector(TA,TB,TC:TVect;A,B,C:TPoint);{put triang map piece with texture}
      procedure Draw_Triand_Sector(TA,TB,TC:TVect;PA,PB,PC:TPoint;level:byte);{put triang textured map piese with ABC Coords and like sphere from center(by radius)}
      procedure Draw_Spherical_Sector(Var T:TSector;A,B,C:TPoint);{put triang map piese with ABC Coords and like sphere from center(by radius)}
      {procedures for render of planet map}
      procedure Draw_Flat_Sector(Var T:TSector;A,B,C:TPoint);
      procedure Gen_planetar_Texture(Var Tex:cardinal);{generate of ground texture}
    public
      Sector:array [0..19] of TSector;
      Units:array [0..Max_Units] of TUnit;
      {texture for ground tiles}
      Ground_tex:cardinal;              {texture for planet}
      Rad:single;{radius of planet}
      Orbital_view:boolean;{state - is view from the orbit enabled}
      MV:byte; {view stage}
      {Pozition of the reaper Point on the Planet}
      Reaper:TPoint;
      CH,NH:Single;{Camera height/need heigth}
      {Pozition on the planet(reaper euler pozition)}
      Poz:TPozition;
      Camera:TPozition;{!main pozition}
      {selection}
      sel_coord:TCoord;
      sel_Sector:byte;
      sel_unit:integer;
      {pozition - for map view}
      Render_type:Cardinal;
      Test:String;
      Need_Poz:TVect;{need pozition eyler - on the earth}
      EndProc:boolean;
      Current_Poz,View_Poz:TVect;{current pos}{camera view on map view mode -> transform to need for animation}
      {for wp}
      stat_shift:byte;{status change for none clean arrays}
      rezult:byte;{pf result}
      Unit_Simbol_vis:boolean;
      Constructor Create(tiles_filename:string);
      {path find}
      function Find_Way(bx,by,bz,fx,fy,fz:byte):TPath;
      {units}
      function Create_Unit(z,x,y,tip,side:byte;Life,damage,reload:integer;rad:single;speed:integer):integer;
      procedure Draw_Units();
      procedure Draw_Units_items();
      procedure Move_Units();
      procedure Send_Unit(x,y:integer);
      {finding visible triang point for selection}
      procedure Find_Select;
      procedure Find_Planes;
      procedure Select(x,y:integer);
      procedure Select_Rect(ax,ay,bx,by:integer);
      {procedure set transformation matrix to need pozition}
      procedure Set_View(AX,AY:Single);
      procedure Move_View(X,Y:integer);
      procedure Change_Render_type;
      {render of the planet}
      procedure draw_Planet;
      {path find}
      procedure Gen_Way_Point;
  end;

{$ENDREGION}

function Face(a,b,c:integer):TFace;
procedure Create_Texture(Var Tex:cardinal);{create clear texture}

Var
Planet:TPlanet;
Sky_Box:TSky_Box;
{models}
  _Quad,_Tank,_Bash,_Laun,
  _Sold,_Heavy,_Worm:TShadow_Mesh;
  _Q,_T,_L,_S:Array [0..5] of Cardinal;



implementation

{$REGION 'Sky_Box'}
constructor TSky_Box.Create(star_fn,sun_fn:String);
var i,j:byte;
begin
 for i:=0 to 36 do
   begin
     Self.Venchik[i,0]:=Vector(Get_X_V(i*10,Planet.Rad+22),Get_Y_V(i*10,Planet.Rad+18));
     Self.Venchik[i,1]:=Vector(Get_X_V(i*10,Planet.Rad-2),Get_Y_V(i*10,Planet.Rad-5));
     Venchik_Norm[i]:=Point(Get_X_V(i*10,1),Get_Y_V(i*10,1),0);
   end;
 for i:=0 to 18 do
  for j:=0 to 18 do
   begin
     Self.sky_Norm[i,j]:=Point(Get_X_V(j*10-90,Get_X_V(i*20,1)),
                          Get_X_V(j*10-90,Get_Y_V(i*20,1)),
                          Get_Y_V(j*10-90,1));
     Self.sky[i,j]:=multi(Self.Sky_Norm[i,j],1100);
   end;
 LoadJPGTexture(star_fn,Self.Star_tex);
 LoadJPGAlphaTexture(205,255,255,sun_fn,Self.Sun_tex);
end;

procedure TSky_Box.Set_Ligth();
begin
 {ligth}
 Anim:=Get_R(Anim+0.01);
 l_p[0]:=Get_X_V(anim,5000); l_p[1]:=Get_Y_V(anim,5000); l_p[2]:=0{-1000}; l_p[3]:=1;
 { }
 glLightFV(Gl_LIGHT0,Gl_Position,@l_p);
 l_p[0]:=1; l_p[1]:=0.95; l_p[2]:=0.95; l_p[3]:=1;
 glLightFV(Gl_LIGHT0,GL_DIFFUSE,@l_p);
 if Planet.MV>4 then
  li:=li*0.95+(-0.2)*0.05 else li:=li*0.95+(0.05)*0.05;//20;//-(Planet.MV/20+0.2);
 l_p[0]:=li; l_p[1]:=li; l_p[2]:=li; l_p[3]:=1;
 glLightFV(Gl_LIGHT0,GL_AMBIENT,@l_p);
 {/light}
end;

procedure TSky_Box.Put_Sky;
begin
 if Planet.Orbital_view then
  begin
    Put_StarBox;
    put_Sun;
    glEnable(GL_Light0);
    put_Venchik;
  end else
  begin
    Put_StarBox;
    put_SkyBox;  
    put_Sun;
  end;
end;

procedure TSky_Box.put_SkyBox;
var i,j:byte;
begin
 glEnable(GL_BLEND);
 glDisable(gl_Texture_2d);
 glColor4f(1,0.7,0.3,0.3);
 glPushMatrix();
 glRotatef(Anim,0,0,1); 
 glRotatef(90,0,1,0);
 glBegin(gl_Quads);
 for i:=0 to 17 do
 for j:=0 to 17 do
   begin
     glColor4f(5,3.7,1.8,2/18*(j+1)-0.7);
     glNormal3fv(@Self.Sky_Norm[i,j+1]);
     glVertex3fv(@Self.Sky[i,j+1]);
     glNormal3fv(@Self.Sky_Norm[i+1,j+1]);
     glVertex3fv(@Self.Sky[i+1,j+1]);
     glColor4f(5,3.7,1.8,2/18*(j)-0.7);
     glNormal3fv(@Self.Sky_Norm[i+1,j]);
     glVertex3fv(@Self.Sky[i+1,j]);    
     glNormal3fv(@Self.Sky_Norm[i,j]);
     glVertex3fv(@Self.Sky[i,j]);
   end;
 glEnd;
 glPopMatrix();
 glDisable(GL_BLEND);      { }
end;

procedure TSky_Box.put_Venchik;
var i:byte;V_P:TPozition;
begin
 glEnable(GL_BLEND);
 glPushMatrix();
 V_P:=transpone(Planet.Poz);
 glMultMatrixf(@V_P);
 glDisable(gl_Texture_2d);
 glBegin(gl_Quads);
 for i:=0 to 35 do
   begin
     glColor4f(1,0.7,0.3,1);
     glNormal3fv(@Self.Venchik_Norm[i+1]);
     glVertex2fv(@Self.Venchik[i+1,1]);
     glColor4f(1,0.7,0.3,0);
     glVertex2fv(@Self.Venchik[i+1,0]);
     glNormal3fv(@Self.Venchik_Norm[i]);
     glVertex2fv(@Self.Venchik[i,0]);
     glColor4f(1,0.7,0.3,1);
     glVertex2fv(@Self.Venchik[i,1]);
   end;
 glEnd;
 glPopMatrix();
 glDisable(GL_BLEND);      { }
end;

procedure TSky_Box.Put_StarBox;
Var Size:integer;num:single;
begin
 Size:=1200;
 num:=1.2;
 glColor4f(5,5,5,1);
 glEnable(GL_TEXTURE_2D);
 glPushMatrix();
 glRotatef(Anim-90,0,0,1);
 //stars
 glBindTexture(GL_Texture_2d,Star_tex);
 glBegin(Gl_Quads);    {down}
 glTexCoord2D(0,num);
 glVertex3f( Size, -Size,Size);
 glTexCoord2D(num,num);
 glVertex3f( -Size,-Size,Size);
 glTexCoord2D(num,0);
 glVertex3f(-Size,  Size,Size);
 glTexCoord2D(0,0);
 glVertex3f( Size,  Size,Size);
 glTexCoord2D(num,0);      {up}
 glVertex3f( Size,  Size,-Size);
 glTexCoord2D(0,0);    
 glVertex3f(-Size,  Size,-Size);
 glTexCoord2D(0,num);
 glVertex3f( -Size,-Size,-Size);
 glTexCoord2D(num,num);
 glVertex3f( Size, -Size,-Size);
 glTexCoord2D(0,num);     {left}
 glVertex3f( Size, -Size, -Size);
 glTexCoord2D(num,num);   
 glVertex3f( -Size,-Size, -Size);
 glTexCoord2D(num,0);
 glVertex3f(-Size, -Size,  Size);
 glTexCoord2D(0,0);
 glVertex3f( Size, -Size,  Size);
 glTexCoord2D(0,num);     {rigth}
 glVertex3f( Size,  Size,  Size);
 glTexCoord2D(num,num);    
 glVertex3f(-Size,  Size,  Size);
 glTexCoord2D(num,0);
 glVertex3f(-Size,  Size, -Size);
 glTexCoord2D(0,0);
 glVertex3f( Size,  Size, -Size);
 glTexCoord2D(0,num);     {front}
 glVertex3f( -Size, Size,  Size);
 glTexCoord2D(num,num);   
 glVertex3f( -Size,-Size,  Size);
 glTexCoord2D(num,0);
 glVertex3f(-Size, -Size, -Size);
 glTexCoord2D(0,0);
 glVertex3f( -Size, Size, -Size);
 glTexCoord2D(0,num);     {back}
 glVertex3f(  Size, Size, -Size);
 glTexCoord2D(num,num);
 glVertex3f(  Size,-Size, -Size);
 glTexCoord2D(num,0);
 glVertex3f(  Size,-Size,  Size);
 glTexCoord2D(0,0);
 glVertex3f(  Size, Size,  Size);
 glend;
 glPopMatrix();
 glDisable(GL_BLEND);      { }
end;
 
procedure TSky_Box.Put_Sun;
Var Size:integer;num:single;
begin
 Size:=800;
 //sun
 glPushMatrix();  
 glEnable(gl_Texture_2d);
 glRotatef(Anim-90,0,0,1);
 glBindTexture(GL_Texture_2d,Sun_Tex);
// enable_bind_tex;  
 glColor4f(5,5,5,1);
 glEnable(GL_BLEND);
 glBegin(Gl_Quads);    {down}
 glTexCoord2D(1,1); glVertex3f( 60,Size, 60);
 glTexCoord2D(0,1); glVertex3f(-60,Size, 60);
 glTexCoord2D(0,0); glVertex3f(-60,Size,-60);
 glTexCoord2D(1,0); glVertex3f( 60,Size,-60);
 glEnd;
 glPopMatrix();
 glDisable(GL_BLEND);      { }
end;
 {$ENDREGION}

{$REGION 'Get_SQ'}
function Get_SQ(A,B:TPoint):Single;{  !( )      (   )}
begin
 Get_SQ:=(B[0]-A[0])*(B[0]-A[0])+(B[1]-A[1])*(B[1]-A[1])+(B[2]-A[2])*(B[2]-A[2]);
end;
{$ENDREGION}

{$REGION 'create_tex  Face Function'}
function Face(a,b,c:integer):TFace;
begin
  Face[0]:=a;
  Face[1]:=b;
  Face[2]:=c;
end;

procedure Create_Texture(Var Tex:cardinal);{create clear texture}
begin
 {create texture}
 glEnable(GL_TEXTURE_2D);
 glGenTextures(1, @Tex);
 glBindTexture(GL_TEXTURE_2D, Tex);
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
end;

{$ENDREGION}

{$REGION 'Creation'}
procedure TPlanet.Change_Render_type;
begin
 if Render_Type=GL_TRIANGLES then
  Render_Type:=GL_LINE_STRIP else
  Render_Type:=GL_TRIANGLES;
end;

Constructor TPlanet.Create(tiles_filename:string);
Var i:byte;{counter}
begin
 Self.Sel_Units_Count:=-1;
 Self.Rad:=150;
 Self.Orbital_view:=true;
 Self.planetar_mode:= 3;
 Self.Tex_w:= 512;
 Self.Tex_h:= 512;
 Self.Need_Poz:=Vector(0,300);
 Self.View_Poz:=Vector(0,300);
 Self.Current_Poz:=Vector(0,0);
 Self.Poz:=Default_TPozition;
 Self.Ground_tex:=Random(255)+1;
 self.stat_shift:=255;//for wp 
 Render_Type:=GL_TRIANGLES;
 Gen_planet;
 Gen_tileset;
 LoadJPGTexture(tiles_filename,Self.Ground_tex);
 for i:=0 to 19 do
   Gen_Sector(Sector[i]);
 for i:=0 to 19 do
  begin
   Find_Normals(Sector[i],
              Self.Points[Self.Faces[i][0]],
              Self.Points[Self.Faces[i][2]],
              Self.Points[Self.Faces[i][1]]);
  end;
 Create_Texture(Self.Planet_tex);
 Gen_planetar_Texture(Self.Planet_tex);
 Self.Find_Planes;
 Self.Gen_Pozitions;
 Gen_Way_Point;
 Find_Way(3,2,0,4,2,0); //for first matrix clear
end;
{$ENDREGION}

{$REGION 'Selection'}
procedure TPlanet.Find_Planes;
Var
i,j,z:byte;
a,b,c:TPoint;
begin
  for z:=0 to 19 do
 //  if (Sector[z].Viz) then {for visible sectors}
      for i:=0 to Sector_Size-1 do
       for j:=0 to i do
     begin
     a:=multi(Sector[z].N[i  ,j  ],Self.Rad);
     b:=multi(Sector[z].N[i+1,j+1],Self.Rad);
     c:=multi(Sector[z].N[i+1,j  ],Self.Rad);
     {plane (uravnenie ploskosti)}
  {ax + by + cz + d = 0 }
  {a}Self.Sector[z].Pl[i,j][0]:= a[1]*(b[2]-c[2]) + b[1]*(c[2]-a[2]) + c[1]*(a[2]-b[2]);
  {b}Self.Sector[z].Pl[i,j][1]:= a[2]*(b[0]-c[0]) + b[2]*(c[0]-a[0]) + c[2]*(a[0]-b[0]);
  {c}Self.Sector[z].Pl[i,j][2]:= a[0]*(b[1]-c[1]) + b[0]*(c[1]-a[1]) + c[0]*(a[1]-b[1]);
  {d}Self.Sector[z].Pl[i,j][3]:= -( a[0] * (b[1]*c[2] - c[1]*b[2]) +
                           b[0] * (c[1]*a[2] - a[1]*c[2]) +
                           c[0] * (a[1]*b[2] - b[1]*a[2]));
   end;
end;


procedure TPlanet.Find_Select;
Var
i,j,z:byte;
F,S:TPoint;
X,Y,null:GLdouble;
L:Single;
viewport:TVector4i;
projection,modelview:TMatrix4d;
begin
 S:=multi(Reaper,(Rad+Get_X_V(View_Poz[1],ch+7))/rad);
 glGetIntegerv(GL_VIEWPORT,@viewport);           //   viewport-a.
 glGetDoublev(GL_PROJECTION_MATRIX,@projection); //   .
 glGetDoublev(GL_MODELVIEW_MATRIX,@modelview);   //   .
  for z:=0 to 19 do
   if (Sector[z].Viz) then {for visible sectors}
      for i:=1 to Sector_Size-1 do
       for j:=1 to i do
        begin
         Sector[z].SP[i,j][0]:=-5;
         L:={a} Sector[z].PL[i,j][0]*S[0]+
            {b} Sector[z].PL[i,j][1]*S[1]+
            {c} Sector[z].PL[i,j][2]*S[2]+
            {d} Sector[z].PL[i,j][3];
         if (L>0) then
          begin
           F:=multi(Sector[z].N[i  ,j  ],Self.Rad);
           gluProject(F[0],F[1],F[2],modelview,projection,viewport,@X,@Y,@null);
           Sector[z].SP[i,j][0]:=Round(X);
           Sector[z].SP[i,j][1]:=Round(Y);
          end;
       end;
end;
                                     
procedure TPlanet.Select_Rect(ax,ay,bx,by:integer);
Var i,j,z:byte;temp:integer;
begin
  if ax>bx then begin temp:=ax;ax:=bx;bx:=temp;end;
  if ay>by then begin temp:=ay;ay:=by;by:=temp;end;
  Self.Sel_Units_Count:=-1;
  test:='';
  for z:=0 to 19 do
   if (Sector[z].Viz) then {for visible sectors}
      for i:=0 to Sector_Size do
       for j:=0 to i do
       begin
        if (Sector[z].SP[i,j][0]>0) then
         if (Sector[z].SP[i,j][0]>=ax) then
          if (Sector[z].SP[i,j][0]<=bx) then
           if (Sector[z].SP[i,j][1]>=ay) then
            if (Sector[z].SP[i,j][1]<=by) then
             begin
              Sel_Coord[0]:=i;
              Sel_Coord[1]:=j;
              Sel_Sector:=z;
              if (Sector[z].Units[i,j]>0) then
               begin
                Sel_Units_Count:=Sel_Units_Count+1;
                Sel_Units[Sel_Units_Count]:=Sector[z].Units[i,j];
                test:=test+intToStr(Sector[z].Units[i,j])+' ';
               end;
             end;
       end;
end;

procedure TPlanet.Select(x,y:integer);
Var
 i,j,z,mi,mj,mz:byte;
 min:integer;
begin
 min:=2000;
  for z:=0 to 19 do
   if (Sector[z].Viz) then {for visible sectors}
      for i:=0 to Sector_Size do
       for j:=0 to i do
       begin
        if (Sector[z].SP[i,j][0]>0) then {for vis pts}
        if (Sector[z].SP[i,j][1]>0) then
         if (abs(x-Sector[z].SP[i,j][0])+abs(y-Sector[z].SP[i,j][1])<min) then
          begin
           min:=abs(x-Sector[z].SP[i,j][0])+abs(y-Sector[z].SP[i,j][1]);
           mi:=i;
           mj:=j;
           mz:=z;
          end;
       end;
 Sel_Coord[0]:=mi;
 Sel_Coord[1]:=mj;
 Sel_Sector:=mz;
{ if (Sector[mz].Units[mi,mj]>0) then
  sel_unit:=Sector[mz].Units[mi,mj];  }
end;
{$ENDREGION}

{$REGION 'Set_view'}
procedure TPlanet.Move_View(X,Y:integer);
begin
   Poz:=multi(Poz,Pozition(Rotate(0.0001*(MV+1)*2*2*pi*Planet.Rad,
        Get_Normal(
        null_TPoint,
        multi(Pozition(Planet.View_Poz[0],Planet.View_Poz[1],1),Point(0,0,1)),
        multi(Pozition(Planet.View_Poz[0],Planet.View_Poz[1],1),Point(X,-Y,1))
        ))));
end;

procedure TPlanet.Set_View(AX,AY:Single);
Var M:TPozition;
begin
 Self.Need_Poz[0]:=Get_R(Self.Need_Poz[0]-AX);
 Self.Need_Poz[1]:=Self.Need_Poz[1]+AY;
 if Self.Need_Poz[1]<280 then Self.Need_Poz[1]:=280;
 if Self.Need_Poz[1]>360 then Self.Need_Poz[1]:=360;
{}
 if (MV>200) then MV:=0;
 if MV>10 then MV:=10;
 Planet.Orbital_view:=MV>4;
 case MV of
  0,1,2:Self.Current_Poz:=Self.Need_Poz;
  3:Self.Current_Poz:=Vector((Need_Poz[0]){*0.8},360-Get_R(360-Need_Poz[1])*0.8);
  4:Self.Current_Poz:=Vector((Need_Poz[0]){*0.5},360-Get_R(360-Need_Poz[1])*0.5);
  5:Self.Current_Poz:=Vector((Need_Poz[0]){*0.3},360-Get_R(360-Need_Poz[1])*0.3);
  6..10:Self.Current_Poz:=Vector((Need_Poz[0]),0);
 end;
 {animate view moving}
    if abs(Self.View_Poz[0]-Self.Current_Poz[0])>0 then
     Self.View_Poz[0]:=Get_R(Self.View_Poz[0]+Head_Rotate(Self.View_Poz[0],Self.Current_Poz[0],2));
   if abs(Self.View_Poz[1]-Self.Current_Poz[1])>0 then
    Self.View_Poz[1]:=Get_R(Self.View_Poz[1]+Head_Rotate(Self.View_Poz[1],Self.Current_Poz[1],2));
 {Transform matrix change}
 
 NH:=(MV*2)*(MV*2); {heigth}
 if (abs(CH-NH)>0.1) then CH:=CH*0.7+NH*0.3 else CH:=NH;
{animation of heigth changing}
 M:=Pozition(Matrix(1,0,0,0,1,0,0,0,1),Point(0,0,CH));
 glMultMatrixf(@M);  {height from camera}
// Camera:=M;
 Planet.Reaper:=multi(M,Planet.Reaper); {Reaper Finding and set}
 Planet.Reaper:=Point(0,0,-Planet.Rad);
 M:=Pozition(Planet.View_Poz[0],Planet.View_Poz[1],1);
 glMultMatrixf(@M);                     {heigth from center of the planet}
// Camera:=multi(Camera,M);
 M:=Pozition(Matrix(1,0,0,0,1,0,0,0,1),Point(0,0,Planet.Rad));
 glMultMatrixf(@M);
 Planet.Reaper:=multi(M,Planet.Reaper);
{rotate of Pozition view}
 glMultMatrixf(@Poz);
 Planet.Reaper:=multi(Poz,Planet.Reaper);
end;
{$ENDREGION}

{$REGION 'Find_way_procedures'}
function TPlanet.Get_cost(nx,ny,nz,ex,ey,ez:byte):integer;
var a,b:TPoint;
begin
 a:=multi(Sector[nz].N[nx,ny],self.Rad);
 b:=multi(Sector[ez].N[ex,ey],self.Rad);
 Get_cost:=2*Round((abs(b[0]-a[0])+abs(b[1]-a[1])+abs(b[2]-a[2])));
end;

procedure TPlanet.Add_OWP(x,y,z:byte;way:integer);
begin
 Self.OWP.owp[OWP_Count].stat:=stat_shift;
 Self.OWP.owp[OWP_Count].i:=x;
 Self.OWP.owp[OWP_Count].j:=y;
 Self.OWP.owp[OWP_Count].z:=z;
 Self.OWP.owp[OWP_Count].cost:=Get_Cost(x,y,z,ex,ey,ez);
 Self.OWP.owp[OWP_Count].way:=way;
 OWP_Count:=OWP_Count+1;
end;

procedure TPlanet.Add_Open(wp:TWay;px,py,pz,pw:byte;way:integer;tip:byte);
var x,y,z:byte;flag:boolean;
begin
 x:=wp.i;
 y:=wp.j;
 z:=wp.z;
 //prepyatstviya!
 case tip of
  0:flag:=(Sector[z].wp[x,y]<stat_shift);//start point
  1:flag:=(Sector[z].Units[x,y]=0) and (Sector[z].wp[x,y]<stat_shift);//for tech
  2:flag:=(Sector[z].Units[x,y]=0) and (Sector[z].wp[x,y]<stat_shift);//for infantry
 end;
 if (x=ex) and (y=ey) and (z=ez) then
{  if (Sector[z].Units[x,y]>0) then
  Rezult:=2 else   }
   begin
    Rezult:=1;  //finish
    flag:=true;
   end;        
 if flag then
     begin
      Sector[z].Back_Way[x,y].i:=px;
      Sector[z].Back_Way[x,y].j:=py;
      Sector[z].Back_Way[x,y].z:=pz;
      Sector[z].Back_gr[x,y]:=pw;
      Sector[z].WP[x,y]:=stat_shift;
      Add_OWP(x,y,z,way);
     end;
end;

procedure TPlanet.Add_Nearest(_x,_y,_z:byte;_way:integer);
var _w:byte;
begin
 for _w:=0 to 5 do
  if (sector[_z].Graph[_x,_y][_w].z<Clear_Graph) then {the way is real}
   begin
    Add_Open(sector[_z].Graph[_x,_y][_w],_x,_y,_z,_w,_way+1,1);
   end;
end;

function TPlanet.Find_Best_Open:boolean;
var i,n,minw:integer;
begin
 n:=-1;{best owp}
 minw:=high(integer);{the best way - the longest}
 for i:=0 to Owp_Count do
   if (OWP.owp[i].stat=stat_shift) then {if this owp from this path find}
    if (OWP.owp[i].way+OWP.owp[i].cost<=minw) then
    begin
     minw:=OWP.owp[i].way+OWP.owp[i].cost;
     n:=i;
    end;
 if n=-1 then begin Rezult:=2;n:=10;end;
 if (minw=high(integer)) then Rezult:=2;
 OWP.owp[n].stat:=stat_shift+1;
 cx:=OWP.owp[n].i;
 cy:=OWP.owp[n].j;
 cz:=OWP.owp[n].z;
 Sector[cz].WP[cx,cy]:=stat_shift+1;
 Add_Nearest(cx,cy,cz,OWP.owp[n].way);
 if (owp_Count>=Max_owp-1) then Rezult:=2;
end;
{$ENDREGION}

{$REGION 'Find_Way'}
function TPlanet.gen_way(bx,by,bz,fx,fy,fz:byte):TPath;
var
  i,j,z:byte;
  way:TWay;f_w:TPath;
  curr:integer;
  f:array[0..Max_owp] of TWay;
begin
 i:=fx;
 j:=fy;
 z:=fz;
 f[0].i:=i;
 f[0].j:=j;
 f[0].z:=z;
 way.i:=i;
 way.j:=j;
 way.z:=z;
 f[0]:=way;
 way:=Sector[z].Back_Way[i,j];
 curr:=1;
 repeat
  i:=way.i;
  j:=way.j;
  z:=way.z;
  f[curr]:=way;//Sector[z].Back_Way[i,j];
  way:=Sector[z].Back_Way[i,j];
  curr:=curr+1;
 until ((curr = Max_owp) or ((way.i=bx) and (way.j=by) and (way.z=bz)));
// test:=intToStr(curr);
 if (f[curr-1].i=way.i) and
    (f[curr-1].j=way.j) and
    (f[curr-1].z=way.z) then curr:=curr-1;//Sector[z].Back_Way[i,j];
 for i:= 0 to Max_way-1 do
  if curr>0 then
   begin
    curr:=curr-1;
    f_w[i]:=f[curr];
   end else f_w[i].z:=Clear_Graph;
 gen_way:=f_w;
end;

function TPlanet.Find_Way(bx,by,bz,fx,fy,fz:byte):TPath;
var
  i,j,z,s:byte;
  way:TWay;
begin
 EndProc:=false;
 stat_shift:=stat_shift+2;
 if (Self.stat_shift>250) then {stat shift overload}
  begin
   stat_shift:=1;
   for z:=0 to 19 do
    for i:=0 to Sector_Size-1 do
     for j:=0 to i do
      begin
       Sector[z].WP[i,j]:=0;
      end;
    end;
 sx:=bx;
 sy:=by;
 sz:=bz;
 ex:=fx;
 ey:=fy;
 ez:=fz;
 Rezult:=0;
 OWP_Count:=0;
 cx:=sx;
 cy:=sy;
 cz:=sz;
 way.i:=cx;
 way.j:=cy;
 way.z:=cz;
 s:=0;
 Add_Open(way,cx,cy,cz,stop_way,0,0);
 Repeat
  if Rezult=2 then  {esli tochka ne dostigima}
   begin
    way:=Sector[fz].Graph[fx,fy][Random(6)];
    if (way.z<clear_Graph) then
     begin
       fx:=way.i;
       fy:=way.j;
       fz:=way.z;
     end;
     s:=s+1;
   end;
  Find_Best_Open;
 Until ((Rezult=1)or (s>5));
 Find_Way:=gen_way(bx,by,bz,fx,fy,fz);
 EndProc:=true;
end;
{$ENDREGION}

{$REGION 'Units'}
function TPlanet.Create_Unit(z,x,y,tip,side:byte;Life,damage,reload:integer;rad:single;speed:integer):integer;
Var i,j:integer;
begin
//   0-none
//   1-harvester
//   2-quad
//   3-tank
//   4-launcher
//   5-soldier
//   6-heavy
//   7-worm
//   8-canon
 for i:=0 to Max_Units do
  if (Units[i].tip=0) then
   begin
    for j:=0 to Max_Way do
     Units[i].way[j].z:=Clear_Graph;
    Units[i].poz.i:=x;
    Units[i].poz.j:=y;
    Units[i].poz.z:=z;
    Units[i].way[0].i:=x;
    Units[i].way[0].j:=y;
    Units[i].way[0].z:=z;
   // Units[i].way[0].z:=Clear_Graph;
    Units[i].way_command:=0;
    Units[i].tip:=tip;
    Units[i].side:=side;
    Units[i].Life:=Life;
    Units[i].Fool_Life:=Life;
    Units[i].Damage:=Damage;
    Units[i].Rad:=Rad;
    Units[i].Reload:=Reload;
    Units[i].current_Reload:=reload;
    Units[i].action:=0;
    Units[i].speed:=speed;
    Units[i].current_speed:=0;
    Units[i].wpx:=Random(Sector_Size-4)+2;
    Units[i].wpy:=Random(Units[i].wpx);
    Units[i].wpz:=Random(20); 
    Units[i].action:=0;
    break;
   end;         
 Self.Sector[z].Units[x,y]:=i;
 Create_Unit:=i;
end;

procedure TPlanet.Draw_Units_items();
var
  i,j,z:byte;
  u:integer;
  p:TPoint;
begin        
 glDisable(GL_Light0);
 for z := 0 to 19 do
   begin
    for i:=0 to Sector_Size-1 do
     for j:=0 to i do
      if Sector[z].Units[i,j]>0 then
       begin
       case Units[Sector[z].Units[i,j]].Side of
        0:glColor3f(4,4,0);
        1:glColor3f(5,0,0);
        2:glColor3f(0,5,0);
        3:glColor3f(0,0,5);
        4:glColor3f(5,5,0);
        5:;
       { 7:begin
            glPushMatrix();
            u:=Sector[z].Units[i,j];
            Units[u].ang:=get_R(Units[u].ang+Head_Rotate(Units[u].ang,Units[u].need_ang,6));
            p:=multi(Units[u].pt,Units[u].current_speed);
            glMultMatrixf(@Sector[z].Poz[i,j]);
            glTranslatef(p[0],p[1],p[2]);
            glRotatef(Units[u].ang+180,0,0,1);
            glTranslatef(0,0,Self.Rad);
            Units[u].anim:=Units[u].anim+10;
            if Units[u].anim>200 then Units[u].anim:=0;
            _Worm.Anim(Units[u].anim/100);
            _Worm.Render(_Worm.Texture);
            glPopMatrix();
          end;   }
     end;
     p:=multi(Sector[z].N[i,j],Self.Rad);
     glBegin(gl_Points);
     glVertex3fv(@p);
     glend;
    end;
 end; 
 glEnable(GL_Light0);
end;

procedure TPlanet.Draw_Units();
var
  i,j,z:byte;
  u:integer;
  p:TPoint;
begin
 for z := 0 to 19 do
 if Sector[z].Viz then
   begin
    for i:=0 to Sector_Size-1 do
     for j:=0 to i do
     if (Sector[z].SP[i,j][0]>=0) then
     if (Sector[z].SP[i,j][1]>=0) then 
     if (Sector[z].SP[i,j][0]<=PW) then
     if (Sector[z].SP[i,j][1]<=PH) then
     if (Sector[z].Units[i,j]>0) then
     case Units[Sector[z].Units[i,j]].Tip of
      0:;//none
      2:begin
          glPushMatrix();
          u:=Sector[z].Units[i,j];
          Units[u].ang:=get_R(Units[u].ang+Head_Rotate(Units[u].ang,Units[u].need_ang,6));
          p:=multi(Units[u].pt,Units[u].current_speed);
          glMultMatrixf(@Sector[z].Poz[i,j]);
          glTranslatef(p[0],p[1],p[2]);
          if Units[u].H and (Units[u].H_v<0.2) then Units[u].H_v:=Units[u].H_v+0.2/Units[u].speed;
          if not Units[u].H and (Units[u].H_v>0) then Units[u].H_v:=Units[u].H_v-0.2/Units[u].speed;
          if Sector[z].H[i,j] then glTranslatef(0,0,Units[u].H_v);
          glRotatef(Units[u].ang+90,0,0,1);
          glTranslatef(0,0,Self.Rad);
          _Quad.Render(_Q[Units[u].Side]);
          glPopMatrix();{}
        end;{quad}
      3:begin
          glPushMatrix();
          u:=Sector[z].Units[i,j];
          Units[u].ang:=get_R(Units[u].ang+Head_Rotate(Units[u].ang,Units[u].need_ang,6));
          p:=multi(Units[u].pt,Units[u].current_speed);
          glMultMatrixf(@Sector[z].Poz[i,j]);
          glTranslatef(p[0],p[1],p[2]);
          if Units[u].H and (Units[u].H_v<0.2) then Units[u].H_v:=Units[u].H_v+0.2/Units[u].speed;
          if not Units[u].H and (Units[u].H_v>0) then Units[u].H_v:=Units[u].H_v-0.2/Units[u].speed;
          if Sector[z].H[i,j] then glTranslatef(0,0,Units[u].H_v);
          glRotatef(Units[u].ang+90,0,0,1);
          glTranslatef(0,0,Self.Rad);
          _Tank.Render(_T[Units[u].Side]);
          _Bash.Render(_T[Units[u].Side]);
          glPopMatrix();{}
        end;{tank}
      4:begin
          glPushMatrix();
          u:=Sector[z].Units[i,j];
          Units[u].ang:=get_R(Units[u].ang+Head_Rotate(Units[u].ang,Units[u].need_ang,6));
          p:=multi(Units[u].pt,Units[u].current_speed);
          glMultMatrixf(@Sector[z].Poz[i,j]);
          glTranslatef(p[0],p[1],p[2]);
          if Units[u].H and (Units[u].H_v<0.2) then Units[u].H_v:=Units[u].H_v+0.2/Units[u].speed;
          if not Units[u].H and (Units[u].H_v>0) then Units[u].H_v:=Units[u].H_v-0.2/Units[u].speed;
          if Sector[z].H[i,j] then glTranslatef(0,0,Units[u].H_v);
          glRotatef(Units[u].ang+90,0,0,1);
          glTranslatef(0,0,Self.Rad);
          _Laun.Render(_L[Units[u].Side]);
          glPopMatrix();{}
        end;{launcher}
      5:begin
          glPushMatrix();
          u:=Sector[z].Units[i,j];
          Units[u].ang:=get_R(Units[u].ang+Head_Rotate(Units[u].ang,Units[u].need_ang,6));
          p:=multi(Units[u].pt,Units[u].current_speed);
          glMultMatrixf(@Sector[z].Poz[i,j]);
          glTranslatef(p[0],p[1],p[2]);
          if Units[u].H and (Units[u].H_v<0.2) then Units[u].H_v:=Units[u].H_v+0.2/Units[u].speed;
          if not Units[u].H and (Units[u].H_v>0) then Units[u].H_v:=Units[u].H_v-0.2/Units[u].speed;
          if Sector[z].H[i,j] then glTranslatef(0,0,Units[u].H_v);
          glRotatef(Units[u].ang+90,0,0,1);
          glTranslatef(0,0,Self.Rad);
          Units[u].anim:=Units[u].anim+20;
          if Units[u].anim>800 then Units[u].anim:=0;
          _Sold.Anim(Units[u].anim/100);
          _Sold.Render(_S[Units[u].Side]);
          glPopMatrix();{}
        end;{Soldier}
      6:begin
          glPushMatrix();
          u:=Sector[z].Units[i,j];
          Units[u].ang:=get_R(Units[u].ang+Head_Rotate(Units[u].ang,Units[u].need_ang,6));
          p:=multi(Units[u].pt,Units[u].current_speed);
          glMultMatrixf(@Sector[z].Poz[i,j]);
          glTranslatef(p[0],p[1],p[2]);
          if Units[u].H and (Units[u].H_v<0.2) then Units[u].H_v:=Units[u].H_v+0.2/Units[u].speed;
          if not Units[u].H and (Units[u].H_v>0) then Units[u].H_v:=Units[u].H_v-0.2/Units[u].speed;
          if Sector[z].H[i,j] then glTranslatef(0,0,Units[u].H_v);
          glRotatef(Units[u].ang+90,0,0,1);
          glTranslatef(0,0,Self.Rad);
          Units[u].anim:=Units[u].anim+20;
          if Units[u].anim>800 then Units[u].anim:=0;
          _Heavy.Anim(Units[u].anim/100);
          _Heavy.Render(_S[Units[u].Side]);
          glPopMatrix();{}
        end;{Heavy}
      7:begin
          glPushMatrix();
          u:=Sector[z].Units[i,j];
          Units[u].ang:=get_R(Units[u].ang+Head_Rotate(Units[u].ang,Units[u].need_ang,6));
          p:=multi(Units[u].pt,Units[u].current_speed);
          glMultMatrixf(@Sector[z].Poz[i,j]);
          glTranslatef(p[0],p[1],p[2]);
          glRotatef(Units[u].ang+180,0,0,1);
          glTranslatef(0,0,Self.Rad);
          Units[u].anim:=Units[u].anim+10;
          if Units[u].anim>200 then Units[u].anim:=0;
          _Worm.Anim(Units[u].anim/100);
          _Worm.Render(_Worm.Texture);
          glPopMatrix();{}
        end;{Worm}
     end;
   end;
// _Quad.Render(_Quad.Texture);
end;
{$ENDREGION}

{$REGION 'Units Move'}
procedure TPlanet.Send_Unit(x,y:integer);
var u,i:integer;a,b,z:byte;
begin
 Select(x,y);
 a:=sel_coord[0];
 b:=sel_coord[1];
 z:=sel_sector;
 for i:=0 to Sel_Units_Count do
 begin
  u:=Sel_Units[i];
  if (u>0) then
  begin
   Units[u].wpx:=a;
   Units[u].wpy:=b;
   Units[u].wpz:=z;
   Units[u].way:=Find_way(
                    Units[u].poz.i,Units[u].poz.j,Units[u].poz.z, //start poz
                    Units[u].wpx,Units[u].wpy,Units[u].wpz); //end poz
   Units[u].way_command:=0;
  end;
 end;
{}
end;


procedure TPlanet.Move_Units();
var
 i,j,z,u:integer;
 way:TWay;A,B,P:TPoint;
begin
//move
for u := 0 to Max_Units do
if (Units[u].Tip>0) then
 begin  //units only
  i:=Units[u].poz.i;
  j:=Units[u].poz.j;
  z:=Units[u].poz.z;
  if (Units[u].current_speed=0) then
   begin
    if not((Units[u].way[Units[u].way_command].z=z) and
        (Units[u].way[Units[u].way_command].i=i) and
        (Units[u].way[Units[u].way_command].j=j)) then
     if not (Units[u].way[Units[u].way_command].z=Clear_Graph) then //move
      begin
       way:=Units[u].way[Units[u].way_command];
       if Sector[way.z].Units[way.i,way.j]=0 then
        begin     //move!
         Sector[way.z].Units[way.i,way.j]:=Sector[z].Units[i,j];
         Units[u].poz.i:=way.i;
         Units[u].poz.j:=way.j;
         Units[u].poz.z:=way.z;
         P:=minus(Sector[way.z].N[way.i,way.j],Sector[z].N[i,j]);
         Units[u].H:=Sector[way.z].H[way.i,way.j];
         Sector[z].Units[i,j]:=0;
         P:=multi(Sector[way.z].Poz[way.i,way.j],P);
         Units[u].pt:=multi(P,-Self.Rad/Units[u].speed);
         Units[u].need_ang:=Get_R(Get_A(P[0],P[1]));
         Units[u].current_speed:=Units[u].speed;
         Units[u].way_command:=Units[u].way_command+1;
        end else
         begin
     //     if True then

          Units[u].way[Units[u].way_command].z:=Clear_Graph;
         end;
      end
     else
     if (Units[u].wpx<>i) or (Units[u].wpy<>j) or
      (Units[u].wpz<>z) then
      begin
       Units[u].way:=Find_way(i,j,z,Units[u].wpx,Units[u].wpy,Units[u].wpz);
       Units[u].way_command:=0;
      end;
   end
  else
    Units[u].current_speed:=Units[u].current_speed-1;
 end;
//fire
end;
{$ENDREGION}

{$REGION 'Path Graf Generate'}
procedure TPlanet.Gen_Way_Point;
Var i,j,z,w,h,k,l:byte;a1,b1,a2,b2:integer;
 function Set_Gr(z,i,j:byte):TWay;
  begin
   Set_Gr.z:=z;
   Set_Gr.i:=i;
   Set_Gr.j:=j;
  end;
begin
 {onulayem} 
 for z:=0 to 19 do
    for i:=0 to Sector_Size-1 do
     for j:=0 to i do
      for w:=0 to 5 do
       begin
        Sector[z].Graph[i,j][w]:=Set_Gr(Clear_Graph,i,j);
       end;
 {delaem grafi v treugolnike}      
 for z:=0 to 19 do
   begin
    for i:=1 to Sector_Size-1 do
     for j:=1 to i do
      begin
       Sector[z].Graph[i,j][0]:=Set_Gr(z,i+1,j  );
       Sector[z].Graph[i,j][1]:=Set_Gr(z,i+1,j+1);
       Sector[z].Graph[i,j][2]:=Set_Gr(z,i  ,j+1);
       Sector[z].Graph[i,j][3]:=Set_Gr(z,i-1,j  );
       Sector[z].Graph[i,j][4]:=Set_Gr(z,i  ,j-1);
       Sector[z].Graph[i,j][5]:=Set_Gr(z,i-1,j-1);{ }
      end;
   end;
 {obrubaem bortiki}
 for z:=0 to 19 do
   begin
    for i:=0 to Sector_Size do
     for j:=0 to i do
      for w:=0 to 5 do
       begin
        if (Sector[z].Graph[i,j][w].i>Sector_Size-1) or
           (Sector[z].Graph[i,j][w].j<1) or
           (Sector[z].Graph[i,j][w].j>Sector[z].Graph[i,j][w].i)
        then
         begin
          Sector[z].Graph[i,j][w]:=Set_Gr(Clear_Graph,i,j);
         end;
       end;
   end;
 {prisoedinayem bortiki treugolnikov - kagdiy s kagdim}  
 for z:=0 to 19 do
  for h:=0 to 19 do
   if (h<>z) then
    begin
     for k:=0 to 3 do
      for l:=0 to 3 do
       if ((Faces[z][k mod 3] = Faces[h][(l+1) mod 3]) and
           (Faces[z][(k+1) mod 3] = Faces[h][l mod 3]))
         then
         begin
          case (k mod 3) of
           0:for i:=0 to Sector_Size-1 do
              for w:=0 to 5 do
               if (Sector[z].Graph[i,0][w].z=Clear_Graph) then
                begin
                  case (l mod 3) of
                    0:Sector[z].Graph[i,1][w]:=Set_GR(h,Sector_Size-i,1);
                    1:Sector[z].Graph[i,1][w]:=Set_GR(h,Sector_Size-1,Sector_Size-i);
                    2:Sector[z].Graph[i,1][w]:=Set_GR(h,i,i);
                  end;
                  break;
                end;
           1:for i:=0 to Sector_Size-1 do
              for w:=0 to 5 do
               if (Sector[z].Graph[Sector_Size-1,i][w].z=Clear_Graph) then
                begin
                  case (l mod 3) of
                    0:Sector[z].Graph[Sector_Size-1,i][w]:=Set_GR(h,Sector_Size-i,1);
                    1:Sector[z].Graph[Sector_Size-1,i][w]:=Set_GR(h,Sector_Size-1,Sector_Size-i);
                    2:Sector[z].Graph[Sector_Size-1,i][w]:=Set_GR(h,i,i);
                  end;
                  break;
                end;
           2:for i:=0 to Sector_Size-1 do
              for w:=0 to 5 do
               if (Sector[z].Graph[i,i][w].z=Clear_Graph) then
                begin
                  case (l mod 3) of
                    0:Sector[z].Graph[i,i][w]:=Set_GR(h,i,1);
                    1:Sector[z].Graph[i,i][w]:=Set_GR(h,Sector_Size-1,i);
                    2:Sector[z].Graph[i,i][w]:=Set_GR(h,i,i);
                  end;
                 break;
                end;  { }
          end;
         end;  
    end;
end;
{$ENDREGION}

{$REGION 'Draw and Optimize'}
procedure TPlanet.Draw_Planet;
Var i:integer;      {counter}
begin
 if Self.Orbital_view then
 begin
  {orbital view - paint like texture on the sphere}
  glEnable(GL_Texture_2d);
//  glDisAble(GL_Blend);
  glBindTexture(GL_Texture_2d,Self.Planet_tex);
  for i:=0 to 19 do
   begin
    Draw_Triand_Sector(
              Self.Tex_Points[Self.Tex_Faces[i][0]],
              Self.Tex_Points[Self.Tex_Faces[i][2]],
              Self.Tex_Points[Self.Tex_Faces[i][1]],
              Self.Points[Self.Faces[i][0]],
              Self.Points[Self.Faces[i][1]],
              Self.Points[Self.Faces[i][2]],
              0);
   end;
   if Unit_Simbol_vis then   
    Draw_Units_items();
{test}
//   Draw_Units();
 end else
 begin
  {map view(near Self) - paint like polygonal map + optimizing}
  glEnable(GL_Texture_2d);
  glBindTexture(GL_Texture_2d,Ground_tex);
  for i:=0 to 19 do
   if (Get_SQ(
     Self.Reaper,
     Middle(
       Self.Points[Self.Faces[i][2]],
       Self.Points[Self.Faces[i][1]],
       Self.Points[Self.Faces[i][0]]))<Self.Rad*Self.Rad*1.2) then
    begin
     Sector[i].Viz:=true;
     Draw_Spherical_Sector(Self.Sector[i],
               Self.Points[Self.Faces[i][2]],
               Self.Points[Self.Faces[i][1]],
               Self.Points[Self.Faces[i][0]]);
    end else
     Sector[i].Viz:=false;
   Draw_Units();
 end;
end;  
{$ENDREGION}

{$REGION 'Render spheres'}
procedure TPlanet.Set_Color(Color:byte);
begin
 case Color of
//  0:glColor3f(1,0.8,0.33);{desert}
//  1:glColor3f(1,0.55,0.08);{rocks e2990c}
//  2:glColor3f(1,0.18,0.18);{spice}
  0:glColor3f($ce/$FF,$8e/$ff,$40/$ff);{desert d5b858}
  1:glColor3f($68/256,$3f/256,$00/$ff);{rocks 684800}
  2:glColor3f(1,0.18,0.18);{spice}
 end;
end;

procedure TPlanet.Set_G_Color(Color:byte);
begin
 case Color of
  0:glColor3f(1,1,1);{desert d5b858}
  1:glColor3f(1,1,1);{rocks 684800}
  2:glColor3f(1,0.18,0.18);{spice}
 end;
end;

Procedure TPlanet.Draw_Spherical_Sector(var T:TSector;A,B,C:TPoint);
Var
  i,j,tile:integer;{counters}
  IV,JV:TPoint;{triang vectors}
  HN:TPoint;{heigth vector}
  VA,VB,VC:TPoint;{points for each side}
begin
 //A - Point of begin
 IV:=(multi(minus(C,A),1/Sector_Size));  {find vectors}
 JV:=(multi(minus(B,C),1/Sector_Size));
 HN:=multi(Get_Normal(A,B,C),Get_S(A,B)/Sector_Size*0.1);{landscape height}
 glBegin(Render_Type);
 glColor3f(1,1,1);
 for i:=0 to Sector_Size-1 do
  for j:=0 to i do
   begin          {find point of current triangle}
    VA:=multi(T.N[i  ,j  ],Self.Rad);
    VB:=multi(T.N[i+1,j+1],Self.Rad);
    VC:=multi(T.N[i+1,j  ],Self.Rad);
    if T.H[i  ,j  ] then VA:=plus(VA,HN);{+heigth if need}
    if T.H[i+1,j+1] then VB:=plus(VB,HN);
    if T.H[i+1,j  ] then VC:=plus(VC,HN);
    tile:= byte(T.H[i,j])*4+byte(T.H[i+1,j+1])*2+byte(T.H[i+1,j]);
    glTexCoord3fv(@Tile_Points[Tile_Faces[tile][0]]);
    glNormal3fv(@T.N[i,j]);{set normals,color and draw}
    Set_G_Color(T.C[i,j]);
    glVertex3fv(@VA);
    if (i=Sel_Coord[0]) and (j=Sel_Coord[1]) then
     glColor3f(5,0,0);
    glTexCoord3fv(@Tile_Points[Tile_Faces[tile][1]]);
    glNormal3fv(@T.N[i+1,j+1]);
    Set_G_Color(T.C[i+1,j+1]);
    glVertex3fv(@VB);
    glTexCoord3fv(@Tile_Points[Tile_Faces[tile][2]]);
    glNormal3fv(@T.N[i+1,j]);
    Set_G_Color(T.C[i+1,j]);
    glVertex3fv(@VC);
   end;
 for i:=1 to Sector_Size-1 do {for middle triangles}
  for j:=0 to i-1 do
   begin
    VA:=multi(T.N[i  ,j  ],Self.Rad);
    VB:=multi(T.N[i  ,j+1],Self.Rad);
    VC:=multi(T.N[i+1,j+1],Self.Rad);
    if T.H[i  ,j  ] then VA:=plus(VA,HN);
    if T.H[i  ,j+1] then VB:=plus(VB,HN);
    if T.H[i+1,j+1] then VC:=plus(VC,HN);
    tile:=8+byte(T.H[i,j])*4+byte(T.H[i,j+1])*2+byte(T.H[i+1,j+1]);
    glNormal3fv(@T.N[i,j]);
    glTexCoord3fv(@Tile_Points[Tile_Faces[tile][0]]);
    Set_G_Color(T.C[i,j]);
    glVertex3fv(@VA);
    glNormal3fv(@T.N[i,j+1]);
    glTexCoord3fv(@Tile_Points[Tile_Faces[tile][1]]);
    Set_G_Color(T.C[i,j+1]);
    glVertex3fv(@VB);
    glNormal3fv(@T.N[i+1,j+1]);
    glTexCoord3fv(@Tile_Points[Tile_Faces[tile][2]]);
    Set_G_Color(T.C[i+1,j+1]);
    glVertex3fv(@VC);
   end;
 glEnd;
end;

procedure TPlanet.Draw_tex_Sector(TA,TB,TC:TVect;A,B,C:TPoint);
Var  Norm:TPoint;
begin
 glColor4f(1,1,1,1);
 glBegin(Render_Type);
  Norm:=Normalize(A);
  glNormal3fv(@Norm);
  glTexCoord2fv(@TA);
  glVertex3fv(@A);
  Norm:=Normalize(B);
  glNormal3fv(@Norm);
  glTexCoord2fv(@TB);
  glVertex3fv(@B);
  Norm:=Normalize(C);
  glNormal3fv(@Norm);
  glTexCoord2fv(@TC);
  glVertex3fv(@C);
 glEnd;
end;

procedure TPlanet.Draw_Triand_Sector(TA,TB,TC:TVect;PA,PB,PC:TPoint;level:byte);
Var //i,j:byte;
f:single;
//TX,TY:array [0..2] of single;
//temp:single;
FPA,FPB,FPC:TPoint;
FTA,FTB,FTC:TVect;
begin
 f:=0.2;
 if level=Self.planetar_mode then
 begin
  Draw_Tex_Sector(TA,TC,TB,PA,PC,PB);
  exit;
 end;
 level:=level+1;
 {tex coords}
 FTA:=middle(TA,TB);
 FTB:=middle(TB,TC);
 FTC:=middle(TC,TA);
 {coords}
 FPA:=middle(PA,PB);
 FPB:=middle(PB,PC);
 FPC:=middle(PC,PA);
 FPA:=multi(normalize(FPA),Self.Rad);
 FPB:=multi(normalize(FPB),Self.Rad);
 FPC:=multi(normalize(FPC),Self.Rad);
 Draw_Triand_Sector(FTA,TB,FTB, FPA,PB,FPB,level);
 Draw_Triand_Sector(FTC,FTB,TC, FPC,FPB,PC,level);
 Draw_Triand_Sector(TA,FTA,FTC, PA,FPA,FPC,level);
 Draw_Triand_Sector(FTA,FTB,FTC,FPA,FPB,FPC,level);
end;
{$ENDREGION}

{$REGION 'Planet Generation'}
procedure TPlanet.Find_Normals(Var T:TSector;A,B,C:TPoint);{find point normals - for planet sperize}
Var
  i,j:integer;{counters}
  IV,JV:TPoint;{triang vectors}
  VA,VB,VC:TPoint;{points for each side}
begin
 ///A - Point of begin
 IV:=(multi(minus(C,A),1/Sector_Size));
 JV:=(multi(minus(B,C),1/Sector_Size));
 for i:=0 to Sector_Size do
  for j:=0 to i do
   begin
    VA:=plus(A,(plus(multi(IV,(i  )),multi(JV,(j  )))));
    VB:=plus(A,(plus(multi(IV,(i+1)),multi(JV,(j+1)))));
    VC:=plus(A,(plus(multi(IV,(i+1)),multi(JV,(j  )))));
    T.N[i,j]:=normalize(VA);
    T.N[i+1,j+1]:=normalize(VB);
    T.N[i,j+1]:=normalize(VC);
   end;
end;

procedure TPlanet.Gen_Sector(Var T:TSector);{generate Maps}
Var i,j{,z,x}:integer;
procedure put_S(i,j,l:integer);
begin
 if (i<=0) or (i>=Sector_Size) or
    (j<=0) or (j>=Sector_Size)  then exit;
 if l=0 then
 begin
  T.H[i-1,j-1]:=true;
  T.H[i,j-1]:=true;
  T.H[i-1,j]:=true;
  T.H[i,j]:=true;
  T.H[i+1,j]:=true;
  T.H[i,j+1]:=true;
  T.H[i+1,j+1]:=true;
  exit;
 end;
 if Random(3)=0 then put_S(i-1,j-1,l-1);
 if Random(3)=0 then put_S(i,j-1,l-1);
 if Random(3)=0 then put_S(i-1,j,l-1);
 if Random(3)=0 then put_S(i+1,j,l-1);
 if Random(3)=0 then put_S(i,j+1,l-1);
 if Random(3)=0 then put_S(i+1,j+1,l-1);
end;
begin
 for i:=1 to Sector_Size+1 do
  for j:=1 to Sector_Size+1 do
   begin
    if random(16)=0 then
     begin
     end;
    T.H[i,j]:=T.H[i,j] and (Random(3)=0); 
   end;
{ for i:=0 to Sector_Size+1 do
   begin
   end;   }
 put_S(Sector_Size-trunc(Sector_Size/4),trunc(Sector_Size/4),8);
 for i:=0 to 20 do
   begin
    put_S(Random(Sector_Size),Random(Sector_Size),1);
   end;
 for i:=0 to Sector_Size+1 do
   begin
   // T.H[Sector_Size-3,i]:=true;
   // T.H[i,3]:=true;
    T.H[i,0]:=false;
    T.H[i,1]:=false;
    T.H[Sector_Size,i]:=false;
    T.H[Sector_Size-1,i]:=false;
    T.H[i,i]:=false;
    T.H[i+1,i]:=false;
   end;
 for i:=0 to Sector_Size+1 do
  for j:=0 to Sector_Size+1 do
   begin
    if T.H[i,j] then T.C[i,j]:=1 else T.C[i,j]:=0;
   end;
end;

procedure TPlanet.Gen_Planet;{creating of all coords of Self}
Var i:byte; {counter}
begin             
 {Front up / down}
 Self.Points[0][2]:=1;
 Self.Points[0][1]:=0.618;
 Self.Points[0][0]:=0;
 Self.Points[1][2]:=1;
 Self.Points[1][1]:=-0.618;
 Self.Points[1][0]:=0;
 {back up / down}
 Self.Points[2][2]:=-1;
 Self.Points[2][1]:=0.618;
 Self.Points[2][0]:=0;
 Self.Points[3][2]:=-1;
 Self.Points[3][1]:=-0.618;
 Self.Points[3][0]:=0;
 {rigth front / back}
 Self.Points[4][0]:=1;
 Self.Points[4][2]:=0.618;
 Self.Points[4][1]:=0;
 Self.Points[5][0]:=1;
 Self.Points[5][2]:=-0.618;
 Self.Points[5][1]:=0;
 {left front / back}
 Self.Points[6][0]:=-1;
 Self.Points[6][2]:=0.618;
 Self.Points[6][1]:=0;
 Self.Points[7][0]:=-1;
 Self.Points[7][2]:=-0.618;
 Self.Points[7][1]:=0;
 {up rigth / left}
 Self.Points[8][1]:=1;
 Self.Points[8][0]:=0.618;
 Self.Points[8][2]:=0;
 Self.Points[9][1]:=1;
 Self.Points[9][0]:=-0.618;
 Self.Points[9][2]:=0;
 {down rigth / left}
 Self.Points[10][1]:=-1;
 Self.Points[10][0]:=0.618;
 Self.Points[10][2]:=0;
 Self.Points[11][1]:=-1;
 Self.Points[11][0]:=-0.618;
 Self.Points[11][2]:=0;
 for i:=0 to 11 do
  begin              
   Self.Points[i]:=multi(normalize(Self.Points[i]),Self.Rad);
  end;
 Self.Faces[0]:=face(0,4,1);
 Self.Faces[1]:=face(0,1,6);
 Self.Faces[2]:=face(0,9,8);
 Self.Faces[3]:=face(0,6,9);
 Self.Faces[4]:=face(1,11,6);
 Self.Faces[5]:=face(1,4,10);
 Self.Faces[6]:=face(1,10,11);
 Self.Faces[7]:=face(2,3,5);
 Self.Faces[8]:=face(2,7,3);
 Self.Faces[9]:=face(2,8,9);
 Self.Faces[10]:=face(2,5,8);
 Self.Faces[11]:=face(2,9,7);
 Self.Faces[12]:=face(3,10,5);
 Self.Faces[13]:=face(3,11,10);
 Self.Faces[14]:=face(3,7,11);
 Self.Faces[15]:=face(4,0,8);
 Self.Faces[16]:=face(4,8,5);
 Self.Faces[17]:=face(4,5,10);
 Self.Faces[18]:=face(6,7,9);
 Self.Faces[19]:=face(6,11,7);
end;
{$ENDREGION}

{$REGION 'Gen_Poz'}
procedure TPlanet.Gen_Pozitions;{creating of all coords of Self}
Var
i,j,z:byte;
a,b,c:single;
P:TPoint;
begin
 for z := 0 to 19 do
   begin
    for i:=0 to Sector_Size-1 do
     for j:=0 to i do
     begin
      a:=Get_A(Sector[z].N[i,j][2],Sector[z].N[i,j][0]);
      b:=Get_A(Get_S(Sector[z].N[i,j][0],Sector[z].N[i,j][2]),
                Sector[z].N[i,j][1]);
//      c:=0;
      Sector[z].Poz[i,j]:=
        multi(Pozition(rotate(b,1,0,0)),
        Pozition(rotate(a{+180},0,-1,0)));
      P:=minus(Self.Points[Self.Faces[z][0]],
          middle( Self.Points[Self.Faces[z][0]],
                  Self.Points[Self.Faces[z][1]],
                  Self.Points[Self.Faces[z][2]]));
      P:=multi(Sector[z].Poz[i,j],P);
      c:=Get_A(P[0],P[1]);
      Sector[z].Poz[i,j]:=multi(Pozition(Rotate(c,0,0,-1)),Sector[z].Poz[i,j]);
     end;
   end;
end;
{$ENDREGION}

{$REGION 'Gen_tiles'}
procedure TPlanet.Gen_tileset;{creating coords to link tileset and tiles}
Var i:byte; {counter}
begin
 for i:= 0 to 3 do
   begin                   
    Self.Tile_Points[i]   [0]:=(i+0.5)/3.5;
    Self.Tile_Points[i]   [1]:=1;
    Self.Tile_Points[i+4] [0]:=(i)/3.5;
    Self.Tile_Points[i+4] [1]:=0.75;
    Self.Tile_Points[i+8] [0]:=(i+0.5)/3.5;
    Self.Tile_Points[i+8] [1]:=0.5;
    Self.Tile_Points[i+12][0]:=(i)/3.5;
    Self.Tile_Points[i+12][1]:=0.25;
    Self.Tile_Points[i+16][0]:=(i+0.5)/3.5;
    Self.Tile_Points[i+16][1]:=0;
   end;
 for i:=0 to 15 do
   begin
    Tile_Faces[i]:=Face(0,1,5);
   end;
//   *   *   *   *  0   1   2  3
// *   *   *   *  4   5   6   7
//   *   *   *   *  8   9   10  11
// *   *   *   *  12  13  14  15
//   *   *   *   *  16  17  18  19
// Points of tile texture count by myself
 Tile_Faces[0]:=Face(1,2,6); {clear}
 Tile_Faces[1]:=Face(0,1,5); {c sand etc}
 Tile_Faces[2]:=Face(12,13,16);
 Tile_Faces[3]:=Face(8,9,13);
 Tile_Faces[4]:=Face(13,14,17);
 Tile_Faces[5]:=Face(5,6,9);
 Tile_Faces[6]:=Face(9,10,14);
 Tile_Faces[7]:=Face(10,11,15);
 Tile_Faces[8]:=Face(17,14,18); {clear}
 Tile_Faces[9]:=Face(12,8,13);
 Tile_Faces[10]:=Face(16,13,17);
 Tile_Faces[11]:=Face(14,10,15);
 Tile_Faces[12]:=Face(5,1,6);
 Tile_Faces[13]:=Face(9,6,10);
 Tile_Faces[14]:=Face(13,9,14); 
 Tile_Faces[15]:=Face(10,7,11);
end;      
{$ENDREGION}

{$REGION 'Land Texture Generation'}
procedure TPlanet.Draw_Flat_Sector(Var T:TSector;A,B,C:TPoint);
Var
  i,j:integer;{counters}
  IV,JV:TPoint;{triang vectors}
  VA,VB,VC:TPoint;{points for each side}
begin
 IV:=(multi(minus(C,A),1/Sector_Size));
 JV:=(multi(minus(B,C),1/Sector_Size));
 glColor3f(1,1,1);
 glEnable(GL_Texture_2d);
 glBegin(GL_TRIANGLES);
 for i:=0 to Sector_Size-1 do
  for j:=0 to i do
   begin
    VA:=plus(A,(plus(multi(IV,(i  )),multi(JV,(j  )))));
    VB:=plus(A,(plus(multi(IV,(i+1)),multi(JV,(j+1)))));
    VC:=plus(A,(plus(multi(IV,(i+1)),multi(JV,(j  )))));
    glNormal3fv(@T.N[i,j]);
    Set_Color(T.C[i,j]);
    glVertex3fv(@VA);
    glNormal3fv(@T.N[i+1,j+1]);
    Set_Color(T.C[i+1,j+1]);
    glVertex3fv(@VB);
    glNormal3fv(@T.N[i+1,j]);
    Set_Color(T.C[i+1,j]);
    glVertex3fv(@VC);
   end;
 for i:=1 to Sector_Size-1 do
  for j:=0 to i-1 do
   begin
    VA:=plus(A,plus(multi(IV,(i  )),multi(JV,(j  ))));
    VB:=plus(A,plus(multi(IV,(i  )),multi(JV,(j+1))));
    VC:=plus(A,plus(multi(IV,(i+1)),multi(JV,(j+1))));
    glNormal3fv(@T.N[i,j]);
    Set_Color(T.C[i,j]);
    glVertex3fv(@VA);
    glNormal3fv(@T.N[i,j+1]);
    Set_Color(T.C[i,j+1]);
    glVertex3fv(@VB);
    glNormal3fv(@T.N[i+1,j+1]);
    Set_Color(T.C[i+1,j+1]);
    glVertex3fv(@VC);
   end;
 glEnd;
end;

procedure TPlanet.Gen_Planetar_Texture(Var Tex:cardinal);{generate of ground texture}
Var
  i:byte;    {counters}
  Tex_Vertex:Array [0..16] of TPoint;{for render}
begin
//  Self.Tex_Point.Points:array[0..16] of TVect;
//  Self.Tex_Point.Faces:array[0..19] of TFace;
//   *   *   *      0   1   2
// *   *   *   *  3   4   5   6
//   *   *   *      7   8   9
// *   *   *   *  10  11  12  13
//   *   *   *      14  15  16
// Points of texture count{by myself}
for i:= 0 to 2 do
   begin
    Self.Tex_Points[i][0]:=(i+0.5)/3.5;
    Self.Tex_Points[i][1]:=(0.866*4)/3.5;
    Self.Tex_Points[i+7][0]:=(i+0.5)/3.5;
    Self.Tex_Points[i+7][1]:=(0.866*2)/3.5;
    Self.Tex_Points[i+14][0]:=(i+0.5)/3.5;
    Self.Tex_Points[i+14][1]:=0;
   end;
 for i:= 0 to 3 do
   begin
    Self.Tex_Points[i+3][0]:=i/3.5;
    Self.Tex_Points[i+3][1]:=(0.866*3)/3.5;
    Self.Tex_Points[i+10][0]:=i/3.5;
    Self.Tex_Points[i+10][1]:=(0.866)/3.5;
   end;    {texture Face set}
 Self.Tex_Faces[0]:=Face(0,4,3);
 Self.Tex_Faces[1]:=Face(0,1,4);
 Self.Tex_Faces[2]:=Face(1,5,4);
 Self.Tex_Faces[3]:=Face(1,2,5);
 Self.Tex_Faces[4]:=Face(2,6,5);
 Self.Tex_Faces[5]:=Face(3,4,7);
 Self.Tex_Faces[6]:=Face(4,8,7);
 Self.Tex_Faces[7]:=Face(4,5,8);
 Self.Tex_Faces[8]:=Face(5,9,8);
 Self.Tex_Faces[9]:=Face(5,6,9);
 Self.Tex_Faces[10]:=Face(7,11,10);
 Self.Tex_Faces[11]:=Face(7,8,11);
 Self.Tex_Faces[12]:=Face(8,12,11);
 Self.Tex_Faces[13]:=Face(8,9,12);
 Self.Tex_Faces[14]:=Face(9,13,12);
 Self.Tex_Faces[15]:=Face(10,11,14);
 Self.Tex_Faces[16]:=Face(11,15,14);
 Self.Tex_Faces[17]:=Face(11,12,15);
 Self.Tex_Faces[18]:=Face(12,16,15);
 Self.Tex_Faces[19]:=Face(12,13,16);
 for i:=0 to 16 do
  begin           {creation real 3d Points for Render}
   Tex_Vertex[i]:=Point((Self.Tex_Points[i][0]-0.5)*2,(Self.Tex_Points[i][1]-0.5)*2,0);
  end;
 {Render to texture}
 glPushAttrib(GL_VIEWPORT_BIT);         {save viewPort}
 glViewport(0, 0, Self.Tex_W, Self.Tex_H);{set tex size}                 {cle}
 glMatrixMode(GL_Projection);
 gluPerspective(10.0, 1, 0.1, 10.0);  {set perspective}
 glLoadIdentity();
 glMatrixMode(Gl_ModelView);
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glPushMatrix();
 glLoadIdentity();
 glDisable(GL_LIGHTING);
 glDisable(GL_TEXTURE_2D);
 glDisable(GL_Depth_Test);
 Set_Color(0);
 glBegin(GL_QUADS);
 glVertex3f( 1,-1,0); glVertex3f(-1,-1,0);
 glVertex3f(-1, 1,0); glVertex3f( 1, 1,0);
 glend;
 for i:=0 to 19 do
   Draw_Flat_Sector(Self.Sector[i],
              Tex_Vertex[Self.Tex_Faces[i][0]],
              Tex_Vertex[Self.Tex_Faces[i][1]],
              Tex_Vertex[Self.Tex_Faces[i][2]]);
 glEnable(GL_TEXTURE_2D);
 glBindTexture(GL_TEXTURE_2D, Tex);
 glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 0, 0, Self.Tex_W, Self.Tex_H, 0);
 glPopMatrix();
 glPopAttrib;
 glEnable(GL_LIGHTING);
 glEnable(GL_Depth_Test);
 on_Resize(PW,PH);
end;
{$ENDREGION}
end.
