unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, xmldom, XMLIntf, ActnList, msxmldom, XMLDoc, ComCtrls, Menus,
  ToolWin, ImgList, uFieldData, ExtCtrls, StdCtrls, frmLevel, VirtualTrees,
  oxmldom;
  
type

  PNodeData = ^TNodeData;

  TNodeData = record
    Caption: WideString;
    Value: IXMLNode;
  end;

  TFormMain = class(TForm)
    MainMenu: TMainMenu;
    StatusBar: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    XMLConverter: TXMLDocument;
    MainMenuActionList: TActionList;
    acSave: TAction;
    Savefile1: TMenuItem;
    Savefile2: TMenuItem;
    acExit: TAction;
    N1: TMenuItem;
    Exit1: TMenuItem;
    acNew: TAction;
    New1: TMenuItem;
    acOpen: TAction;
    Exit2: TMenuItem;
    Icons: TImageList;
    ToolButton3: TToolButton;
    ToolbarActionList: TActionList;
    acClear: TAction;
    acWall: TAction;
    acSand: TAction;
    acRock: TAction;
    acDiamond: TAction;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    acBarrel: TAction;
    acKeyRed: TAction;
    acKeyGreen: TAction;
    acKeyBlue: TAction;
    acKeyMagenta: TAction;
    KeysMenu: TPopupMenu;
    btnKeysButton: TToolButton;
    acKeyRed1: TMenuItem;
    acKeyGreen1: TMenuItem;
    acKeyBlue1: TMenuItem;
    acKeyMagenta1: TMenuItem;
    acDoorRed: TAction;
    acDoorGreen: TAction;
    acDoorBlue: TAction;
    acDoorMagenta: TAction;
    DoorsMenu: TPopupMenu;
    acDoorRed1: TMenuItem;
    acDoorGreen1: TMenuItem;
    acDoorBlue1: TMenuItem;
    acDoorMagenta1: TMenuItem;
    btnDoorsButton: TToolButton;
    MonstersMenu: TPopupMenu;
    acMonsterLHRight: TAction;
    acMonsterLHDown: TAction;
    acMonsterLHLeft: TAction;
    acMonsterLHUp: TAction;
    btnMonstersButton: TToolButton;
    acMonsterLHRight1: TMenuItem;
    acMonsterLHLeft1: TMenuItem;
    acMonsterLHDown1: TMenuItem;
    acMonsterLHUp1: TMenuItem;
    acMonsterRHRight: TAction;
    acMonsterRHDown: TAction;
    acMonsterRHLeft: TAction;
    acMonsterRHUp: TAction;
    acMonsterRHRight1: TMenuItem;
    acMonsterRHDown1: TMenuItem;
    acMonsterRHLeft1: TMenuItem;
    acMonsterRHUp1: TMenuItem;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    acIndicator: TAction;
    acPlayerStart: TAction;
    acPlayerExit: TAction;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    acChangeLimit: TAction;
    Edit1: TMenuItem;
    acChangeLimit1: TMenuItem;
    acCreateFrame: TAction;
    Makeborderwalls1: TMenuItem;
    acLevelInfo: TAction;
    ools1: TMenuItem;
    Levelinfo1: TMenuItem;
    acSaveAs: TAction;
    Saveas1: TMenuItem;
    ToolBar2: TToolBar;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    MenuIcons: TImageList;
    Splitter1: TSplitter;
    PageControl1: TPageControl;
    PageMenu: TPopupMenu;
    acPageClose: TAction;
    Closepage1: TMenuItem;
    vstLevels: TVirtualStringTree;
    Panel1: TPanel;
    ToolBar3: TToolBar;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    acLevelNew: TAction;
    acLevelDel: TAction;
    acLevelOpen: TAction;
    ToolButton19: TToolButton;
    ToolButton20: TToolButton;
    Memo1: TMemo;
    Splitter2: TSplitter;
    acLevelNew1: TMenuItem;
    acLevelDel1: TMenuItem;
    acLevelOpen1: TMenuItem;
    procedure acExitExecute(Sender: TObject);
    procedure acNewExecute(Sender: TObject);
    procedure EditorPaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure acDoorRedExecute(Sender: TObject);
    procedure acKeyRedExecute(Sender: TObject);
    procedure acClearExecute(Sender: TObject);
    procedure EditorPaintBoxMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure EditorPaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure acMonsterLHRightExecute(Sender: TObject);
    procedure acIndicatorExecute(Sender: TObject);
    procedure acSaveExecute(Sender: TObject);
    procedure acOpenExecute(Sender: TObject);
    procedure acChangeLimitExecute(Sender: TObject);
    procedure acCreateFrameExecute(Sender: TObject);
    procedure acLevelInfoExecute(Sender: TObject);
    procedure acSaveAsExecute(Sender: TObject);
    procedure acPageCloseExecute(Sender: TObject);
    procedure lbLevelsListDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure vstLevelsGetText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure vstLevelsDblClick(Sender: TObject);
    procedure acLevelOpenExecute(Sender: TObject);
    procedure acLevelNewExecute(Sender: TObject);
    procedure acLevelDelExecute(Sender: TObject);
  private
    { Private declarations }
    fLastFilename:String;
    procedure setLastFileName(val:String);
    procedure createNewDocument;
    procedure openNode(number:Integer; xmlNode:IXMLNode);
    function getLevelInfo(node:PVirtualNode):String;
    function isOpened(number:Integer):Boolean;
    procedure focusByIndex(number: Integer);
    procedure closeByIndex(number: Integer);
    function createNewNode:IXMLNode;
    procedure updateTreeStructure;
    procedure DoSaveLevel(Sender:TFormLevel);
    procedure DeleteFocused;
    procedure SaveDocument(FileName:String);
    property LastFileName:String read fLastFileName write setLastFileName;
  public
    { Public declarations }
    fSelectedType: TFieldObject;
    procedure Log(s:String);
  end;

var
  FormMain: TFormMain;

implementation

uses frmNewField;

{$R *.dfm}

procedure TFormMain.acExitExecute(Sender: TObject);
begin
  FormMain.Close;
end;

procedure TFormMain.acNewExecute(Sender: TObject);
begin
  createNewDocument;
  updateTreeStructure;
  LastFileName := '';
end;

procedure TFormMain.EditorPaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  //
end;

procedure TFormMain.acDoorRedExecute(Sender: TObject);
begin
  acIndicator.ImageIndex := (Sender as TAction).ImageIndex;
  fSelectedType := TFieldObject((Sender as TAction).ImageIndex);
  btnDoorsButton.ImageIndex := (Sender as TAction).ImageIndex;
end;

procedure TFormMain.acKeyRedExecute(Sender: TObject);
begin
  acIndicator.ImageIndex := (Sender as TAction).ImageIndex;
  fSelectedType := TFieldObject((Sender as TAction).ImageIndex);
  btnKeysButton.ImageIndex := (Sender as TAction).ImageIndex;
end;

procedure TFormMain.acClearExecute(Sender: TObject);
begin
  acIndicator.ImageIndex := (Sender as TAction).ImageIndex;
  fSelectedType := TFieldObject((Sender as TAction).ImageIndex);
end;

procedure TFormMain.EditorPaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  //
end;

procedure TFormMain.EditorPaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  //
end;

procedure TFormMain.acMonsterLHRightExecute(Sender: TObject);
begin
  acIndicator.ImageIndex := (Sender as TAction).ImageIndex;
  fSelectedType := TFieldObject((Sender as TAction).ImageIndex);
  btnMonstersButton.ImageIndex := (Sender as TAction).ImageIndex;
end;

procedure TFormMain.acIndicatorExecute(Sender: TObject);
begin
  //
end;

procedure TFormMain.acSaveExecute(Sender: TObject);
begin
  SaveDialog1.FileName := LastFileName;
  if (lastFileName <> '') or SaveDialog1.Execute then
  begin
    SaveDocument(SaveDialog1.FileName);
  end;
end;

procedure TFormMain.acOpenExecute(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    vstLevels.Clear;
    XMLConverter.Active := true;
    XMLConverter.Encoding := 'UTF-8';
    XMLConverter.LoadFromFile(OpenDialog1.FileName);
    updateTreeStructure;
    LastFileName := OpenDialog1.FileName;
  end
end;

procedure TFormMain.acChangeLimitExecute(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
  begin
    (PageControl1.ActivePage.Controls[0] as TFormLevel).limit := StrToInt(
      InputBox('Change Diamonds limit',
        'Enter new value',
        IntToStr((PageControl1.ActivePage.Controls[0] as TFormLevel).limit)));
  end;
end;

procedure TFormMain.acCreateFrameExecute(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
    (PageControl1.ActivePage.Controls[0] as TFormLevel).makeWallFrame;
end;

procedure TFormMain.acLevelInfoExecute(Sender: TObject);
var
  res: String;
begin
  //if Assigned(PageControl1.ActivePage) then
  //  ShowMessage((PageControl1.ActivePage.Controls[0] as TFormLevel).GetLevelInfo);
  res := getLevelInfo(vstLevels.FocusedNode);
  if res <> '' then log(res);
end;

procedure TFormMain.acSaveAsExecute(Sender: TObject);
begin
  SaveDialog1.FileName := '';
  if SaveDialog1.Execute then
  begin
    SaveDocument(SaveDialog1.FileName);
  end;
end;

procedure TFormMain.acPageCloseExecute(Sender: TObject);
begin
  if Assigned(PageControl1.ActivePage) then
    (PageControl1.ActivePage.Controls[0] as TFormLevel).Close;
end;

procedure TFormMain.lbLevelsListDblClick(Sender: TObject);
var
  i: Integer;
begin
  {
  if lbLevelsList.ItemIndex >= 0 then
  begin
    ShowMessage(lbLevelsList.Items.Objects[lbLevelsList.ItemIndex].ClassName);
  end;
  }
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
  Memo1.Clear;
  vstLevels.NodeDataSize := SizeOf(TNodeData);
end;

procedure TFormMain.vstLevelsGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var
  data: PNodeData;
begin
  data := vstLevels.GetNodeData(Node);
  CellText := IntToStr(Node^.Index) + ' ' + data^.Caption
    + ' (' + data^.Value.Attributes['limit'] + ')';
end;

procedure TFormMain.vstLevelsDblClick(Sender: TObject);
var
  node:PVirtualNode;
  data:PNodeData;
begin
  node := vstLevels.FocusedNode;
  if Assigned(node) then
  begin
    data := vstLevels.GetNodeData(node);
    openNode(node^.Index, data.Value);
  end;
end;

procedure TFormMain.openNode(number:Integer; xmlNode:IXMLNode);
var
  data: PNodeData;
  form:TFormLevel;
  s:String;
begin
  if not isOpened(number) then
  begin
    s := xmlNode.Text;
    s := StringReplace(s, ' ', '', [rfReplaceAll]);
    s := StringReplace(s, chr(10), '', [rfReplaceAll]);
    s := StringReplace(s, chr(13), '', [rfReplaceAll]);
    s := StringReplace(s, chr(VK_TAB), '', [rfReplaceAll]);
    //ShowMessage('!!!' + s);

    form := TFormLevel.Create(Self);
    form.ManualDock(PageControl1);
    form.NewLevel(number,
      StrToInt(xmlNode.Attributes['width']),
      StrToInt(xmlNode.Attributes['height']),
      StrToInt(xmlNode.Attributes['limit']),
      xmlNode.Attributes['name'],
      xmlNode);
    form.data := s;
    form.OnSaveLevel := DoSaveLevel;
    form.Show;
  end;
  focusByIndex(number);
end;

function TFormMain.getLevelInfo(node: PVirtualNode):String;
var
  cnt, i: Integer;
  data: String;
  xmlNode: IXMLNode;
  nodeData: PNodeData;
begin
  if Assigned(node) then
  begin
    cnt := 0;
    nodeData := vstLevels.GetNodeData(node);
    xmlNode := nodeData.Value;
    data := xmlNode.Text;
    //Log(Data);
    for i := 1 to length(data) do
    begin
      if ord(data[i]) - ord('a') = ord(foDiamond) then
        inc(cnt);
    end;
    //Log(IntToStr(cnt));

    Result := 'Name: "'
      + xmlNode.Attributes['name']
      + '", Level size: '
      + xmlNode.Attributes['width']
      + 'x'
      + xmlNode.Attributes['height']
      + ', Diamonds count: '
      + IntToStr(cnt)
      + ', Diamonds limit: '
      + xmlNode.Attributes['limit'];
  end
  else
    Result := '';
end;

procedure TFormMain.Log(s: String);
begin
  Memo1.lines.Add(s);
end;

procedure TFormMain.acLevelOpenExecute(Sender: TObject);
begin
  //loadFromNode(vstLevels.FocusedNode);
  vstLevelsDblClick(self);
end;

function TFormMain.isOpened(number: Integer): Boolean;
var
  i: Integer;
  f: TFormLevel;
begin
  Result := false;
  for i := 0 to PageControl1.PageCount - 1 do
  begin
    f := PageControl1.Pages[i].Controls[0] as TFormLevel;
    if f.levelIndex = number then
    begin
      Result := true;
      Break;
    end;
  end;
end;

procedure TFormMain.focusByIndex(number: Integer);
var
  i: Integer;
  f: TFormLevel;
begin
  for i := 0 to PageControl1.PageCount - 1 do
  begin
    f := PageControl1.Pages[i].Controls[0] as TFormLevel;
    if f.levelIndex = number then
    begin
      //PageControl1.Pages[i].SetFocus;
      PageControl1.ActivePageIndex := i;
      Break;
    end;
  end;
end;

procedure TFormMain.acLevelNewExecute(Sender: TObject);
var
  xmlNode: IXMLNode;
begin
  xmlNode := createNewNode;
  if Assigned(xmlNode) then
  begin
    updateTreeStructure;
    openNode(vstLevels.rootNode.ChildCount - 1, xmlNode);
  end;
  //Log(XMLConverter.XML.Text);
end;

function TFormMain.createNewNode:IXMLNode;
var
  root: IXMLNode;
begin
  if XMLConverter.IsEmptyDoc then
  begin
    createNewDocument;
  end;
  if FormNew.ShowModal = mrOk then
  begin
    root := XMLConverter.ChildNodes.First;
    Result := root.AddChild('level');
    Result.Attributes['name'] := FormNew.edName.Text;
    Result.Attributes['width'] := FormNew.edSizeX.Text;
    Result.Attributes['height'] := FormNew.edSizeY.Text;
    Result.Attributes['limit'] := FormNew.edLimit.Text;
  end
  else
    Result := nil;
end;

procedure TFormMain.createNewDocument;
var
  i: Integer;
  form:TFormLevel;
  root:IXMLNode;
begin
  if not XMLConverter.IsEmptyDoc then
  begin
    vstLevels.Clear;
    XMLConverter.ChildNodes.Clear;
  end;
  //DONE:   
  for i := 0 to PageControl1.PageCount - 1 do
  begin
    (PageControl1.Pages[i].Controls[0] as TFormLevel).Close;
  end;
  //DONE:    
  XMLConverter.XML.Text := '<levels version="0.01"></levels>';
  XMLConverter.Encoding := 'UTF-8';
  XMLConverter.Active := true;
end;

procedure TFormMain.updateTreeStructure;
var
  i:Integer;
  root: IXMLNode;
  node: PVirtualNode;
  nodeData: PNodeData;
begin
  vstLevels.Clear;
  root := XMLConverter.ChildNodes.First;
  for i := 0 to root.ChildNodes.Count - 1 do
  begin
    //lbLevelsList.AddItem(root.ChildNodes.Nodes[i].Attributes['name'],
    //  root.ChildNodes.Nodes[i]);
    if root.ChildNodes.Nodes[i].NodeName = 'level' then
    begin
      node := vstLevels.AddChild(nil);
      nodeData := vstLevels.GetNodeData(node);
      with nodeData^ do
      begin
        Caption := root.ChildNodes.Nodes[i].Attributes['name'];
        Value := root.ChildNodes.Nodes[i];
        //log('nn: ' + Value.NodeName);
      end;
    end;
  end;
  //Log('aaa' + XMLConverter.XML.Text + 'aaa');
end;

procedure TFormMain.acLevelDelExecute(Sender: TObject);
begin
  //
  DeleteFocused;
end;

procedure TFormMain.DoSaveLevel(Sender: TFormLevel);
begin
  updateTreeStructure;
end;

procedure TFormMain.closeByIndex(number: Integer);
var
  i: Integer;
  f: TFormLevel;
begin
  for i := 0 to PageControl1.PageCount - 1 do
  begin
    f := PageControl1.Pages[i].Controls[0] as TFormLevel;
    if f.levelIndex = number then
    begin
      (PageControl1.Pages[i].Controls[0] as TFormLevel).Close;
      Break;
    end;
  end;
end;

procedure TFormMain.DeleteFocused;
var
  node:PVirtualNode;
  data:PNodeData;
  index: Integer;
  i: Integer;
  form:TFormLevel;
begin
  node := vstLevels.FocusedNode;
  if Assigned(node) then
  begin
    data := vstLevels.GetNodeData(node);
    XMLConverter.ChildNodes.First.ChildNodes.Remove(data.Value);
    index := node.Index;
    for i := 0 to PageControl1.PageCount - 1 do
    begin
      form := PageControl1.Pages[i].Controls[0] as TFormLevel;
      if form.levelIndex = index then
        form.Close;
      if form.levelIndex > index then
        form.levelIndex := form.levelIndex - 1;
    end;
    updateTreeStructure;
  end;
end;

procedure TFormMain.setLastFileName(val: String);
begin
  fLastFilename := val;
  Caption := 'Editor - ' + val;
end;

procedure TFormMain.SaveDocument(FileName: String);
var
  i:Integer;
begin
  if XMLConverter.IsEmptyDoc then
      createNewDocument;

  for i := 0 to PageControl1.PageCount - 1 do
  begin
    (PageControl1.Pages[i].Controls[0] as TFormLevel).saveCurrent();
  end;

  LastFileName := FileName;
  XMLConverter.SaveToFile(LastFileName);
end;

end.
