unit uStringTools;

interface

type
  TStringArr = array of string;

function JoinString(Source: TStringArr; joinString: String = ''):String;
function DeformatString(Source:string;Divider:string=';';
  DeletingSymbol:string='"';TrimSpaces:boolean=true):TStringArr;

implementation

uses
  SysUtils;

function JoinString(Source: TStringArr; joinString: String = ''):String;
var
  i, len: Integer;
begin
  Result := '';
  len := Length(Source);
  for i := 0 to len - 1 do
  begin
    if i < (len - 1) then
      Result := Result + Source[i] + joinString
    else
      Result := Result + Source[i];
  end;
end;

function DeformatString(Source:string;Divider:string=';';DeletingSymbol:string='"';TrimSpaces:boolean=true):TStringArr;
begin
  SetLength(Result, 0);
  if DeletingSymbol<>'' then
    while pos(DeletingSymbol,Source)>0 do
      Source:=copy(Source,1,pos(DeletingSymbol,Source)-1)+copy(Source,pos(DeletingSymbol,Source)+1,length(Source)-pos(DeletingSymbol,Source));
  if copy(Source,length(Source),length(Divider))<>Divider then Source:=Source+Divider;
  while pos(Divider,Source)>0 do
  begin
    setLength(result,high(result)+2);
    result[high(result)]:=copy(Source,1,pos(Divider,Source)-1);
    if TrimSpaces then result[high(result)]:=trim(result[high(result)]);
    Source:=copy(Source,pos(Divider,Source)+length(Divider),length(Source)-pos(Divider,Source));
  end;
end;


end.
