﻿/**
 * ...
 * @author Werdn
 * TODO: Сварганить режим меню
 * TODO: Сварганить режим редактора карт (нужен хоть самый уродский UI)
 */

package ;

import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.Loader;
import flash.display.MovieClip;
import flash.display.PixelSnapping;
import flash.events.Event;
import flash.events.KeyboardEvent;
import flash.geom.ColorTransform;
import flash.text.Font;
import flash.text.TextField;
import flash.text.TextFormat;
import flash.xml.XML;
import flash.xml.XMLDocument;
import flash.xml.XMLNode;
import flash.xml.XMLNodeType;
import gears.Splash;
//import flash.geom.Matrix;
import flash.geom.Point;
import flash.geom.Rectangle;
import flash.Lib;
import flash.system.System;
import flash.ui.Keyboard;
import haxe.Resource;
import haxe.Timer;
import objects.Cell;
import objects.Look;
import objects.OnEndResult;
import sounds.SoundFactory;

class SpriteSet extends BitmapData
{
	public function new()
	{
		super(0, 0);
	}
}

class MenuSet extends BitmapData
{
	public function new()
	{
		super(0, 0);
	}
}

class BackgroundFill extends BitmapData
{
	public function new()
	{
		super(0, 0);
	}
}

class CracksSet extends BitmapData
{
	public function new()
	{
		super(0, 0);
	}
}

typedef Cells = Array<Array<Cell>>;

class Field extends MovieClip
{
	
	public static inline var cellSize:Int = 32;	// 32px for every cell
	
	private static var KILL_SELF_KEY:Int = new String('K').charCodeAt(0);
	private static var MENU_KEY:Int = new String('R').charCodeAt(0);
	
	private static var GAME_SPEED:Int = 30;
	
	public static var spriteSet:BitmapData = new SpriteSet();
	public static var cracksSet:BitmapData = new CracksSet();
	public static var menuSet:BitmapData = new MenuSet();
	
	var bufferBitmapData:BitmapData;
	var buffer:Bitmap;
	
	// режим работы
	var menuMode:Bool;
	
	var sizeX:Int;
	var sizeY:Int;
	// Логические координаты игрока
	var playerX:Int;
	var playerY:Int;
	// А энто направление движения юзерпика
	var playerDx:Int;
	var playerDy:Int;
	// Экранные координаты камеры (на всем поле)
	var cameraX:Int;
	var cameraY:Int;
	
	// Сплэш для левела (текст)
	public var mapSplashText:String;
	// Счет алмазов
	public var diamondsCount:Int;
	// Лимит выработки алмазов
	public var diamondsLimit:Int;
	// Cчет ключей
	public var keysCollected:Array<Bool>;
		
	var _cells:Cells;
	//TODO: Сделать нормальный геттер-сеттер, если это можно
	private function getCells(i:Int, j:Int):Cell
	{
		if ((i < 0) || (j < 0) || (i >= sizeX) || (j >= sizeY))
		{
			//return Cell.Wall(15, 0);
			return Cell.Unbreakable;
		}
		return _cells[i][j];
	}
	private function setCells(i:Int, j:Int, val:Cell)
	{
		if ((i < 0) || (j < 0) || (i >= sizeX) || (j >= sizeY))
		{
			return;
		}
		_cells[i][j] = val;
	}
	
	//	Направление движения
	var playerLook:Look;
	// Нажатия клавиш
	var isUp:Bool;
	var isDown:Bool;
	var isLeft:Bool;
	var isRight:Bool;
	var isHold:Bool;	// Признак удержания на месте
	//	Кадр анимации
	var frame:Int;
	// Кадр анимации главгероя
	var framePlayer:Int;
	var framePlayerNew:Bool;
	
	// Таймер для игры
	var timer:Timer;
	
	var startSplash:MovieClip;
	
	var gameOverTimer:Timer;
	var gameOverFlag:Bool;
	var gameActivateFlag:Bool;
	
	var onGameOver:OnEndResult -> Void;
	var onScoreUpdate:Void -> Void;
	
	private var returnToMenu:Bool;
	private var restartRequest:Bool;
	
	public function new(node:XML, onEnd:OnEndResult -> Void, onUpdate:Void -> Void, menuMode:Bool) 
	{
		super();
		
		this.menuMode = menuMode;
		
		returnToMenu = false;
		restartRequest = false;
		
		sizeX = 0;
		sizeY = 0;
		
		playerX = 1;
		playerY = 1;
		
		playerDx = 0;
		playerDy = 0;
		
		cameraX = 0;
		cameraY = 0;
		
		// Установка нормы выработка по умолчанию
		diamondsLimit = 0;
		
		onGameOver = onEnd;
		onScoreUpdate = onUpdate;
			
		bufferBitmapData = new BitmapData(600, 400, true, 0x000000);
		buffer = new Bitmap(bufferBitmapData, PixelSnapping.NEVER, false);		
		
		//TODO: тут должна быть загрузка уровня		
		//debugFill();
		if (menuMode)
		{
			//trace(menuData.elements('level')[0]);
			load(node);
			playerX = 1;
			playerY = 1;
		}
		else
		{
			load(node);
		}
		
		fixWalls();
		
		addChild(buffer);
	}
	
	/**
	 * ТруЪ функция загрузки уровня (без проверки валидности)
	 * @param	data
	 */
	private function load(data:XML)
	{
		sizeX = cast(data.attribute('width'));
		sizeY = cast(data.attribute('height'));
		diamondsLimit = cast(data.attribute('limit'));
		mapSplashText = cast(data.attribute('name')) +
			'<br>' + 
			((diamondsLimit == 0)?
				'Кристаллы не нужны':
				(diamondsLimit == 1)? 
					'Возьми хотя бы один кристалл':
					'Требуется кристаллов: ' + diamondsLimit) + 
			'<br>и жмакай пробел для старта';
			
		var lev:String = cast(data);
		lev = lev.split(' ').join('');
		lev = lev.split(String.fromCharCode(10)).join('');
		lev = lev.split(String.fromCharCode(13)).join('');
		lev = lev.split(String.fromCharCode(9)).join('');
		var pos:Int = 0;
		
		_cells = new Array();
		for (i in 0...sizeX)
		{
			_cells[i] = new Array();
			for (j in 0...sizeY)		
			{
				var c:Cell = Cell.Empty;
				switch(lev.charAt(pos))
				{
					case 'b': c = Cell.Wall(0, 0);
					case 'c': c = Cell.Netting(Math.round(Math.random() * 3));
					case 'd': c = Cell.Rock(true, true, 0, 0);
					case 'e': c = Cell.Diamond(Math.round(Math.random() * 3), true, true, 0, 0);
					case 'f': c = Cell.Barrel(true, true, 0, 0);
					case 'g': c = Cell.Key(0);
					case 'h': c = Cell.Key(1);
					case 'i': c = Cell.Key(2);
					case 'j': c = Cell.Key(3);
					case 'k': c = Cell.Door(0);
					case 'l': c = Cell.Door(1);
					case 'm': c = Cell.Door(2);
					case 'n': c = Cell.Door(3);
					case 'o': 
						playerX = i;
						playerY = j;
						c = Cell.StartPlace;
					case 'p': //TODO: Сделать конец левела и лимит выработки :)
						c = Cell.FinishPlace;
					case 'q': c = Cell.MonsterArrow(Look.Right, true, true, 0, 0);
					case 'r': c = Cell.MonsterArrow(Look.Down, true, true, 0, 0);
					case 's': c = Cell.MonsterArrow(Look.Left, true, true, 0, 0);
					case 't': c = Cell.MonsterArrow(Look.Up, true, true, 0, 0);
					case 'u': c = Cell.MonsterArrow(Look.Right, false, true, 0, 0);
					case 'v': c = Cell.MonsterArrow(Look.Down, false, true, 0, 0);
					case 'w': c = Cell.MonsterArrow(Look.Left, false, true, 0, 0);
					case 'x': c = Cell.MonsterArrow(Look.Up, false, true, 0, 0);
					default:
				}
				_cells[i][j] = c;
				pos ++;
			}
		}
		
	}
	
	/**
	 * Заполнение уровня всяким бредом
	 */
	private function debugFill():Void
	{
		//Подготовка поля (дебаг) 
		sizeX = 50;
		sizeY = 50;		
		_cells = new Array();
		for (i in 0...sizeX)
		{
			_cells[i] = new Array();
			for (j in 0...sizeY)		
			{
				_cells[i][j] = Cell.Empty;
			}
		}
		
		for (i in 0...sizeX)
		for (j in 0...sizeY)
		{
			// Тестовое заполнение
			if (i == 1 && j == 1)
			{
				_cells[i][j] = Cell.StartPlace;
			}
			else if (((i == 0) && (j == 0)) ||
				((i == 0) && (j == (sizeY - 1))) ||
				((i == (sizeX - 1)) && (j == 0)) ||
				((i == (sizeX - 1)) && (j == (sizeY - 1))) ||
				(i == 0) ||
				(j == 0) ||
				(i == (sizeX - 1)) ||
				(j == (sizeY - 1)))
			{
				_cells[i][j] = Cell.Wall(0, 0);
			}			
			else
			{
				if (Math.random() > 0.1)
				{
					if (Math.random() < 0.5)
					{
						if (Math.random() > 0.2)
						{
							_cells[i][j] = Cell.Netting(Math.round(Math.random() * 3));
						}
						else
						{
							if (Math.random() > 0.6)
							{
								_cells[i][j] = Cell.Rock(true, true, 0, 0);
							}
							else
							{
								if (Math.random() > 0.5)
								{
									_cells[i][j] = Cell.Diamond(Math.round(Math.random() * 3), true, true, 0, 0);
								}
								else
								{
									_cells[i][j] = Cell.Barrel(true, true, 0, 0);
								}
							}
						}
					}
					else
					{
						if (Math.random() < 0.01)
						{
							_cells[i][j] = Cell.MonsterArrow(Look.Right, true, false, 0, 0);
						}
						else
						{
							_cells[i][j] = Cell.Empty;
						}
					}
				}
				else
				{
					if(Math.random() > 0.2)
					{
						_cells[i][j] = Cell.Wall(0, 0);
					}
					else
					{
						if(Math.random() > 0.2)
						{
							_cells[i][j] = Cell.Door(Math.round(Math.random() * 3));
						}
						else
						{
							_cells[i][j] = Cell.Key(Math.round(Math.random() * 3));
						}
					}
				}
			}
		}
	}
	
	/**
	 * Фиксим стены дабы не было щелей, ато холодно
	 */
	private function fixWalls()
	{
		for (i in 0...sizeX)
		for (j in 0...sizeY)
		{
			if (isWall(i, j))
			{
				
				
				setCells(i, j, Cell.Wall(calcWallPicture(i, j), 0));
			}
		}
	}
	
	/**
	 * Определяем какие стены рядом с клеткой
	 * 	а) для рисования стен
	 * 	б) для рисования подпалин и трещин
	 * 	в) ????
	 * 	г) ПРОФИТ!
	 * @param	i
	 * @param	j
	 * @return
	 */
	function calcWallPicture(i:Int, j:Int):Int
	{
		var code:Int = 
				(isWall(i + 1, j)? 	1: 0)
			+ 	(isWall(i, j - 1)?	2: 0)
			+ 	(isWall(i - 1, j)?	4: 0)
			+ 	(isWall(i, j + 1)?	8: 0);
		
		return code;
	}
	
	/**
	 * Проверяе стена по координатам или нет
	 * @param	x
	 * @param	y
	 * @return
	 */
	private inline function isWall(x:Int, y:Int):Bool
	{
		switch(getCells(x, y))
		{
			case Wall(pic, corrupt): return true;
			default: return false;
		}
	}
	
	/**
	 * Подпаливаем стены
	 * @param	x
	 * @param	y
	 */
	private function corruptWall(x:Int, y:Int)
	{
		switch(getCells(x, y))
		{
			case Wall(pic, corrupt): 
				var mask:Int = pic & ~calcWallPicture(x, y);
				setCells(x, y, Cell.Wall(pic, corrupt | mask));
			default:
		}
	}
	
	function update()
	{	
		var t:Int = Lib.getTimer();
		
		// Плавно скроллим камеру (фишка)
		var dx = ((playerX << 5) - cameraX) >> 3;
		var dy = ((playerY << 5) - cameraY) >> 3;
		
		cameraX += dx;
		cameraY += dy;		
		
		// Поворочать плеером даем в любой момент времени а не по тику
		switch(playerLook)
		{
			case Dead, Arrive, Outcoming:
			default: 
				if (framePlayer == 0)
				{
					turnPlayer();
					framePlayerNew = true;
				}
		}
		
		// Когда кадр равен нулю производим передвижение робота
		if (framePlayer == 0)
		{
			// Двигаем плеера
			switch(playerLook)
			{
				case Dead, Arrive, Outcoming:
				default:
					// Двигаем конечностями (если они есть)
					movePlayer();
					// Жрем чего надыбали после шага (По иде хаваем зарание :)
					utilize(playerX, playerY);
			}
		}
		
		// Когда робот остановился — делаем чик-чик
		switch(playerLook)
		{
			case Up, Down, Left, Right: 
				framePlayer++;
				framePlayerNew = false;
			default:
				framePlayer = 0;
				framePlayerNew = false;
		}		
		// Обработка анимации роботика
		if (framePlayer > 3)
		{
			framePlayerNew = true;
			framePlayer = 0;
			//По факту достижения кадра делаем поглощение предмета
			// Жрем все что попало под руку (или упало на голову)
			utilize(playerX, playerY);
		}
	
		// Моргаем всеми видами монстров и анимаций из двух кадров
		frame++;
		if (frame > 3)
		{
			frame = 0;
			
			// Очищаем все блоки звуков
			SoundFactory.clearAllChannels();
			
			//if (playerLook != Look.Dead)
			/*switch(playerLook)
			{
				case Dead, Arrive, Outcoming:
				default:
					// Двигаем конечностями (если они есть)
					movePlayer();
			}*/
			
			for (j in 0...sizeY)
			for(i in 0...sizeX)
			{
				switch(getCells(i, j))
				{					
					//Надыбали камень
					case Rock(stand, active, dx, dy):
						if (active)
						{				
							//Проверка на возможность падения
							if (isRockCanDrop(i, j, stand))
							{
								if (getCells(i, j + 1) != Cell.Empty)
								{
									boom(i, j + 1);
								}
								else
								{ //Падение вниз
									setCells(i, j + 1, Cell.Rock(false, false, 0, 1));
									setCells(i, j, Cell.Empty);
								}							
							}
							//DONE: Сделать падение по бокам
							else if(isRockCanRoll(i, j))
							{
								//А вот тут самое оно — падение врпаво или влево
								var l:Bool = isCanDropLeft(i, j);
								var r:Bool = isCanDropRight(i, j);
								//if (l || r)
								//{
									//trace("x=" + i + ", px=" + playerX);
								//}
								if (l && r)
								{
									//Падение в случайном направлении
									var toLeft:Bool = Math.random() > 0.5;
									var dir:Int = toLeft? -1: 1;
									setCells(i + dir, j, Cell.Rock(false, toLeft, dir, 0));
									setCells(i, j, Cell.Empty);
								}
								else if (l)
								{
									setCells(i - 1, j, Cell.Rock(false, true, -1, 0));
									setCells(i, j, Cell.Empty);
								}
								else if (r)
								{
									setCells(i + 1, j, Cell.Rock(false, false, 1, 0));
									setCells(i, j, Cell.Empty);
								}
								else
								{	//Покоимся от безысходности
									setCells(i, j, Cell.Rock(true, true, 0, 0));
								}
								//DONE: Звучок как падает камень
								if (!stand)
								{
									SoundFactory.playRockDropSample();
								}
							}
							else 
							{
								// Никуда падать мы не можем
								//DONE: Звучок как падает камень
								setCells(i, j, Cell.Rock(true, true, 0, 0));
								if (!stand)
								{
									SoundFactory.playRockDropSample();
								}
							}							
						}
						else
						{	// активируем
							setCells(i, j, Cell.Rock(stand, true, dx, dy));
						}
					case Diamond(color, stand, active, dx, dy):
						if (active)
						{				
							//Проверка на возможность падения
							if (isRockCanDrop(i, j, stand))
							{
								if (getCells(i, j + 1) != Cell.Empty)
								{
									boom(i, j + 1);
								}
								else
								{ //Падение вниз
									setCells(i, j + 1, Cell.Diamond(color, false, false, 0, 1));
									setCells(i, j, Cell.Empty);
								}							
							}
							//DONE: Сделать падение по бокам
							else if(isRockCanRoll(i, j))
							{
								//А вот тут самое оно — падение врпаво или влево
								var l:Bool = isCanDropLeft(i, j);
								var r:Bool = isCanDropRight(i, j);
								//if (l || r)
								//{
									//trace("x=" + i + ", px=" + playerX);
								//}
								if (l && r)
								{
									//Падение в случайном направлении
									var toLeft:Bool = Math.random() > 0.5;
									var dir:Int = toLeft? -1: 1;
									setCells(i + dir, j, Cell.Diamond(color, false, toLeft, dir, 0));
									setCells(i, j, Cell.Empty);
								}
								else if (l)
								{
									setCells(i - 1, j, Cell.Diamond(color, false, true, -1, 0));
									setCells(i, j, Cell.Empty);
								}
								else if (r)
								{
									setCells(i + 1, j, Cell.Diamond(color, false, false, 1, 0));
									setCells(i, j, Cell.Empty);
								}
								else
								{	//Покоимся от безысходности
									setCells(i, j, Cell.Diamond(color, true, true, 0, 0));
								}
								//DONE: Звучек падения олмаза
								if (!stand)
								{
									SoundFactory.playDiamondDropSample();
								}
							}
							else 
							{
								// Никуда падать мы не можем
								//DONE: Звучек падения олмаза
								if (!stand)
								{
									SoundFactory.playDiamondDropSample();
								}
								setCells(i, j, Cell.Diamond(color, true, true, 0, 0));
							}							
						}
						else
						{	// активируем
							setCells(i, j, Cell.Diamond(color, stand, true, dx, dy));
						}
					//Надыбали бочку
					case Barrel(stand, active, dx, dy):
						if (active)
						{				
							//Проверяем горит ли что рядом
							if(isFlame(i + 1, j, true) || 
								isFlame(i - 1, j) ||
								isFlame(i, j + 1, true) ||
								isFlame(i, j - 1))
							{
								boom(i, j);
							}
							//Проверка на возможность падения
							else if (isRockCanDrop(i, j, stand))
							{
								if (getCells(i, j + 1) != Cell.Empty)
								{
									boom(i, j + 1);
								}
								else
								{ //Падение вниз
									setCells(i, j + 1, Cell.Barrel(false, false, 0, 1));
									setCells(i, j, Cell.Empty);
								}							
							}							
							else 
							{
								// Никуда падать мы не можем
								if (!stand)
								{
									// Бочка взрывается
									boom(i, j);
								}
								else
								{									
									setCells(i, j, Cell.Barrel(true, true, 0, 0));
								}
								/*setCells(i, j, Cell.Barrel(true, true, 0, 0));
								if (!stand)
								{
									SoundFactory.playRockDropSample();
								}*/
							}							
						}
						else
						{	// активируем
							setCells(i, j, Cell.Barrel(stand, true, dx, dy));
						}
					case MonsterArrow(look, leftHand, active, dx, dy):
						// Активные двтгаем (те что против сканирования автоактивируются)
						if(active)
						{
							switch(look)
							{
								case Stand:	//Стоячих делаем бегущими вправо
									setCells(i, j, Cell.MonsterArrow(Look.Right, leftHand, false, 0, 0));
								case Right: //ловим Правобегущих
									if (isMonsterCanMove(i, j + (leftHand ? - 1 : 1)))
									{
										setCells(i, j + (leftHand ? - 1 : 1), 
											Cell.MonsterArrow(leftHand ? Look.Up :Look.Down,
												leftHand, leftHand,
												0, leftHand? -1 : 1));
										setCells(i, j, Cell.Empty);
									}
									else if (isMonsterCanMove(i + 1, j))
									{
										setCells(i + 1, j, Cell.MonsterArrow(look, leftHand, false, 1, 0));
										setCells(i, j, Cell.Empty);
									}
									else
									{
										setCells(i, j, Cell.MonsterArrow(leftHand ? Look.Down : Look.Up, 
											leftHand, !leftHand,
											0, 0));
									}
								case Down: //бегущих вниз
									if (isMonsterCanMove(i + (leftHand ? 1 : -1), j))
									{
										setCells(i + (leftHand ? 1 : -1), j, 
											Cell.MonsterArrow(leftHand ? Look.Right : Look.Left,
												leftHand, !leftHand,
												leftHand? 1 : -1, 0));
										setCells(i, j, Cell.Empty);
									}
									else if (isMonsterCanMove(i, j + 1))
									{
										setCells(i, j + 1, Cell.MonsterArrow(look, leftHand, false, 0, 1));
										setCells(i, j, Cell.Empty);
									}
									else
									{
										setCells(i, j, Cell.MonsterArrow(leftHand ? Look.Left : Look.Right, 
											leftHand, leftHand, 0, 0));
									}
								case Left:
									if (isMonsterCanMove(i, j + (leftHand ? 1 : -1)))
									{
										setCells(i, j + (leftHand ? 1 : -1), 
											Cell.MonsterArrow(leftHand ? Look.Down :Look.Up,
												leftHand, !leftHand,
												0, leftHand? 1: -1));
										setCells(i, j, Cell.Empty);
									}
									else if (isMonsterCanMove(i - 1, j))
									{
										setCells(i - 1, j, Cell.MonsterArrow(look, leftHand, true, -1, 0));
										setCells(i, j, Cell.Empty);
									}
									else
									{
										setCells(i, j, Cell.MonsterArrow(leftHand ? Look.Up : Look.Down, 
											leftHand, leftHand, 0, 0));
									}
								case Up: //набигающих вверх
									if (isMonsterCanMove(i + (leftHand ? -1 : 1), j))
									{
										setCells(i + (leftHand ? -1 : 1), j, 
											Cell.MonsterArrow(leftHand ? Look.Left : Look.Right,
												leftHand, leftHand,
												leftHand? -1: 1, 0));
										setCells(i, j, Cell.Empty);
									}
									else if (isMonsterCanMove(i, j - 1))
									{
										setCells(i, j - 1, Cell.MonsterArrow(look, leftHand, true, 0, -1));
										setCells(i, j, Cell.Empty);
									}
									else
									{
										setCells(i, j, Cell.MonsterArrow(leftHand ? Look.Right : Look.Left, 
											leftHand, !leftHand, 0, 0));
									}
								default:
							}
						}
						else
						{
							setCells(i, j, Cell.MonsterArrow(look, leftHand, true, dx, dy));
						}
					case Flame(pic, active):
						if (active)
						{
							if (pic == 5)
							{
								setCells(i, j, Cell.Empty);
							}
							else
							{
								setCells(i, j, Cell.Flame(pic + 1, true));
							}
						}
						else
						{
							setCells(i, j, Cell.Flame(pic, true));
						}
					case DoorOpening(pic):
						if (pic == 5)
						{
							setCells(i, j, Cell.Empty);
						}
						else
						{
							setCells(i, j, Cell.DoorOpening(pic + 1));
						}
					/*
					case StartPlace:
						switch(playerLook)
						{
							case Dead:
							default:
								gameActivateFlag = true;
								setCells(playerX, playerY, Cell.StartPlaceActive(0));
								SoundFactory.playDoorSample();
						} 
					*/  
					//Надыбали вход при открытии
					case StartPlaceActive(pic):
						if (pic == 15)
						{
							setCells(i, j, Cell.StartPlaceInactive);
						}
						else
						{
							setCells(i, j, Cell.StartPlaceActive(pic + 1));
							if (pic == 9)
							{
								SoundFactory.playDoorSample();
								playerLook = Look.Stand;
							}
						}
					//Надыбали выход, проверяем можно ли выйти :)
					case FinishPlace:
						if (diamondsCount >= diamondsLimit)
						{
							// Открываем двери
							SoundFactory.playDoorSample();
							setCells(i, j, Cell.FinishPlaceOpening(0));
						}
					case FinishPlaceOpening(pic):						
						if (pic == 5)
						{
							setCells(i, j, Cell.FinishPlaceOpened);
						}
						else
						{
							setCells(i, j, Cell.FinishPlaceOpening(pic + 1));
						}
					case FinishPlaceClosing(pic):						
						if (pic == 5)
						{
							setCells(i, j, Cell.FinishPlaceClosed);
						}
						else
						{
							setCells(i, j, Cell.FinishPlaceClosing(pic + 1));
						}
					default:
				}
			}
		}
		
		// Рисуем
		draw();
		
		t = (Lib.getTimer() - t);
		if (t > (GAME_SPEED - 10))
		{
			//trace("delay " + t);
		}
	}
	
	/**
	 * Взрываем все и вся
	 * @param	i
	 * @param	j
	 */
	private function boom(i:Int, j:Int, ?player:Bool = false):Void
	{
		//DONE: Звучок взрыва
		SoundFactory.playExplodeSample();
		
		//explode(i, j);
		setCells(i, j, Cell.Flame(0, true));
		
		explode(i, j - 1, true);
		explode(i - 1, j - 1, true);
		explode(i + 1, j - 1, true);
			
		explode(i - 1, j, true);
		explode(i + 1, j, player);
		
		explode(i, j + 1, player);
		explode(i - 1, j + 1, player);
		explode(i + 1, j + 1, player);
		
		for (x in -2...3)
		{
			corruptWall(i + x, j - 2);
			corruptWall(i + x, j + 2);			
		}
		for (y in -1...2)
		{
			corruptWall(i - 2, j + y);
			corruptWall(i + 2, j + y);
		}
	}
	
	/**
	 * Как бы врывается клетка
	 * (было: клетка может взорваться по полной)
	 * стало: клетка замещается огнем
	 * @param	x
	 * @param	y
	 */
	private function explode(x:Int, y:Int, active:Bool)
	{
		//if (isExplosive(x, y))
		//{
			//boom(x, y);
		//}
		//else
		//{
		setCells(x, y, Cell.Flame(0, active));
		//}
	}
	
	/**
	 * 
	 * @param	x
	 * @param	y
	 * @return
	 */
	private function isExplosive(xx:Int, yy:Int):Bool
	{
		return switch(getCells(xx, yy))
		{
			case Barrel(a, b, c, d): true;
			default: false;
		}
	}
	
	private function isFlame(x:Int, y:Int, ?forward:Bool = false):Bool
	{
		switch(getCells(x, y))
		{
			//Огонь может поджигать только активный
			case Flame(pic, active):
				return (forward || (pic > 0)) && active;
			default:
				return false;
		}
	}
	
	/**
	 * Проверяет может ли двигаться монстр
	 * @param	x
	 * @param	y
	 * @return
	 */
	private function isMonsterCanMove(x:Int, y:Int):Bool
	{
		if ((x >= 0) && (x < sizeX) && (y >= 0) && (y < sizeY))
		{
			var t:Cell = getCells(x, y);
			//return (t == Cell.Empty);
			return switch(t)
			{
				case Empty: true;
				default: false;
			}
		}
		else
		{
			return false;
		}
	}
	
	/**
	 * Может ли упасть любой падучий предмет (вниз)
	 * @param	x Позиция самого камня а не точки назначения
	 * @param	y
	 * @return
	 */
	private function isRockCanDrop(x:Int, y:Int, objStand:Bool):Bool
	{
		if (objStand && (x == playerX) && ((y + 1) == playerY))
		{
			return false;
		}
		if ((y + 1) < sizeY)
		{
			var t:Cell = getCells(x, y + 1);
			switch(t)
			{
				case Empty:
					return true;
				case MonsterArrow(look, leftHand, active, dx, dy):
					return true;
				case Barrel(stand, active, dx, dy):
					return !objStand;
				default:
			}
		}
		return false;
	}
	
	/**
	 * Проверяем может ли камень, который не может падать вниз стоять на месте
	 * не может только на круглой поверхности
	 * @param	x
	 * @param	y
	 */
	private function isRockCanRoll(x:Int, y:Int):Bool
	{
		var t:Cell = getCells(x, y + 1);
		//	Определяем основание
		var base:Bool = switch(t)
		{
			case Rock(a, b, c, d): true;
			case Diamond(color, a, b, c, d): true;
			default: false;
		}
		return base;
	}
	
	/**
	 * Проверка на падаемость слева
	 * @param	x
	 * @param	y
	 * @return
	 */
	private inline function isCanDropLeft(x:Int, y:Int):Bool
	{
		return isEmpty(x - 1, y) && isEmpty(x - 1, y + 1);
	}
	
	/**
	 * Проверка на падучесть справа
	 * @param	x
	 * @param	y
	 * @return
	 */
	private inline function isCanDropRight(x:Int, y:Int):Bool
	{
		return isEmpty(x + 1, y) && isEmpty(x + 1, y + 1);
	}
	
	/**
	 * Проверка на пустоту
	 * @param	x
	 * @param	y
	 * @return
	 */
	private function isEmpty(x:Int, y:Int):Bool
	{
		if ((x == playerX) && (y == playerY))
		{
			return false;
		}
		else
		{
			switch(getCells(x, y))
			{
				case Empty: return true;
				default: return false;
			};
		}
	}
		
	/**
	 * Рисувание всего сразу
	 */
	public function draw()
	{
		//Очищаем буффер
		var ct:ColorTransform = new ColorTransform();
		ct.alphaMultiplier = 0;
		buffer.bitmapData.colorTransform(buffer.bitmapData.rect, ct);
		//Рисуем
		//buffer.bitmapData.draw(spriteSet);
		
		var xx:Int = (buffer.bitmapData.width >> 1) - cameraX;
		var yy:Int = (buffer.bitmapData.height >> 1) - cameraY;
		
		var sx:Int = cameraX >> 5;
		var sy:Int = cameraY >> 5;
		
		var xr:Int = (buffer.bitmapData.width >> 6) + 1;
		var yr:Int = (buffer.bitmapData.height >> 6) + 1;
		
		for (i in sx - xr ... sx + xr + 1)
		for (j in sy - yr ... sy + yr + 1)
		{
			//buffer.bitmapData.setPixel32(i * 32, j * 32, 0xff0000ff);
			drawCell(xx + (i << 5), yy + (j << 5), getCells(i, j));
		}
		
		if(menuMode)
		{
			for (i in 0...4)
			{
				drawMenuItem(xx + 160, yy + 64 + (i << 6), i);
			}
		}
		//trace(cameraY);
		drawPlayer(xx + (playerX << 5), yy + (playerY << 5));
	}
	
	/**
	 * Рисует один кирпич по экранным координатам
	 * @param	x
	 * @param	y
	 * @param	c
	 */
	private function drawCell(x:Int, y:Int, c:Cell)
	{
		var sx:Int = 0;
		var sy:Int = 0;
		
		var cor:Int = 0;
		
		switch(c)
		{
			case Empty:
				return;
			case Wall(pic, corrupt):
				sx = pic & 0x0f;
				sy = 4;
				cor = corrupt;
			case Unbreakable:
				sx = 4;
				sy = 6;
			case Netting(pic):
				sx = 0;
				sy = 6 + pic;
			case Rock(stand, active, dx, dy):
				sx = 1;
				sy = 6;
				x -= dx * 8 * (3 - frame);
				y -= dy * 8 * (3 - frame);
			case Diamond(color, stand, active, dx, dy):
				sx = 2;
				sy = 6 + color;
				x -= dx * 8 * (3 - frame);
				y -= dy * 8 * (3 - frame);	
			case MonsterArrow(look, leftHand, active, dx, dy):
				sy = frame;
				switch(look)
				{
					case Right:
						sx = 5;
					case Down:
						sx = 6;
					case Left:
						sx = 7;
					case Up:
						sx = 8;
					default:
						sx = 5;
				}
				x -= dx * 8 * (3 - frame);
				y -= dy * 8 * (3 - frame);
			case Flame(pic, active):
				sx = pic;
				sy = 5;
			case Barrel(stand, active, dx, dy):
				sx = 3;
				sy = 6;
				x -= dx * 8 * (3 - frame);
				y -= dy * 8 * (3 - frame);	
			case Key(color):
				sx = 10 + color;
				sy = 11;
			case Door(color):
				sx = 10 + color;
				sy = 12;
			case DoorOpening(pic):
				sx = 6 + pic;
				sy = 5;
			case StartPlace:
				sx = 9;
				sy = frame;
			case StartPlaceActive(pic):
				sx = pic;
				sy = 10;
			case StartPlaceInactive:
				sx = 1;
				sy = 7;
			case FinishPlace:
				sx = 10;
				sy = frame;
			case FinishPlaceOpening(pic):
				sx = 6 + pic;
				sy = 6;
			case FinishPlaceOpened:
				sx = 11;
				sy = 6;
			case FinishPlaceClosing(pic):
				sx = 6 + pic;
				sy = 7;
			case FinishPlaceClosed:
				sx = 1;
				sy = 8;
			default:
				sx = 15;
				sy = 15;
		}
		
		sx <<= 5;
		sy <<= 5;
		
		buffer.bitmapData.copyPixels(spriteSet, new Rectangle(sx, sy, 32, 32), new Point(x, y), 
			spriteSet, new Point(sx, sy), true); 
		if (cor > 0)
		{
			sx = cor * 48;
			sy = 0;
			buffer.bitmapData.copyPixels(cracksSet, new Rectangle(sx, sy, 48, 48), new Point(x - 8, y - 8), 
				cracksSet, new Point(sx, sy), true);
		}
	}
	
	/**
	 * Рисуем пункт меню
	 * @param	x
	 * @param	y
	 * @param	n
	 */
	private function drawMenuItem(x:Int, y:Int, n:Int)
	{
		var sx:Int = 0;
		var sy:Int = 0 + n;
		
		sx <<= 5;
		sy <<= 5;
		
		buffer.bitmapData.copyPixels(menuSet, new Rectangle(sx, sy, 300, 32), new Point(x, y), 
			menuSet, new Point(sx, sy), true); 
	}	
	
	private function drawPlayer(x: Int, y:Int)
	{
		// Дохлого не рисуем
		/*if (playerLook == Look.Dead || pla)
		{
			return;
		}*/
		switch(playerLook)
		{
			case Dead, Arrive, Outcoming: return;
			default:
		}
		
		var sx:Int = 0;
		var sy:Int = 0;
		
		switch(playerLook)
		{
			case Look.Stand:
				sx = 0;
				if (playerDx > 0)
				{
					sx = 1;
				}
				else if (playerDx < 0)
				{
					sx = 2;
				}
				else if (playerDy < 0)
				{
					sx = 3;
				}
				else if (playerDy > 0)
				{
					sx = 4;
				}
			case Look.Right:
				sx = 1;
			case Look.Left:
				sx = 2;	
			case Look.Up:
				sx = 3;
			case Look.Down:
				sx = 4;
			case Look.Dead:
				return;
		}
		
		sy += framePlayer;
		//trace(sy);
		
		sx <<= 5;
		sy <<= 5;
		
		if(!framePlayerNew)
		{
			x -= playerDx * 8 * (4 - framePlayer);
			y -= playerDy * 8 * (4 - framePlayer);
		}
	
			
		buffer.bitmapData.copyPixels(spriteSet, new Rectangle(sx, sy, 32, 32), new Point(x, y),
			spriteSet, new Point(sx, sy), true); 
	}
	
	/**
	 * Осуществляем поворот
	 */
	function turnPlayer()
	{
		// Поворачиавем героя
		if(isLeft)
		{
			playerLook = Look.Left;
		}
		else if(isRight)
		{
			playerLook = Look.Right;
		}
		else if(isUp)
		{
			playerLook = Look.Up;
		}
		else if(isDown)
		{
			playerLook = Look.Down;
		}
		else
		{			
			playerLook = Look.Stand;	
		}
	}
	
	/**
	 * Двигаем плеера
	 */
	function movePlayer()
	{		
		// Жрем чего надыбали после шага
		utilize(playerX, playerY);
		// А теперь смотрим куда двигать можно
		playerDx = 0;
		playerDy = 0;
		var servo:Bool = false;
		switch(playerLook)
		{
			case Up: 
				if(isPlayerCanMove(playerX, playerY - 1))
				{
					if(!isHold)
					{
						playerY --;
						playerDy = -1;
						servo = true;
					}
					else
					{
						//Жрем не сходя с места
						utilize(playerX, playerY - 1);
					}
				}
				else
				{
					//Не можем пройти — сбрасываем анимацию робота (следующим ходом будет 0)
					//FIXME: Странное поведение (от УГ)
					framePlayer = 3;
				}
			case Down: 
				if(isPlayerCanMove(playerX, playerY + 1))
				{
					if(!isHold)
					{
						playerY ++;
						playerDy = 1;
						servo = true;
					}
					else
					{
						//Жрем не сходя с места
						utilize(playerX, playerY + 1);
					}
				}
				else
				{
					//Не можем пройти — сбрасываем анимацию робота (следующим ходом будет 0)
					//FIXME: Странное поведение (от УГ)
					framePlayer = 3;
				}
			case Left: 
				if(isPlayerCanMove(playerX - 1, playerY))
				{
					if(!isHold)
					{
						playerX --;
						playerDx = -1;
						servo = true;
					}
					else
					{
						//Жрем не сходя с места
						utilize(playerX - 1, playerY);
					}
				}
				else if (isPlayerCanPushLeft(playerX, playerY))
				{
					//DONE: Звучок толкания
					SoundFactory.playPushSample();
					servo = true;
					switch(getCells(playerX - 1, playerY))
					{
						case Rock(a, b, c, d):
							setCells(playerX - 2, playerY, Cell.Rock(true, false, -1, 0));
						case Barrel(a, b, c, d):
							setCells(playerX - 2, playerY, Cell.Barrel(true, false, -1, 0));
						default:
					}
					setCells(playerX - 1, playerY, Cell.Empty);
					if(!isHold)
					{
						//Толкаем
						playerX --;
						playerDx = -1;
						servo = true;
					}
				}
				else
				{
					//Не могу ни пойти ни толкнуть
					//FIXME: Странное поведение (от УГ)
					framePlayer = 3;
				}
			case Right: 
				if(isPlayerCanMove(playerX + 1, playerY))
				{
					if(!isHold)
					{
						servo = true;
						playerX ++;
						playerDx = 1;
					}
					else
					{
						//Жрем не сходя с места
						utilize(playerX + 1, playerY);
					}
				}
				else if (isPlayerCanPushRight(playerX, playerY))
				{
					//DONE: Звучок толкания
					SoundFactory.playPushSample();
					servo = true;
					switch(getCells(playerX + 1, playerY))
					{
						case Rock(a, b, c, d):
							setCells(playerX + 2, playerY, Cell.Rock(true, false, 1, 0));
						case Barrel(a, b, c, d):
							setCells(playerX + 2, playerY, Cell.Barrel(true, false, 1, 0));
						default:
					}
					setCells(playerX + 1, playerY, Cell.Empty);
					if(!isHold)
					{
						//Толкаем
						servo = true;
						playerX ++;
						playerDx = 1;
					}
				}
				else
				{
					//FIXME: Странное поведение (от УГ)
					framePlayer = 3;
				}
			// В иных состояниях робот передвигаться не может
			default:
				return;
		}
		if (servo)
		{
			SoundFactory.playServoSample();
		}
	}
		
	/**
	 * Проверка может ли персонаж двигаться туда или сюда
	 * @param	x
	 * @param	y
	 * @return
	 */
	private function isPlayerCanMove(x:Int, y:Int):Bool
	{
		if ((x >= 0) && (x < sizeX) && (y >= 0) && (y < sizeY))
		{
			//var t:Cell = cells[x][y];
			var t:Cell = getCells(x, y);
			var b:Bool = switch(t)
			{
				case Empty: true;
				case Netting(a): true;
				//case Rock(stand, a, b, c): !stand;
				case Diamond(color, stand, active, dx, dy): true;
				case MonsterArrow(a, b, c, d, e): true;
				case Flame(p, a): true;
				case Key(color):true;
				case Door(color):
					//TODO: Сделать учет ключей
					//Если ключ цвета есть, то начинаем открывание
					if (keysCollected[color])
					{
						SoundFactory.playDoorSample();
						setCells(x, y, Cell.DoorOpening(0));
					}
					false;
				case FinishPlaceOpened: 
					// Даем время на кадры анимации вхождения внутрь лифта
					(frame == 3);
				default: false;
			}
			return b;
		}
		return false;
	}
	
	/**
	 * Может ли юзернейм толкать камень
	 * @param	x
	 * @param	y
	 * @return
	 */
	private function isPlayerCanPushLeft(x:Int, y:Int):Bool
	{
		var t:Cell = getCells(x - 1, y);
		switch(t)
		{
			case Rock(stand, a, b, c), Barrel(stand, a, b, c):
				// сравнение с тройкой заставит синхронизироваться робота с циклом анимации
				return stand && isEmpty(x - 2, y) && (!isEmpty(x - 1, y + 1)) && (frame == 3);
			default: 
				return false;
		}
	}
	
	/**
	 * Можем ли толкать вправо
	 * @param	x
	 * @param	y
	 * @return
	 */
	private function isPlayerCanPushRight(x:Int, y:Int):Bool
	{
		var t:Cell = getCells(x + 1, y);
		switch(t)
		{
			case Rock(stand, a, b, c), Barrel(stand, a, b, c):
				return stand && isEmpty(x + 2, y) && (!isEmpty(x + 1, y + 1)) && (frame == 3);
			default: 
				return false;
		}
	}
	
	/**
	 * Сжираем что надыбали (или на нас упало что)
	 */
	private function utilize(x:Int, y:Int)
	{
		// Для подсчета очков извлекаем содержимое
		var t:Cell = getCells(x, y);
		switch(t)
		{
			case Empty, StartPlace, StartPlaceInactive:
				return;
			case Wall(pic, corrupt):
				return;
			case StartPlaceActive(pic):
				return;
			case Netting(a):
				//DONE: Звучок как чувак копает
				SoundFactory.playNettingSample();
				setCells(x, y, Cell.Empty);
			case MonsterArrow(look, leftHand, active, dx, dy): die();
			case Rock(stand, active, dx, dy): die();
			case Diamond(color, stand, active, dx, dy):
				if (stand)
				{
					setCells(x, y, Cell.Empty);
					diamondsCount ++;
					if (onScoreUpdate != null)
					{
						onScoreUpdate();
					}
					//DONE: Звучок как собран алмазик
					SoundFactory.playDiamondSample();
				}
				else
				{
					die();
				}
			case Flame(pic, active): 
				// Смерть в агне
				die();
			case Key(color):
				//Собираем ключ
				//DONE: Звучек собирания ключа
				SoundFactory.playKeySample();
				keysCollected[color] = true;
				setCells(x, y, Cell.Empty);
				if (onScoreUpdate != null)
				{
					onScoreUpdate();
				}
			//	Закрываем дверь следом за нашим клиентом
			case FinishPlaceOpened:
				// На нуль проверяем дабы дать время на кадры анимации вхождения внутрь
				if(!isHold && (frame == 0)) 
				{
					//Закрываем дверь
					SoundFactory.playDoorSample();
					//DONE: Непонятное поведение счетчика кадров
					setCells(x, y, Cell.FinishPlaceClosing(0));
				}
			case FinishPlaceClosing(pic):
				epicWin();
			default: 
				//Все остальное чувак не хавает принципиально, несварение у него		
		}
	}
	
	/**
	 * Смерть
	 */
	private function die()
	{
		boom(playerX, playerY, true);
		playerLook = Look.Dead;
		
		gameOverTimer = new Timer(3000);
		gameOverTimer.run = gameOver;
	}
	
	/**
	 * Победа
	 */
	private function epicWin()
	{
		if (playerLook != Look.Outcoming)
		{
			playerLook = Look.Outcoming;
			
			gameOverTimer = new Timer(3000);
			gameOverTimer.run = gameWin;
		}
	}
	
	/**
	 * Начинаем игру дерганием этого
	 */
	public function start()
	{
		frame = 0;
		framePlayer = 0;
		framePlayerNew = true;
		
		playerLook = menuMode? Look.Stand: Look.Arrive;
		
		diamondsCount = 0;
		
		keysCollected = new Array();
		
		gameOverFlag = false;
		gameActivateFlag = menuMode;
		
		if (onScoreUpdate != null)
		{
			onScoreUpdate();
		}
		
		if(!menuMode)
		{
			startSplash = new Splash(mapSplashText);
			addChild(startSplash);
		}
		else
		{
			startSplash = new Splash('<p align="center">ЖЫЛЕЗНЫЙ РОБОТ<br>добро пожаловать</p>');
			addChild(startSplash);
		}
		
		
		timer = new Timer(GAME_SPEED);
		timer.run = update;
		
		Lib.current.stage.addEventListener(KeyboardEvent.KEY_DOWN, onKeyDown);
		Lib.current.stage.addEventListener(KeyboardEvent.KEY_UP, onKeyUp);
	}
	
	/**
	 * Показываем картинку GAME OVER
	 */
	public function gameOver()
	{	
		if (!gameOverFlag)
		{
			gameOverTimer.stop();
			gameOverTimer = null;
			if (returnToMenu || restartRequest)
			{
				end();
			}
			else
			{
				addChild(new Splash('Неудача<br>жми пробел'));
				/*
				var c:MovieClip = Lib.attach("lib.gameover.png");
				c.x = (buffer.width - c.width) / 2;
				c.y = (buffer.height - c.height) / 2;
				addChild(c);
				*/
			}
			gameOverFlag = true;
		}
	}
	
	/**
	 * А это выиграли все
	 */
	private function gameWin()
	{
		if (!gameOverFlag)
		{
			gameOverTimer.stop();
			gameOverTimer = null;
			if (menuMode)
			{
				end();
			}
			else
			{
				addChild(new Splash('Отличная работа<br>нажимай пробел'));
				//DONE: Сделать жизнерадостный такой картинка
				/*
				var c:MovieClip = Lib.attach("lib.gamewin.png");
				c.x = (buffer.width - c.width) / 2;
				c.y = (buffer.height - c.height) / 2;
				addChild(c);
				*/
			}
			gameOverFlag = true;
		}
	}
	
	/**
	 * Завершаем игру, останавливаем таймер, удаляем обработчики
	 */
	public function end()
	{
		if(Lib.current.stage.hasEventListener(KeyboardEvent.KEY_DOWN))
		{
			Lib.current.stage.removeEventListener(KeyboardEvent.KEY_DOWN, onKeyDown);
		}
		if(Lib.current.stage.hasEventListener(KeyboardEvent.KEY_UP))
		{
			Lib.current.stage.removeEventListener(KeyboardEvent.KEY_UP, onKeyUp);
		}
		if (gameOverTimer != null)
		{
			gameOverTimer.stop();
			gameOverTimer = null;
		}
		if(timer != null)
		{
			timer.stop();
			timer = null;
		}
		//trace("end");
		parent.removeChild(this);
		if (onGameOver != null)
		{
			if (returnToMenu)
			{
				onGameOver(OnEndResult.Menu(0));
			}
			else
			{
				switch(playerLook)
				{
					case Dead:
						onGameOver(OnEndResult.Die);
					case Outcoming:
						if (menuMode)
						{
							switch(playerY)
							{
								case 2: onGameOver(OnEndResult.Menu(1));
								case 4: onGameOver(OnEndResult.Menu(2));
								case 6: onGameOver(OnEndResult.Menu(3));
								case 8: onGameOver(OnEndResult.Menu(4));
							}
						}
						else
						{
							onGameOver(OnEndResult.Win(diamondsCount));
						}
					default:
						//TODO: Сделать возврат из меню с параметрами
						onGameOver(OnEndResult.Menu(0));
				}
			}
			onGameOver = null;
		}
	}
	
	/**
	 * Обработчик клавиатуры (отпускание клавиши)
	 * @param	e
	 */
	private function onKeyUp(e:KeyboardEvent):Void 
	{
		switch(e.keyCode) 
		{
			case Keyboard.LEFT:
				isLeft = false;
			case Keyboard.RIGHT:
				isRight = false;
			case Keyboard.UP:
				isUp = false;
			case Keyboard.DOWN:
				isDown = false;
			case Keyboard.SPACE:
				isHold = false;
		}
	}
	
	/**
	 * Обработчик клавиатуры
	 * @param	e
	 */
	private function onKeyDown(e:KeyboardEvent):Void 
	{
		switch(e.keyCode) 
		{
			case Keyboard.LEFT:
				isLeft = true;
			case Keyboard.RIGHT:
				isRight = true;
			case Keyboard.UP:
				isUp = true;
			case Keyboard.DOWN:
				isDown = true;
			case KILL_SELF_KEY:
				if (!menuMode)
				{
					switch (playerLook)//if (playerLook != Look.Dead)
					{
						case Dead, Outcoming:
						default: 
							restartRequest = true;
							die();
					}
				}
			case MENU_KEY:
				if(!menuMode)
				{
					returnToMenu = true;
					switch(playerLook)
					{
						case Dead:
						default: die();
					}
				}
			case Keyboard.SPACE:
				isHold = true;
				if(gameOverFlag)
				{
					end();
				}
				else
				{
					if(!gameActivateFlag)
					{
						switch(playerLook)
						{
							case Dead:
							default:
								removeChild(startSplash);
								gameActivateFlag = true;
								setCells(playerX, playerY, Cell.StartPlaceActive(0));
								SoundFactory.playDoorSample();
						}
					}
				}
		}
	}	
}