﻿package ;

import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.geom.ColorTransform;
import flash.geom.Point;
import flash.geom.Rectangle;
import flash.Lib;
import flash.net.SharedObject;
import flash.ui.ContextMenu;
import flash.xml.XML;
import gears.InfoScreen;
import haxe.Resource;
import objects.Cell;
import objects.OnEndResult;

/**
 * ...
 * @author Werdn
 */

//TODO: !!! Сделать отображение счета, ключей  и времени (время считать по тикам)
class Game 
{
	private static var menuData:XML = new XML(Resource.getString('xmlmenu'));
	private static var levelData:XML = new XML(Resource.getString('xmllevels'));
	
	var field:Field;
	
	var keysBar:Bitmap;
	var limitbar:Bitmap;
	var scoreBar:Bitmap;	

	//TODO: Сделать уровни в одном ХМЛ-файле и убрать это убожество
	// Число левелов
	private static var levelsTotal:Int = levelData.elements('level').length();
	//Читерский параметр
	//УГ!!! Все разрабы — читеры! Они не могут без читов как без воздуха!
	//Даешь античит всем разрабам всех игр! Ато они издевают чувства рядового геймера!!!!
	//private static var levelStartCheat:Int = 15;
	private static var levelStartCheat:Int = 0;
	// Текущий левел
	private var currentLevel:Int;
	// Имя шаред обжекта для сохраненок
	private static var saveObjectName:String = 'Diamonds';
	
	static function main() 
	{
		//trace(levelsTotal);
		new Game();
	}	
	
	public function new()
	{
		Lib.current.addChild(Lib.attach("lib.background.png"));
		//Lib.current.stage.showDefaultContextMenu = false;
				
		keysBar = new Bitmap(new BitmapData(128, 32, true, 0xff0000));
		keysBar.x = 56;
		keysBar.y = 480 - 32 - 16;
		
		limitbar = new Bitmap(new BitmapData(128, 32, true, 0xff0000));
		limitbar.x = 256;
		limitbar.y = 480 - 32 - 16;
		
		
		scoreBar = new Bitmap(new BitmapData(128, 32, true, 0x00ff00));
		scoreBar.x = 456;
		scoreBar.y = 480 - 32 - 16;
		
		currentLevel = 0;
		
		Lib.current.addChild(keysBar);
		Lib.current.addChild(limitbar);
		Lib.current.addChild(scoreBar);		
		
		onEnd(OnEndResult.Menu(0));
	}
	
	private function onEnd(result:OnEndResult)
	{
		var allOk:Bool = false;
		switch(result)
		{
			case Menu(state):
				switch(state)
				{
					case 0:	//Показать меню
						field = new Field(menuData.elements('level')[0], 
							onEnd, updateScore, true);
						allOk = true;
					case 1: //Новая игра
						currentLevel = levelStartCheat;
						SharedObject.getLocal(saveObjectName).setProperty('progress', currentLevel);
						field = new Field(levelData.elements('level')[currentLevel], 
							onEnd, updateScore, false);
						allOk = true;
					case 2: //Продолжить игру
						//onEnd(OnEndResult.Menu(0));
						var progress:Int = SharedObject.getLocal(saveObjectName).data.progress;
						//trace(progress);
						currentLevel = progress;
						field = new Field(levelData.elements('level')[currentLevel], 
							onEnd, updateScore, false);
						allOk = true;
					case 3: //Справка
						var ifs:InfoScreen = new InfoScreen('help', onEnd);
						ifs.x = 20;
						ifs.y = 20;
						Lib.current.addChild(ifs);
						//onEnd(OnEndResult.Menu(0));
					case 4: //О том, о сем			
						var ifs:InfoScreen = new InfoScreen('about', onEnd);
						ifs.x = 20;
						ifs.y = 20;
						Lib.current.addChild(ifs);
				}
			case Win(score):
				//Следующий левел, если есть еще в загашнике
				currentLevel++;
				if ((currentLevel < levelsTotal) && (currentLevel >= 0))
				{
					SharedObject.getLocal(saveObjectName).setProperty('progress', currentLevel);
					field = new Field(levelData.elements('level')[currentLevel], 
						onEnd, updateScore, false);
					allOk = true;
				}
				else
				{
					onEnd(OnEndResult.Menu(0));
				}
			case Die:
				//Реплей левела (или меню, пока не решил)
				field = new Field(levelData.elements('level')[currentLevel], 
					onEnd, updateScore, false);
				allOk = true;
		}
		if(allOk)
		{
			field.x = 20;
			field.y = 20;
			Lib.current.addChild(field);
			field.start();
		}
	}
	
	private function updateScore()
	{
		//Очищаем буффер
		var ct:ColorTransform = new ColorTransform();
		ct.alphaMultiplier = 0;
		keysBar.bitmapData.colorTransform(keysBar.bitmapData.rect, ct);
		limitbar.bitmapData.colorTransform(keysBar.bitmapData.rect, ct);
		scoreBar.bitmapData.colorTransform(scoreBar.bitmapData.rect, ct);
		
		var score:Int = field.diamondsCount;
		var limit:Int = field.diamondsLimit;
		for (i in 0...4)
		{
			//Рисуем ключики
			if (field.keysCollected[i])
			{
				drawSymbol(keysBar.bitmapData, 10 + i, i << 5, 0);
			}
			//Рисуем счет
			var c = score % 10;
			score = Math.floor(score / 10);
			drawSymbol(scoreBar.bitmapData, c, (3 - i) << 5, 0);
			//Рисуем норму выработки
			var l = limit % 10;
			limit = Math.floor(limit / 10);
			drawSymbol(limitbar.bitmapData, l, (3 - i) << 5, 0);
		}
		
	}
	
	/**
	 * Рисуем значки 0-9 цыфурьки, 10-13 ключи
	 * @param	b
	 * @param	s
	 * @param	x
	 * @param	y
	 */
	private function drawSymbol(b:BitmapData, s:Int, x:Int, y:Int)
	{
		var sx:Int = s << 5;
		var sy:Int = 11 << 5;
		b.copyPixels(Field.spriteSet, new Rectangle(sx, sy, 32, 32), new Point(x, y), 
			Field.spriteSet, new Point(sx, sy), true);
	}
	
}