﻿/**
 * ...
 * @author Werdn
 */

package sounds;
import flash.media.Sound;
import flash.media.SoundChannel;
import flash.media.SoundTransform;

class Netting extends Sound {}
class Explode extends Sound {}
class Diamond extends Sound {}
class DiamondDrop extends Sound {}
class RockDrop extends Sound {}
class Push extends Sound {}
class Servo1 extends Sound {}
class Servo2 extends Sound {}
class Key extends Sound {}
class Door extends Sound {}

/**
 * Само собой разумеющееся дело, иначе будет неразбериха со звуками когда много камней
 */
class SoundFactory 
{

	private static var sampleTransform:SoundTransform = new SoundTransform(0.3, 0);
	private static var servoTransform:SoundTransform = new SoundTransform(0.02, 0);
	
	private static var nettingSample:Sound = new Netting();
	private static var explodeSample:Sound = new Explode();
	private static var diamondSample:Sound = new Diamond();
	private static var diamondDropSample:Sound = new DiamondDrop();
	private static var rockDropSample:Sound = new RockDrop();
	private static var pushSample:Sound = new Push();
	private static var servo1Sample:Sound = new Servo1();
	private static var servo2Sample:Sound = new Servo2();
	private static var keySample:Sound = new Key();
	private static var doorSample:Sound = new Door();
	
	private static var nettingChannel:SoundChannel;
	private static var explodeChannel:SoundChannel;
	private static var diamondChannel:SoundChannel;
	private static var diamondDropChannel:SoundChannel;
	private static var rockDropChannel:SoundChannel;
	private static var pushChannel:SoundChannel;
	private static var servoChannel:SoundChannel;
	private static var keyChannel:SoundChannel;
	private static var doorChannel:SoundChannel;
	
	public static function clearAllChannels()
	{
		nettingChannel = null;
		explodeChannel = null;
	    diamondChannel = null;
		diamondDropChannel = null;
		rockDropChannel = null;
		pushChannel = null;
		servoChannel = null;
		keyChannel = null;
		doorChannel = null;
	}
	
	public static function playNettingSample()
	{
		if(nettingChannel == null)
		{
			nettingChannel = nettingSample.play(0, 0, sampleTransform);
		}
	}
	
	public static function playExplodeSample()
	{
		if(explodeChannel == null)
		{
			explodeChannel = explodeSample.play(300, 0, sampleTransform);
		}
	}
	
	public static function playDiamondSample()
	{
		if(diamondChannel == null)
		{
			diamondChannel = diamondSample.play(0, 0, sampleTransform);
		}
	}
	
	public static function playDiamondDropSample()
	{
		if(diamondDropChannel == null)
		{
			diamondDropChannel = diamondDropSample.play(0, 0, sampleTransform);
		}
	}
	
	public static function playRockDropSample()
	{
		if(rockDropChannel == null)
		{
			rockDropChannel = rockDropSample.play(0, 0, sampleTransform);
		}
	}
	
	public static function playPushSample()
	{
		if (pushChannel == null)
		{
			pushChannel = pushSample.play(400, 0, sampleTransform);
		}
	}
	
	public static function playServoSample()
	{
		if (servoChannel == null)
		{
			servoChannel = Math.random() > 0.5 ? 
				servo1Sample.play(700, 0, servoTransform):
				servo2Sample.play(0, 0, servoTransform);
		}
	}
	
	public static function playKeySample()
	{
		if (keyChannel == null)
		{
			keyChannel = keySample.play(0, 0, sampleTransform);
		}
	}
	
	public static function playDoorSample()
	{
		if (doorChannel == null)
		{
			doorChannel = doorSample.play(1500, 0, sampleTransform);
		}
	}
	
}