unit SD_Game;

interface
uses
  Omega, LexUtils, Setup;

procedure Init;
procedure Work;
procedure Draw;
const
  MofLevel = 2;
var
  HeroA : Single;
  HeroAN, HeroR,
  {HeroS,} HeroL
  : Integer;

  MohHTile : array[1..4] of byte = (28, 28, 32,32);

  LevelS : array[1..MofLevel] of string = ('Maps\1.lex', 'Maps\2.lex');
  LevelN : byte = 1;
implementation
uses
  SD_gproc, StormD_Sky, SD_Bar, SD_cmap, SD_creator, SD_Guns,
  SD_Map, SD_materials, SD_Procs, SD_Live, SD_Expl;

procedure Init;
begin
  GetEndXY;

  HeroL  := 100;
  HeroA  := 1;
  HeroAN := 1;

 Map.Load(LevelS[LevelN]);
end;


procedure Work;
var
  P, SpM, SpA, hX : Single;
  HrX, HrY : Integer;

  procedure MouseAndGame;
  begin
    if abs(M_Distance(Mouse_X, Mouse_Y, (Map.Hero.X - Camera.X), (Map.Hero.Y - Camera.Y))) > hX then
      HeroR := whatroll( Mouse_X, (Map.Hero.X - Camera.X),  Mouse_Y,  (Map.Hero.Y - Camera.Y));

     SD_creator.Work;
  end;

begin
  P := 0;
  HrX := round(Map.Hero.X + sMT/2) div round(sMT);
  HrY := round(Map.Hero.Y + sMT/2) div round(sMT);
  if  (HrX > 0)
  and (HrX < Map.X)
  and (HrY > 0)
  and (HrY < Map.Y) then
  with Map.Top[HrX, HrY] do
  if (T1 = 1) and (T2 = 4) then
  begin
    if LevelN < MofLevel then
      Inc(LevelN);
    SD_Game.Init;
  end;

  if (Omega.Key_Press(K_Enter)) then HeroL := 0;

  if  (HeroL < 1) then
  begin
    if HeroAN <> 4 then HeroA := 1;
    HeroAN := 4;
    SpA := 0.4;
    if HeroA >= MohHTile[4] - 1 then
      SD_Game.Init;
  end
  else
  if HeroAN in [3, 4] then
    SpA := 0.5
  else
  begin
    if Omega.Key_Down(k_shift) then
    begin
      SpM := 0.07 * sMT;
      SpA := 1;
      hX  := 1.2*sMT;
      if HeroAN in [1, 3] then
        HeroAN := 2;
    end
    else
    begin
      SpM := 0.05 * sMT;
      SpA := 0.5;
      hX  := 0.7*sMT;
      if HeroAN in [2, 3] then
        HeroAN := 1;
    end;

    if Omega.Key_Down(k_up) then
      app(P, -SpM);
    if Omega.Key_Down(k_down) then
      app(P,  SpM);

    if MouseX < Bar.R1.W then
      Bar.Work
    else
      MouseAndGame;

    if HeroR > 360  then
      HeroR := HeroR - 360
    else
    if HeroR < -360 then
      HeroR := HeroR + 360;
  end;

    if (P <> 0) or (HeroAN in [3, 4]) then
    begin
      Move(Map.Hero, P, HeroR, Map.Hero);
      if HeroA < MohHTile[HeroAN] then
        app(HeroA, SpA)
      else
      if HeroAN <> 4 then
      begin
        HeroA := 1;
        if HeroAN = 3 then
          HeroAN := 1;
      end;
    end;

  SD_Guns.Work;
  SD_Expl.Work;
  GetCameraXY;
  GetEndXY;
  StormD_Sky.Work;
end;

procedure Draw;
begin
  Pr2D_Rect( 0, 0, WinW, WinH, sColor, 255, 1);
  if SkyDraw then
  begin
    StormD_Sky.Draw(1);
  end;

  Map.Draw;

  if DrawColl then
  CollisMap.Draw;

  { if SkyDraw then
    StormD_Sky.Draw(2);   }


  SD_creator.Draw;
  SD_Expl.Draw;
  SD_Bar.Bar.Draw;



end;

end.
