unit SD_Guns;

interface
uses
  Omega, LexUtils;
type
  TGun = record
    P        : TM2DObj;
    Tp,
    Tm,
    Color,
    Sost     : Byte;
  end;
  TTower = class
    O    : TGun;
    RA   : Single;
    procedure Draw;
    procedure AddRocket;
    procedure Work;
  end;

  TRocket = class
    procedure Roll;
    procedure Work;
    procedure Draw;
    public
    P  : TM2DRealPoint;
    private
    E  : Boolean;
    LR,
    R  : Single;
    Live,
    Cl,
    T  : byte;
  end;

const
  ttOff   = 1;
  ttOn    = 2;
  ttDest  = 3;
  ttDie   = 0;
procedure Work;

var
  Rocket : array of TRocket;

implementation
uses
  SD_Materials, SD_gproc, SD_game, SD_Live, SD_Map, SD_expl;


var
  Colors : array[1..2] of Integer;

procedure TRocket.Roll;
begin
  R := whatroll(Map.Hero.X + 0.5*sMT, P.X, Map.Hero.Y + 0.5*sMT, P.Y) + 180 ;

  if R > 360  then
    R := R - 360
  else
  if R < -360 then
    R := R + 360;
end;

procedure TRocket.Work;
begin
  fly(P, 3, R, P);
  if  (P.X > Map.Hero.X + sMT/4)
  and (P.X < Map.Hero.X + 3*sMT/4)
  and (P.Y > Map.Hero.Y + sMT/4)
  and (P.Y < Map.Hero.Y + 3*sMT/4) then
  begin
    Live := 1;
    Dec(HeroL, 5);
  end;
  Inc(Live, -1);
  if Live <= 1 then
  begin
    E := False;
    AddExpl(P.X, P.Y, random(7)+1);
  end;
end;

procedure TRocket.Draw;
begin
  if E then
  SSprite_Draw(m_Rocket, P.X - xRocket.X - Camera.X,
                             P.Y - xRocket.X - Camera.Y,
                             sRocket.X, sRocket.Y, 255, R);
end;

procedure TTower.Draw;
var
  JJ : Integer;

  procedure Disk;
  begin
  with O.P do
  begin
    ASprite_Draw(m_Gun[1], X*sMT - 0.3*sMT - Camera.X, Y*sMT - 0.3*sMT - Camera.Y, 1.6*sMT, 1.6*sMT, 1, 255, 0);
    ASprite_Draw(m_Gun[1], X*sMT - 0.3*sMT - Camera.X, Y*sMT - 0.3*sMT - Camera.Y, 1.6*sMT, 1.6*sMT, 2, 255, R);
    ASprite_Draw(m_Gun[1], X*sMT - 0.3*sMT - Camera.X, Y*sMT - 0.3*sMT - Camera.Y, 1.6*sMT, 1.6*sMT, 3, 255, 0);
  end;
  end;
begin
  FX_SetColorMix(SetExplColor(O.Color));
  for JJ :=1 to 3  do
  case O.Tp of
    1 : Disk;
  end;
end;

procedure TTower.AddRocket;
var
  I, J, L : Integer;
begin

  I := - 1;
  L := Length(Rocket);
  for J:=0 to L-1 do
  if not Rocket[J].E then
    begin
      I := J;
      Break;
    end;
  if I=-1 then
    begin
      I:=L;
      SetLength(Rocket, I+1);
    end;
  if Rocket[I] = nil then
    Rocket[I] := TRocket.Create;
  Rocket[I].P := Set2DRealPoint(O.P.X*sMT + 0.8*sMT , O.P.Y*sMT + 0.8*sMT);
  with Rocket[I] do
  begin
    Cl := O.Color;
    T  := 50;
    Roll;
    E  := True;
    Live := 200 + random(10);
  end;
  O.TM := 200;
end;

procedure TTower.Work;
begin
  if abs(M_Distance(O.P.X, O.P.Y, Map.Hero.X, Map.Hero.Y)) < 20*sMT then
  begin
    if RA < 7 then
       app(RA,  0.05);
    if RA > 5 then
    begin
      if O.Tm > 0 then
        dec(O.Tm)
      else
        AddRocket;
    end;
  end
  else
    if RA > 0 then
      app(RA, -0.05);
  app(O.P.R, RA);
end;

procedure Work;
var
  I : Integer;
begin
  for I := 0 to Length(Map.Tower) -1 do
    Map.Tower[I].Work;

  for I := 0 to Length(Rocket) -1 do
  if Rocket[I].E then
    Rocket[I].Work;
end;


end.
