unit SD_Live;

interface
uses
   LexUtils;

function whatroll(x2, x1, y2, y1 :real) : integer;
function move(inH : TM2DRealPoint; inP, R : Single; var outH : TM2DRealPoint) : boolean;
function  fly(inH : TM2DRealPoint; inP, R : Single; var outH : TM2DRealPoint) : boolean;
function RPCord2I(P : TM2DRealPoint) : TM2DPoint;

implementation
uses
  SD_procs,
  SD_gproc, SD_cmap;

function whatroll;
function asmroll(x1, y1 :real) : real;
asm
  FLD Y1
  FLD X1
  FPATAN
  FWAIT
end;
begin
  result:=round(asmroll(x1-x2,y1-y2)*57.32) + 90;
end;

function RCord2I(X, Y : Single) : TM2DPoint;
begin
  Result.X := Round(X) div round(CollisMap.S);
  Result.Y := Round(Y) div round(CollisMap.S);
end;

function RPCord2I(P : TM2DRealPoint) : TM2DPoint;
begin
  Result := RCord2I(P.X, P.Y);
end;

function move;
var
  MR : single;
  clsP, dP,
  testP  : TM2DRealPoint;
//______________________________________________________________________________
  function ColPoint(P : TM2DPoint) : boolean;
  begin
    if (P.X <= 0)
    or (P.X >= CollisMap.X)
    or (P.Y <= 0)
    or (P.Y >= CollisMap.Y)
    or (not CollisMap.Cls[P.X, P.Y]) then
      Result := True
    else
      Result := False;
  end;

  function collis(X1, Y1, X2, Y2 : Single) : Boolean;
  begin
    Result := False;
    if ColPoint(RCord2I(X1, Y1))
    or ColPoint(RCord2I(X2, Y2)) then
    Result := True;
  end;
begin

  MR := pi*(R - 90 )/180;

  dP.X := cos(MR)* inP;
  dP.Y := sin(MR)* inP;

  testP.X := inH.X + dP.X;
  testP.Y := inH.Y + dP.Y;

  if (dp.X <> 0) then
  begin
    if dP.X > 0 then
      clsP.X := testP.X + 0.8*sMT
    else
      clsP.X := testP.X + 0.2*sMT;

    if (collis(clsP.X, inH.Y + 0.2*sMT, clsP.X, inH.Y + 0.8*sMT)) then
      testP.X := inH.X;
  end;

  if (dP.Y <> 0) then
  begin
    if dP.Y > 0 then
      clsP.Y := testP.Y + 0.8*sMT
    else
      clsP.Y := testP.Y + 0.2*sMT;

    if (collis(inH.X + 0.2*sMT, clsP.Y, inH.X + 0.8*sMT, clsP.Y)) then
      testP.Y := inH.Y;
  end;

  outH := testP;

end;

function fly;
var
  MR : single;
  clsP, dP : TM2DRealPoint;
  Cord     : TM2DPoint;
begin
  
  MR := pi*(R - 90 )/180;

  dP.X := cos(MR)* inP;
  dP.Y := sin(MR)* inP;

  outH.X := inH.X + dP.X;
  outH.Y := inH.Y + dP.Y;

end;


end.
