unit SD_Procs;

interface
uses
  Omega, LexUtils;

procedure Init;
procedure Draw;
procedure Work;

var
  TofG  : Integer;
  InfoS : array[1..10] of string;
  DrawHelp : Boolean = True;
  DrawInfo : Boolean = False;
  DrawColl : Boolean = False;
  MouseX, MouseY : Integer;
implementation
uses
  SD_gproc, SD_Bar, Setup, SD_bridges, StormD_Sky,
  SD_map, SD_Materials, SD_Game;

procedure Init;
begin
  SD_Materials.Load;
  SD_Map.NewMap(1,1);
  SD_gproc.SetSize;
  SD_Bar.Init;
  SD_Game.Init;
  StormD_Sky.Init;
end;

procedure Work;
begin
  MouseX := Omega.Mouse_X;
  MouseY := Omega.Mouse_Y;

  SD_Game.Work;
  if Omega.Key_Press(k_Space) then
    DrawHelp := not DrawHelp;
  if Omega.Key_Press(k_F2) then
    DrawInfo := not DrawInfo;
  if Omega.Key_Press(k_F3) then
    DrawColl := not DrawColl;
  if Omega.Key_Press(k_F4) then
    if MofDE = 7 then
      MofDE := 6
    else
      MofDE := 7;
end;

procedure Info;
var
  X, I : Integer;
begin
  X := WinW - 160;
  Omega.Pr2D_Rect( X,     8, 156, 156,      15, 120, 1);
  Omega.Pr2D_Rect( X +3, 11, 150, 150, $FFFFFF, 240, 0);
  Omega.Text_Draw(FontA1, X+8, 16, PChar('FPS : ' + Int2S(Omega.OE_GetFPS)));

 // InfoS[1] := Int2S(round(Length(SD_Expl.Expl)));
  for I := 1 to 10 do
  Omega.Text_Draw(FontA1, X+8, 22+ I * 22, PChar(InfoS[I]));

  Omega.Pr2D_Rect( Gran.X, Gran.Y,
                   Gran.W - Gran.X + sMT, Gran.H - Gran.Y + sMT,
                  0, 200, 0);
end;

procedure Draw;
var
  I : integer;
begin
  SD_Game.Draw;
  if DrawInfo then
    Info;
end;

end.
