unit SD_bridges;

interface
uses
  Omega, LexUtils;

const
    fbX = 2;
    fbY = 2;

type
  TfbTop = record
    T1, T2, A   : Byte;
  end;

  tFB = class
    Top  : array[0..3, -fbX..fbX, -fbY..fbY] of TfbTop;
    procedure DrawMenu(X, Y, S : Integer);
    procedure Draw(A : byte; mX, mY : Integer; Flag : Integer = 1);
    procedure Load(FileName : String);
    function  Work(A : byte; mX, mY : Integer) : Boolean;
    procedure Add(A : byte; mX, mY : Integer);
  end;

procedure Init;
function Bord(inE1, inE2 : TM2DPoint) : Boolean;

const
  MofFB = 4;
var
  FragmentBridge : array[1..MofFB] of TFB;
  UseBB : byte = 0;
  MofDE : byte = 6;  //  F4   (=7)
    BCZ  : array[1..4, 0..3, -1..1, -1..1] of Boolean;

implementation
uses
  SD_materials, SD_procs, SD_map, SD_expl,
  SD_cmap, SD_gproc, SD_bar;

var
  BRBS : array[1..4, 0..3, 1..4] of Boolean;

procedure InitPortal;
type
  tBRS = set of 1..4;
var
  IX, IY,
  I, I2, I3 : Integer;
  BRS  : array[1..4] of tBRS;
  Rb : Boolean;
begin
  BRS[1] := [3,2];
  BRS[2] := [2,3,4];
  BRS[3] := [1,3];
  BRS[4] := [1,2,3,4];

  for I := 1 to 4 do
  begin
    BCZ[I, 0, -1,-1] := False;
    BCZ[I, 0, -1, 1] := False;
    BCZ[I, 0,  1,-1] := False;
    BCZ[I, 0,  1, 1] := False;
    for I2 := 1 to 4 do
    begin
      if I2 in BRS[I] then
        Rb := True
      else
        RB := False;
      case I2 of
        1 : BCZ[I, 0, 0,-1] := Rb;
        2 : BCZ[I, 0, 1, 0] := Rb;
        3 : BCZ[I, 0, 0, 1] := Rb;
        4 : BCZ[I, 0,-1, 0] := Rb;
      end;
    end;
    for I2 := 1 to 3 do
    for IX := -1 to 1 do
    for IY := -1 to 1 do
      BCZ[I, I2,  -IY, IX]  := BCZ[I, I2-1, IX, IY];
  end;
end;

function Portal(X, Y, R : Integer) : Boolean;
var
  RX, RY : Integer;
begin
  case R of
    1, 3 : RX := 0;
       2 : RX := 1;
       4 : RX :=-1;
  end;
  case R of
       1 : RY :=-1;
    2, 4 : RY := 0;
       3 : RY := 1;
  end;

  with Map.Top[X, Y] do
    Result := BCZ[T2, T1-2, RX, RY];
end;

function Bord(inE1, inE2 : TM2DPoint) : Boolean;
var
  E1, E2 : TM2DPoint;
  S : byte;
begin
{  Result := True;
  E1 := inE1;
  E2 := inE2;
  if  (InE1.X <> InE2.X)
  and (InE1.Y <> InE2.Y) then
  if Map.Top[InE1.X, InE1.Y].T1 = 2 then
  if Map.Top[InE2.X, InE2.Y].T1 = 2 then
  begin
    Result := False;
    if  (Portal(InE2, InE1))
    and (Portal(InE1, InE2)) then
      Result := True;
  end;}
end;

procedure tFB.DrawMenu;
var
  iX, iY : Integer;
begin
  Inc(X, S*2 + 2);
  Inc(Y, S*2 + 2);
  for iX := -fbX to fbX do
  for iY := -fbY to fbY do
  with Top[0, iX, iY] do
  if (T1 > 0) and (T1 < 6) then
    ASprite_Draw(m_Tile[T1], (iX)*S + X, (iY)*S + Y, S, S, T2);
end;

procedure tFB.Draw;
var
  iX, iY : Integer;
begin
  for iX := -fbX to fbX do
  for iY := -fbY to fbY do
  with Top[A, iX, iY] do
  if (T1 > 0) and (T1 < MofDE) then
    ASprite_Draw(m_Tile[T1], (iX+mX)*sMT - round(Camera.X) , (iY+mY)*sMT - round(Camera.Y), sMT, sMT, T2, 200, 0, Flag);
end;

procedure tFB.Load;
var
  F : file;
  A : Byte;
  iX, iY : Integer;

  function Vert(var iA : byte; A : byte) : Boolean;
  begin
    Result := False;
    if  (iA > 1)
    and (iA < 6) then
    begin
      Inc(iA);
      if iA > 5 then
      Ia := IA - 4;
    end
    else
    if IA = 6 then
    Result := True;
  end;
begin
  AssignFile(F, FileName);
  Reset(F, 1);
  BlockRead(F, Top[0], SizeOf(Top[0]));
  CloseFile(F);
  //____________________________________________________________________________
  for A := 1 to 3 do
  for iX := -fbX to fbX do
  for iY := -fbY to fbY do
  begin
    Top[A][ -iY, iX] :=  Top[A - 1][ iX, iY];

    if Vert(Top[A][-iY, iX].T1, A) then
    begin
      Inc(Top[A][-iY, iX].T2);
      if Top[A][-iY, iX].T2 > 4 then
        Dec(Top[A][-iY, iX].T2, 4)
    end;

    Inc(Top[A][-iY, iX].A, A);
    if Top[A] [-iY, iX].A > 3 then
    Dec(Top[A][-iY, iX].A, 3);
  end;
end;

function tFB.Work;
var
  iX, iY : Integer;
  U1 : Boolean;
  U2 : Boolean;

  procedure BridhePlace(PTop : SD_Map.tTop);
  begin
    case pTop.T1 of
                1 : if pTop.T2 in [1..4, 8, 12, 18, 21, 23, 26] then
                      U2 := True;
       2, 3, 4, 5 : if Portal(mX + iX, mY + iY, Top[A, iX, iY].T2) then
                      U2 := True;
     end;
  end;

begin
  U1 := True;
  U2 := False;
  for iX := -fbX to fbX do
  for iY := -fbY to fbY do
    case Top[A, iX, iY].T1 of
      2, 3, 4, 5 : if (Map.Top[mX + iX, mY + iY].T1<>0) then
                     U1 := False;
               6 : BridhePlace(Map.Top[mX + iX, mY + iY]);
    end;
  if U1 and U2 then
    Result := True
  else
    Result := False;
end;

procedure tFB.Add;
var
  eI,
  iX, iY : Integer;
begin
  for iX := -fbX to fbX do
  for iY := -fbY to fbY do
  if Top[A, iX, iY].T1 in [2, 3, 4, 5] then
  begin
    Map.Top[mX + iX, mY + iY].T1 := Top[A, iX, iY].T1;
    Map.Top[mX + iX, mY + iY].T2 := Top[A, iX, iY].T2;
    Map.Top[mX + iX, mY + iY].A  := Top[A, iX, iY].A;
    CollisMap.Add(mX + iX, mY + iY);
    Bar.BridgeButton[UseBB].T := random(MofFB) + 1;
    for eI := 1 to 5 do
    SD_expl.AddExpl((mX + iX)*sMT - 5 + random(round(sMT)),
                    (mY + iY)*sMT - 5 + random(round(sMT)), 8, False);

    //    
  end;
end;
procedure Init;
var
  I : Integer;
begin
  InitPortal;
  for I := 1 to MofFB do
  begin
    FragmentBridge[I] := tFB.Create;
    FragmentBridge[I].Load('Data\FB' + Int2S(I) + '.lex');
  end;
end;

end.
