unit SD_cmap;

interface
const
  MofCM = 8;

type
  tCM = array[1..MofCM, 1..MofCM] of Boolean;

  TCollisMap = class
    Cls   : array of array of Boolean;
    S     : Single;
    X, Y  : Integer;
    procedure Add(iX, iY : Integer);
    procedure Init;
    procedure SetSize;
    procedure Draw;
  end;

procedure Load(FileName : string);
procedure Init;

var
  CollisMap : TCollisMap;
implementation
uses
  Omega,
  LexUtils, SD_map, SD_gproc, SD_procs;

var
  CM : array of array of tCM;

procedure Load;
var
  F : file;
  IL1, IL2, L1, L2 : Integer;
begin
  AssignFile(F, FileName);
  Reset(F, 1);
  
  BlockRead(F, L1, Sizeof(Integer) );
  SetLength(CM, L1);
  for IL1 := 0 to L1 - 1 do
  begin
    BlockRead(F, L2, Sizeof(Integer) );
    SetLength(CM[iL1], L2);
    for IL2 := 0 to L2 - 1 do
    BlockRead(F, CM[iL1, iL2], Sizeof(tCM));
  end;
  CloseFile(F);

{  for L1 := 1 to 3 do
  begin
    SetLength(CM[L1], 2);
    SetLength(CM[L1, 1], 4);
    for L2 := 0 to 3 do
    for IL1 := 1 to MofCM do
    for IL2 := 1 to MofCM do
    CM[L1, 1, L2][IL2 , 9 - IL1] := CM[L1 - 1, 1, L2][IL1, IL2];
  end;}
end;

procedure TCollisMap.Add;
var
  mX, mY : Integer;
begin
  for mX := 1 to MofCM do
  for mY := 1 to MofCM do
  with  Map.Top[iX, iY] do
  if (T1 > 0) and (T2 > 0) then
    Cls[mX + iX * MofCM - 1, mY + iY * MofCM - 1] := CM[T1-1, T2-1][mX, mY]
  else
    Cls[mX + iX * MofCM - 1, mY + iY * MofCM - 1] := False;
end;

procedure TCollisMap.Init;
var
  iX, iY : Integer;
begin
  X := Map.X * MofCM;
  Y := Map.Y * MofCM;
  SetLength(Cls, X + 1, Y +1);
  for iX := 0 to Map.X - 1 do
  for iY := 0 to Map.Y - 1 do
    Add(iX, iY);
end;

procedure TCollisMap.SetSize;
begin
  S := sMT / MofCM;
end;

procedure Init;
begin
  CollisMap := TCollisMap.Create;
  CollisMap.SetSize;
  CollisMap.Init;
end;

procedure TCollisMap.Draw;
  var
    iX, iY : Integer;
  begin
  for iX := 0 to CollisMap.X do
  for iY := 0 to CollisMap.Y do
  with CollisMap do
  if Cls[iX, iY] then
    Omega.Pr2D_Rect(iX*s - Camera.X, iY*s - Camera.Y, s, s, $FFFFFF, 110, 1)
  end;
end.
