unit SD_expl;

interface
uses
  LexUtils, Omega;

procedure AddExpl(X, Y : single; inColor : Byte; inD : Boolean = False);
procedure Draw;
procedure Work;
procedure ReSize(s : Single);

implementation
uses
  SD_Game, SD_Map, SD_Live, SD_materials, SD_gproc;
type
  TExpl = class
    Cl    : Byte;
    A     : Single;
    Dest  : Boolean;
    S,
    P     : TM2DRealPoint;
    R     : Integer;
    procedure Work;
    procedure Draw;
  end;

var
  Expl : array of TExpl;

const
  peA = 0.25;

procedure TExpl.Work;
begin
  app(A, peA);
end;

procedure TExpl.Draw;
begin
  FX_SetColorMix(SetExplColor(Cl));
  ASprite_Draw(m_Expl, P.X - S.X/2 - Camera.X, P.Y - S.Y/2 - Camera.Y, S.X, S.Y, round(A), 190, R, FX_DEFAULT or FX_COLORMIX);
end;

procedure AddExpl;
var
  I, J, L : Integer;
begin
  I := - 1;
  L := Length(Expl);
  for J:=0 to L-1 do
  if Expl[J].A >= 16 then
    begin
      I := J;
      Break;
    end;
  if I=-1 then
    begin
      I:=L;
      SetLength(Expl, I+1);
    end;
  if Expl[I] = nil then
  Expl[I] := TExpl.Create;
  with Expl[I] do
  begin
    Cl    := inColor;
    Dest  := inD;
    if Dest then
      S := sBigExpl
    else
      S := sExpl;
    P := Set2DRealPoint(X, Y);

    R := random(360);
    A := 1;
  end;
end;

procedure Draw;
var
  I : Integer;
begin
  for I := 0 to Length(Expl) - 1 do
  if Expl[I].A<=16 then
    Expl[I].Draw;
end;

procedure Work;
var
  I : Integer;
begin
  for I := 0 to Length(Expl) - 1 do
  if Expl[I].A<=16 then
    Expl[I].Work;
end;

procedure ReSize(s : Single);
var
  I : Integer;
begin
  for I := 1 to Length(Expl) - 1 do
  begin
    Expl[I].P.X := Expl[I].P.X * S;
    Expl[I].P.Y := Expl[I].P.Y * S;
  end;
end;
end.
