unit SD_map;

interface
uses
  LexUtils, Setup, Omega, SD_Guns;

type
  tTop = record
    T1,            //  
    T2,            // 
    Scr,
    A   : Byte;    //  (x90)
//  Cl  : Byte;    //  
  end;

  tMap = class
    Top  : array of array of tTop;
    X, Y : Integer;
    Hero : TM2DRealPoint;
    Tower : array of TTower;
    procedure Size(inX, inY : Integer);
    procedure Draw;
    procedure Load(FileName : String);
  end;

var
  Map     : TMap;

procedure NewMap(X : Integer = 10; Y : Integer = 10);

implementation
uses
  //EditProc,
  SD_Game, SD_cmap, SD_bridges,
  SD_gproc, SD_materials, StormD_Sky;

procedure tMap.Size;
begin
  X := InX - 1;
  Y := InY - 1;
  SetLength(Map.Top, inX, inY);
end;

procedure tMap.Draw;
var
  tX, tY,
  iX, iY, I : Integer;
begin
  for iX := startX to endX do
  for iY := startY to endY do
  with Top[iX, iY] do
  if T1 > 0 then
  begin
    ASprite_Draw(m_Tile[T1], iX*sMT - round(Camera.X), iY*sMT - round(Camera.Y), sMT, sMT, T2);
  end;
  ASprite_Draw(m_Hero[HeroAN],Hero. X - round(Camera.X), Hero.Y - round(Camera.Y), sMT, sMT, round(HeroA), 255, HeroR);
  for I := 0 to Length(Rocket) -1 do
    Rocket[I].Draw;
  for I := 0 to Length(Tower) - 1 do
    Tower[I].Draw;
end;

procedure tMap.Load;
var
  F : file;
  I, iX, iY : Integer;
begin
  AssignFile(F, FileName);
  Reset(F, 1);
  BlockRead(F, X, SizeOf(Integer));
  BlockRead(F, Y, SizeOf(Integer));
  Size(X + 1, Y + 1);
  for iX := 0 to X do
  for iY := 0 to Y do
    BlockRead(F, Top[iX, iY], SizeOf(tTop));

  BlockRead(F, Hero, SizeOf(TM2DRealPoint));
  Hero := Set2DRealPoint(Hero.X * sMT, Hero.Y * sMT);

  BlockRead(F, iX, SizeOf(Integer));
  SetLength(Tower, iX);
  if iX > 0 then
  for I := 0 to Length(Tower) - 1 do
  begin
    Tower[I] :=TTower.Create;
    BlockRead(F, Tower[I].O, SizeOf(tGun));
  end;
  CloseFile(F);
   SD_cmap.Init;
end;

procedure NewMap;
begin
  if Map <> nil then
    Map.Free;
  Map := tMap.Create;
  Map.Size(X, Y);
end;

end.
