unit StormD_Sky;
{***********************************************
    v0.01
  cdmlex 17.08.2009
************************************************}
interface
uses
  LexUtils, Omega, Setup;

const
  cMofClouds1 = 50;
  cMofClouds2 = 10;

procedure Init;
procedure Work;
procedure Draw(Z : Integer);

var
  sColor : Integer = 12940355;//14862746;
  sWing  : Integer = 30;
  cWinW  : Integer = 1024;
  cWinH  : Integer = 768;
implementation
uses
  SD_gproc;

type
  tClouds = class(CL2DRealObj)
    T : byte;
    A : SIngle;
    procedure Add(X, Y : Single; V : Integer = -1);
    procedure Work;
    procedure Draw;
  end;
var
  Clouds   : array[1..2] of array of tClouds;
  ttClouds : PTexture;
  MofClouds : array[1..2] of Integer;
  WorkClouds : Boolean = False;

procedure LoadMaterials;
begin
  Tex_LoadMaskFromFile(PChar('Data\sky_m.JPG'));
  ttClouds := Tex_LoadFromFile('Data\w_1024.GIF',  -1, TEX_DEFAULT_2D or TEX_USEMASK );
  Tex_SetFramesSize(ttClouds, 512, 256);
end;

procedure Init;
var
  I, Z : Integer;
begin
  MofClouds[1] := cMofClouds1;
  MofClouds[2] := cMofClouds2;
  LoadMaterials;
  for Z := 1 to 2 do
  SetLength(Clouds[Z], MofClouds[1] + 1);
  for Z := 1 to 2 do
  for I := 0 to MofClouds[1] do
  begin
    Clouds[Z, I] := tClouds.Create;
    Clouds[Z, I].Add(random(WinW), random(WinH));
  end;
  WorkClouds := True;
end;
//***  ***
procedure tCLouds.Add;
begin
  T := random(9)+1;
  S := Set2DRealPoint(sCloudMin + random(round(sCloudMin)), (SCloudMin + random(round(sCloudMin)))/2);
  P := Set2DRealPoint(X + V*S.X, Y + V*S.Y);
  R := 0;
  SetM(sWing, 0.7 + 0.005*random(7));
  A := 155 + random(100);
end;

procedure tClouds.Work;
begin
  Move;
  S := Set2DRealPoint(S.X + Rndz(0.07, 0.17, -1), S.Y + Rndz(0.07, 0.17, 1));

  if (P.X - S.X > cWinW) then
    Add(  0, random(WinH), -1)
  else
  if (P.X + S.X <    0) then
    Add(WinW, random(cWinH), 0)
  else
  if (P.Y - S.Y > cWinH) then
    Add(random(WinW),    0, -1)
  else
  if (P.Y + S.Y <    0) then
    Add(random(WinW), cWinH, 0);
end;

procedure Work;
var
  I, Z : Integer;
begin
  if WorkClouds then
  for Z := 1 to 2 do
  for I := 0 to MofClouds[1] do
    Clouds[Z,I].Work;
end;

//***  ***
procedure tClouds.Draw;
begin
  ASprite_Draw(ttClouds, P.X, P.Y, S.X, S.Y, T, round(A), R)
end;

procedure Draw;
var
  I : Integer;
begin
  for I := 0 to MofClouds[1] do
    Clouds[Z, I].Draw;
end;

end.
